package com.vykon.vykonPro.energy;

import javax.baja.sys.BFacets;
import javax.baja.sys.BStruct;
import javax.baja.sys.Flags;
import javax.baja.sys.Property;
import javax.baja.sys.Sys;
import javax.baja.sys.Type;

public class BConsumptionProperties
    extends BStruct
{
  /*-
   class BConsumptionProperties
   {
     properties
     {
       kwhTotal: double
         flags{ operator }
         default{[ 0 ]}
         slotfacets{[ MIN=0 ]}
         
       kwhOffPeakTotal: double
         flags{ operator }
         default{[ 0 ]}
         slotfacets{[ MIN=0 ]}
         
       kwhOnPeakTotal: double
         flags{ operator }
         default{[ 0 ]}
         slotfacets{[ MIN=0 ]}
         
       monthlyKwh: double
         flags{ operator }
         default{[ 0 ]}
         slotfacets{[ MIN=0 ]}
         
       monthlyKwhOffPeak: double
         flags{ operator }
         default{[ 0 ]}
         slotfacets{[ MIN=0 ]}
         
       monthlyKwhOnPeak: double
         flags{ operator }
         default{[ 0 ]}
         slotfacets{[ MIN=0 ]}
         
     }
   }
   -*/
/*+ ------------ BEGIN BAJA AUTO GENERATED CODE ------------ +*/
/*@ $com.vykon.vykonPro.energy.BConsumptionProperties(3558102716)1.0$ @*/
/* Generated Fri Apr 16 09:40:42 EDT 2010 by Slot-o-Matic 2000 (c) Tridium, Inc. 2000 */

////////////////////////////////////////////////////////////////
// Property "kwhTotal"
////////////////////////////////////////////////////////////////
  
  /**
   * Slot for the <code>kwhTotal</code> property.
   * @see com.vykon.vykonPro.energy.BConsumptionProperties#getKwhTotal
   * @see com.vykon.vykonPro.energy.BConsumptionProperties#setKwhTotal
   */
  public static final Property kwhTotal = newProperty(Flags.OPERATOR, 0,BFacets.make(BFacets.MIN,0));
  
  /**
   * Get the <code>kwhTotal</code> property.
   * @see com.vykon.vykonPro.energy.BConsumptionProperties#kwhTotal
   */
  public double getKwhTotal() { return getDouble(kwhTotal); }
  
  /**
   * Set the <code>kwhTotal</code> property.
   * @see com.vykon.vykonPro.energy.BConsumptionProperties#kwhTotal
   */
  public void setKwhTotal(double v) { setDouble(kwhTotal,v,null); }

////////////////////////////////////////////////////////////////
// Property "kwhOffPeakTotal"
////////////////////////////////////////////////////////////////
  
  /**
   * Slot for the <code>kwhOffPeakTotal</code> property.
   * @see com.vykon.vykonPro.energy.BConsumptionProperties#getKwhOffPeakTotal
   * @see com.vykon.vykonPro.energy.BConsumptionProperties#setKwhOffPeakTotal
   */
  public static final Property kwhOffPeakTotal = newProperty(Flags.OPERATOR, 0,BFacets.make(BFacets.MIN,0));
  
  /**
   * Get the <code>kwhOffPeakTotal</code> property.
   * @see com.vykon.vykonPro.energy.BConsumptionProperties#kwhOffPeakTotal
   */
  public double getKwhOffPeakTotal() { return getDouble(kwhOffPeakTotal); }
  
  /**
   * Set the <code>kwhOffPeakTotal</code> property.
   * @see com.vykon.vykonPro.energy.BConsumptionProperties#kwhOffPeakTotal
   */
  public void setKwhOffPeakTotal(double v) { setDouble(kwhOffPeakTotal,v,null); }

////////////////////////////////////////////////////////////////
// Property "kwhOnPeakTotal"
////////////////////////////////////////////////////////////////
  
  /**
   * Slot for the <code>kwhOnPeakTotal</code> property.
   * @see com.vykon.vykonPro.energy.BConsumptionProperties#getKwhOnPeakTotal
   * @see com.vykon.vykonPro.energy.BConsumptionProperties#setKwhOnPeakTotal
   */
  public static final Property kwhOnPeakTotal = newProperty(Flags.OPERATOR, 0,BFacets.make(BFacets.MIN,0));
  
  /**
   * Get the <code>kwhOnPeakTotal</code> property.
   * @see com.vykon.vykonPro.energy.BConsumptionProperties#kwhOnPeakTotal
   */
  public double getKwhOnPeakTotal() { return getDouble(kwhOnPeakTotal); }
  
  /**
   * Set the <code>kwhOnPeakTotal</code> property.
   * @see com.vykon.vykonPro.energy.BConsumptionProperties#kwhOnPeakTotal
   */
  public void setKwhOnPeakTotal(double v) { setDouble(kwhOnPeakTotal,v,null); }

////////////////////////////////////////////////////////////////
// Property "monthlyKwh"
////////////////////////////////////////////////////////////////
  
  /**
   * Slot for the <code>monthlyKwh</code> property.
   * @see com.vykon.vykonPro.energy.BConsumptionProperties#getMonthlyKwh
   * @see com.vykon.vykonPro.energy.BConsumptionProperties#setMonthlyKwh
   */
  public static final Property monthlyKwh = newProperty(Flags.OPERATOR, 0,BFacets.make(BFacets.MIN,0));
  
  /**
   * Get the <code>monthlyKwh</code> property.
   * @see com.vykon.vykonPro.energy.BConsumptionProperties#monthlyKwh
   */
  public double getMonthlyKwh() { return getDouble(monthlyKwh); }
  
  /**
   * Set the <code>monthlyKwh</code> property.
   * @see com.vykon.vykonPro.energy.BConsumptionProperties#monthlyKwh
   */
  public void setMonthlyKwh(double v) { setDouble(monthlyKwh,v,null); }

////////////////////////////////////////////////////////////////
// Property "monthlyKwhOffPeak"
////////////////////////////////////////////////////////////////
  
  /**
   * Slot for the <code>monthlyKwhOffPeak</code> property.
   * @see com.vykon.vykonPro.energy.BConsumptionProperties#getMonthlyKwhOffPeak
   * @see com.vykon.vykonPro.energy.BConsumptionProperties#setMonthlyKwhOffPeak
   */
  public static final Property monthlyKwhOffPeak = newProperty(Flags.OPERATOR, 0,BFacets.make(BFacets.MIN,0));
  
  /**
   * Get the <code>monthlyKwhOffPeak</code> property.
   * @see com.vykon.vykonPro.energy.BConsumptionProperties#monthlyKwhOffPeak
   */
  public double getMonthlyKwhOffPeak() { return getDouble(monthlyKwhOffPeak); }
  
  /**
   * Set the <code>monthlyKwhOffPeak</code> property.
   * @see com.vykon.vykonPro.energy.BConsumptionProperties#monthlyKwhOffPeak
   */
  public void setMonthlyKwhOffPeak(double v) { setDouble(monthlyKwhOffPeak,v,null); }

////////////////////////////////////////////////////////////////
// Property "monthlyKwhOnPeak"
////////////////////////////////////////////////////////////////
  
  /**
   * Slot for the <code>monthlyKwhOnPeak</code> property.
   * @see com.vykon.vykonPro.energy.BConsumptionProperties#getMonthlyKwhOnPeak
   * @see com.vykon.vykonPro.energy.BConsumptionProperties#setMonthlyKwhOnPeak
   */
  public static final Property monthlyKwhOnPeak = newProperty(Flags.OPERATOR, 0,BFacets.make(BFacets.MIN,0));
  
  /**
   * Get the <code>monthlyKwhOnPeak</code> property.
   * @see com.vykon.vykonPro.energy.BConsumptionProperties#monthlyKwhOnPeak
   */
  public double getMonthlyKwhOnPeak() { return getDouble(monthlyKwhOnPeak); }
  
  /**
   * Set the <code>monthlyKwhOnPeak</code> property.
   * @see com.vykon.vykonPro.energy.BConsumptionProperties#monthlyKwhOnPeak
   */
  public void setMonthlyKwhOnPeak(double v) { setDouble(monthlyKwhOnPeak,v,null); }

////////////////////////////////////////////////////////////////
// Type
////////////////////////////////////////////////////////////////
  
  public Type getType() { return TYPE; }
  public static final Type TYPE = Sys.loadType(BConsumptionProperties.class);

/*+ ------------ END BAJA AUTO GENERATED CODE -------------- +*/

  public BConsumptionProperties()
  {
    
  }
  
  public BConsumptionProperties(double kwhTotal, double kwhOffPeakTotal, double kwhOnPeakTotal, double monthlyKwh, double monthlyKwhOffPeak, double monthlyKwhOnPeak)
  {
    setKwhTotal(kwhTotal);
    setKwhOffPeakTotal(kwhOffPeakTotal);
    setKwhOnPeakTotal(kwhOnPeakTotal);
    setMonthlyKwh(monthlyKwh);
    setMonthlyKwhOffPeak(monthlyKwhOffPeak);
    setMonthlyKwhOnPeak(monthlyKwhOnPeak);
  }

}
