package com.vykon.vykonPro.history;

import javax.baja.status.BStatusNumeric;
import javax.baja.sys.Action;
import javax.baja.sys.BAbsTime;
import javax.baja.sys.BComponent;
import javax.baja.sys.BDynamicEnum;
import javax.baja.sys.BEnum;
import javax.baja.sys.BEnumRange;
import javax.baja.sys.BFacets;
import javax.baja.sys.BIcon;
import javax.baja.sys.BMonth;
import javax.baja.sys.BRelTime;
import javax.baja.sys.Clock;
import javax.baja.sys.Context;
import javax.baja.sys.Flags;
import javax.baja.sys.Property;
import javax.baja.sys.Slot;
import javax.baja.sys.Sys;
import javax.baja.sys.Type;

import com.vykon.vykonPro.enums.BDateModeEnum;

public class BMinTracker
    extends BComponent
{
  /*-
   class BMinTracker
   {
     properties
     {
       enabled: boolean
         -- Property which controls whether the component functions.
         default {[ true ]}
         slotfacets{[BFacets.makeBoolean("enabled", "disabled")]}
         
       facets: BFacets
        -- These facets are applied against the out property.
        default {[ BFacets.makeNumeric() ]}
      
       dateMode: BEnum
         -- The mode determines how the minimum value is tracked.
         flags{ operator }
         default{[ ( BDynamicEnum.make(0, BEnumRange.make(BDateModeEnum.TYPE))) ]}
         
       billingCycleStartDay: int
         -- The day of the month which the billing cycle starts.
         flags{ operator }
         default{[ 1 ]}
         slotfacets{[ BFacets.makeInt(null, 1, 28) ]}
         
       in: BStatusNumeric
       flags {summary, transient}
       default {[ new BStatusNumeric() ]}
       
       lastReset: BAbsTime
       flags { summary, readonly }
       default {[ BAbsTime.NULL ]}
       
       januaryMin: BStatusNumeric
       flags {summary, readonly }
       default {[ new BStatusNumeric() ]}
       
       januaryTimestamp: BAbsTime
       flags { readonly }
       default {[ BAbsTime.NULL ]}
       
       februaryMin: BStatusNumeric
       flags {summary, readonly }
       default {[ new BStatusNumeric() ]}
       
       februaryTimestamp: BAbsTime
       flags { readonly }
       default {[ BAbsTime.NULL ]}
       
       marchMin: BStatusNumeric
       flags {summary, readonly }
       default {[ new BStatusNumeric() ]}
       
       marchTimestamp: BAbsTime
       flags { readonly }
       default {[ BAbsTime.NULL ]}
       
       aprilMin: BStatusNumeric
       flags {summary, readonly }
       default {[ new BStatusNumeric() ]}
       
       aprilTimestamp: BAbsTime
       flags { readonly }
       default {[ BAbsTime.NULL ]}
       
       mayMin: BStatusNumeric
       flags {summary, readonly }
       default {[ new BStatusNumeric() ]}
       
       mayTimestamp: BAbsTime
       flags { readonly }
       default {[ BAbsTime.NULL ]}
       
       juneMin: BStatusNumeric
       flags {summary, readonly }
       default {[ new BStatusNumeric() ]}
       
       juneTimestamp: BAbsTime
       flags { readonly }
       default {[ BAbsTime.NULL ]}
       
       julyMin: BStatusNumeric
       flags {summary, readonly }
       default {[ new BStatusNumeric() ]}
       
       julyTimestamp: BAbsTime
       flags { readonly }
       default {[ BAbsTime.NULL ]}
       
       augustMin: BStatusNumeric
       flags {summary, readonly }
       default {[ new BStatusNumeric() ]}
       
       augustTimestamp: BAbsTime
       flags { readonly }
       default {[ BAbsTime.NULL ]}
       
       septemberMin: BStatusNumeric
       flags {summary, readonly }
       default {[ new BStatusNumeric() ]}
       
       septemberTimestamp: BAbsTime
       flags { readonly }
       default {[ BAbsTime.NULL ]}
       
       octoberMin: BStatusNumeric
       flags {summary, readonly }
       default {[ new BStatusNumeric() ]}
       
       octoberTimestamp: BAbsTime
       flags { readonly }
       default {[ BAbsTime.NULL ]}
       
       novemberMin: BStatusNumeric
       flags {summary, readonly }
       default {[ new BStatusNumeric() ]}
       
       novemberTimestamp: BAbsTime
       flags { readonly }
       default {[ BAbsTime.NULL ]}
       
       decemberMin: BStatusNumeric
       flags {summary, readonly }
       default {[ new BStatusNumeric() ]}
       
       decemberTimestamp: BAbsTime
       flags { readonly }
       default {[ BAbsTime.NULL ]}
     }
     actions
     {
       calculate()
         flags{hidden}
       
       ticketExpired()
         flags{hidden}
         
       resetMins()
     }
     topics
     {
     }
   }
   -*/
/*+ ------------ BEGIN BAJA AUTO GENERATED CODE ------------ +*/
/*@ $com.vykon.vykonPro.history.BMinTracker(3883802546)1.0$ @*/
/* Generated Fri Dec 14 09:01:15 EST 2012 by Slot-o-Matic 2000 (c) Tridium, Inc. 2000 */

////////////////////////////////////////////////////////////////
// Property "enabled"
////////////////////////////////////////////////////////////////
  
  /**
   * Slot for the <code>enabled</code> property.
   * Property which controls whether the component functions.
   * @see com.vykon.vykonPro.history.BMinTracker#getEnabled
   * @see com.vykon.vykonPro.history.BMinTracker#setEnabled
   */
  public static final Property enabled = newProperty(0, true,BFacets.makeBoolean("enabled", "disabled"));
  
  /**
   * Get the <code>enabled</code> property.
   * @see com.vykon.vykonPro.history.BMinTracker#enabled
   */
  public boolean getEnabled() { return getBoolean(enabled); }
  
  /**
   * Set the <code>enabled</code> property.
   * @see com.vykon.vykonPro.history.BMinTracker#enabled
   */
  public void setEnabled(boolean v) { setBoolean(enabled,v,null); }

////////////////////////////////////////////////////////////////
// Property "facets"
////////////////////////////////////////////////////////////////
  
  /**
   * Slot for the <code>facets</code> property.
   * These facets are applied against the out property.
   * @see com.vykon.vykonPro.history.BMinTracker#getFacets
   * @see com.vykon.vykonPro.history.BMinTracker#setFacets
   */
  public static final Property facets = newProperty(0, BFacets.makeNumeric(),null);
  
  /**
   * Get the <code>facets</code> property.
   * @see com.vykon.vykonPro.history.BMinTracker#facets
   */
  public BFacets getFacets() { return (BFacets)get(facets); }
  
  /**
   * Set the <code>facets</code> property.
   * @see com.vykon.vykonPro.history.BMinTracker#facets
   */
  public void setFacets(BFacets v) { set(facets,v,null); }

////////////////////////////////////////////////////////////////
// Property "dateMode"
////////////////////////////////////////////////////////////////
  
  /**
   * Slot for the <code>dateMode</code> property.
   * The mode determines how the minimum value is tracked.
   * @see com.vykon.vykonPro.history.BMinTracker#getDateMode
   * @see com.vykon.vykonPro.history.BMinTracker#setDateMode
   */
  public static final Property dateMode = newProperty(Flags.OPERATOR, ( BDynamicEnum.make(0, BEnumRange.make(BDateModeEnum.TYPE))),null);
  
  /**
   * Get the <code>dateMode</code> property.
   * @see com.vykon.vykonPro.history.BMinTracker#dateMode
   */
  public BEnum getDateMode() { return (BEnum)get(dateMode); }
  
  /**
   * Set the <code>dateMode</code> property.
   * @see com.vykon.vykonPro.history.BMinTracker#dateMode
   */
  public void setDateMode(BEnum v) { set(dateMode,v,null); }

////////////////////////////////////////////////////////////////
// Property "billingCycleStartDay"
////////////////////////////////////////////////////////////////
  
  /**
   * Slot for the <code>billingCycleStartDay</code> property.
   * The day of the month which the billing cycle starts.
   * @see com.vykon.vykonPro.history.BMinTracker#getBillingCycleStartDay
   * @see com.vykon.vykonPro.history.BMinTracker#setBillingCycleStartDay
   */
  public static final Property billingCycleStartDay = newProperty(Flags.OPERATOR, 1,BFacets.makeInt(null, 1, 28));
  
  /**
   * Get the <code>billingCycleStartDay</code> property.
   * @see com.vykon.vykonPro.history.BMinTracker#billingCycleStartDay
   */
  public int getBillingCycleStartDay() { return getInt(billingCycleStartDay); }
  
  /**
   * Set the <code>billingCycleStartDay</code> property.
   * @see com.vykon.vykonPro.history.BMinTracker#billingCycleStartDay
   */
  public void setBillingCycleStartDay(int v) { setInt(billingCycleStartDay,v,null); }

////////////////////////////////////////////////////////////////
// Property "in"
////////////////////////////////////////////////////////////////
  
  /**
   * Slot for the <code>in</code> property.
   * @see com.vykon.vykonPro.history.BMinTracker#getIn
   * @see com.vykon.vykonPro.history.BMinTracker#setIn
   */
  public static final Property in = newProperty(Flags.SUMMARY|Flags.TRANSIENT, new BStatusNumeric(),null);
  
  /**
   * Get the <code>in</code> property.
   * @see com.vykon.vykonPro.history.BMinTracker#in
   */
  public BStatusNumeric getIn() { return (BStatusNumeric)get(in); }
  
  /**
   * Set the <code>in</code> property.
   * @see com.vykon.vykonPro.history.BMinTracker#in
   */
  public void setIn(BStatusNumeric v) { set(in,v,null); }

////////////////////////////////////////////////////////////////
// Property "lastReset"
////////////////////////////////////////////////////////////////
  
  /**
   * Slot for the <code>lastReset</code> property.
   * @see com.vykon.vykonPro.history.BMinTracker#getLastReset
   * @see com.vykon.vykonPro.history.BMinTracker#setLastReset
   */
  public static final Property lastReset = newProperty(Flags.SUMMARY|Flags.READONLY, BAbsTime.NULL,null);
  
  /**
   * Get the <code>lastReset</code> property.
   * @see com.vykon.vykonPro.history.BMinTracker#lastReset
   */
  public BAbsTime getLastReset() { return (BAbsTime)get(lastReset); }
  
  /**
   * Set the <code>lastReset</code> property.
   * @see com.vykon.vykonPro.history.BMinTracker#lastReset
   */
  public void setLastReset(BAbsTime v) { set(lastReset,v,null); }

////////////////////////////////////////////////////////////////
// Property "januaryMin"
////////////////////////////////////////////////////////////////
  
  /**
   * Slot for the <code>januaryMin</code> property.
   * @see com.vykon.vykonPro.history.BMinTracker#getJanuaryMin
   * @see com.vykon.vykonPro.history.BMinTracker#setJanuaryMin
   */
  public static final Property januaryMin = newProperty(Flags.SUMMARY|Flags.READONLY, new BStatusNumeric(),null);
  
  /**
   * Get the <code>januaryMin</code> property.
   * @see com.vykon.vykonPro.history.BMinTracker#januaryMin
   */
  public BStatusNumeric getJanuaryMin() { return (BStatusNumeric)get(januaryMin); }
  
  /**
   * Set the <code>januaryMin</code> property.
   * @see com.vykon.vykonPro.history.BMinTracker#januaryMin
   */
  public void setJanuaryMin(BStatusNumeric v) { set(januaryMin,v,null); }

////////////////////////////////////////////////////////////////
// Property "januaryTimestamp"
////////////////////////////////////////////////////////////////
  
  /**
   * Slot for the <code>januaryTimestamp</code> property.
   * @see com.vykon.vykonPro.history.BMinTracker#getJanuaryTimestamp
   * @see com.vykon.vykonPro.history.BMinTracker#setJanuaryTimestamp
   */
  public static final Property januaryTimestamp = newProperty(Flags.READONLY, BAbsTime.NULL,null);
  
  /**
   * Get the <code>januaryTimestamp</code> property.
   * @see com.vykon.vykonPro.history.BMinTracker#januaryTimestamp
   */
  public BAbsTime getJanuaryTimestamp() { return (BAbsTime)get(januaryTimestamp); }
  
  /**
   * Set the <code>januaryTimestamp</code> property.
   * @see com.vykon.vykonPro.history.BMinTracker#januaryTimestamp
   */
  public void setJanuaryTimestamp(BAbsTime v) { set(januaryTimestamp,v,null); }

////////////////////////////////////////////////////////////////
// Property "februaryMin"
////////////////////////////////////////////////////////////////
  
  /**
   * Slot for the <code>februaryMin</code> property.
   * @see com.vykon.vykonPro.history.BMinTracker#getFebruaryMin
   * @see com.vykon.vykonPro.history.BMinTracker#setFebruaryMin
   */
  public static final Property februaryMin = newProperty(Flags.SUMMARY|Flags.READONLY, new BStatusNumeric(),null);
  
  /**
   * Get the <code>februaryMin</code> property.
   * @see com.vykon.vykonPro.history.BMinTracker#februaryMin
   */
  public BStatusNumeric getFebruaryMin() { return (BStatusNumeric)get(februaryMin); }
  
  /**
   * Set the <code>februaryMin</code> property.
   * @see com.vykon.vykonPro.history.BMinTracker#februaryMin
   */
  public void setFebruaryMin(BStatusNumeric v) { set(februaryMin,v,null); }

////////////////////////////////////////////////////////////////
// Property "februaryTimestamp"
////////////////////////////////////////////////////////////////
  
  /**
   * Slot for the <code>februaryTimestamp</code> property.
   * @see com.vykon.vykonPro.history.BMinTracker#getFebruaryTimestamp
   * @see com.vykon.vykonPro.history.BMinTracker#setFebruaryTimestamp
   */
  public static final Property februaryTimestamp = newProperty(Flags.READONLY, BAbsTime.NULL,null);
  
  /**
   * Get the <code>februaryTimestamp</code> property.
   * @see com.vykon.vykonPro.history.BMinTracker#februaryTimestamp
   */
  public BAbsTime getFebruaryTimestamp() { return (BAbsTime)get(februaryTimestamp); }
  
  /**
   * Set the <code>februaryTimestamp</code> property.
   * @see com.vykon.vykonPro.history.BMinTracker#februaryTimestamp
   */
  public void setFebruaryTimestamp(BAbsTime v) { set(februaryTimestamp,v,null); }

////////////////////////////////////////////////////////////////
// Property "marchMin"
////////////////////////////////////////////////////////////////
  
  /**
   * Slot for the <code>marchMin</code> property.
   * @see com.vykon.vykonPro.history.BMinTracker#getMarchMin
   * @see com.vykon.vykonPro.history.BMinTracker#setMarchMin
   */
  public static final Property marchMin = newProperty(Flags.SUMMARY|Flags.READONLY, new BStatusNumeric(),null);
  
  /**
   * Get the <code>marchMin</code> property.
   * @see com.vykon.vykonPro.history.BMinTracker#marchMin
   */
  public BStatusNumeric getMarchMin() { return (BStatusNumeric)get(marchMin); }
  
  /**
   * Set the <code>marchMin</code> property.
   * @see com.vykon.vykonPro.history.BMinTracker#marchMin
   */
  public void setMarchMin(BStatusNumeric v) { set(marchMin,v,null); }

////////////////////////////////////////////////////////////////
// Property "marchTimestamp"
////////////////////////////////////////////////////////////////
  
  /**
   * Slot for the <code>marchTimestamp</code> property.
   * @see com.vykon.vykonPro.history.BMinTracker#getMarchTimestamp
   * @see com.vykon.vykonPro.history.BMinTracker#setMarchTimestamp
   */
  public static final Property marchTimestamp = newProperty(Flags.READONLY, BAbsTime.NULL,null);
  
  /**
   * Get the <code>marchTimestamp</code> property.
   * @see com.vykon.vykonPro.history.BMinTracker#marchTimestamp
   */
  public BAbsTime getMarchTimestamp() { return (BAbsTime)get(marchTimestamp); }
  
  /**
   * Set the <code>marchTimestamp</code> property.
   * @see com.vykon.vykonPro.history.BMinTracker#marchTimestamp
   */
  public void setMarchTimestamp(BAbsTime v) { set(marchTimestamp,v,null); }

////////////////////////////////////////////////////////////////
// Property "aprilMin"
////////////////////////////////////////////////////////////////
  
  /**
   * Slot for the <code>aprilMin</code> property.
   * @see com.vykon.vykonPro.history.BMinTracker#getAprilMin
   * @see com.vykon.vykonPro.history.BMinTracker#setAprilMin
   */
  public static final Property aprilMin = newProperty(Flags.SUMMARY|Flags.READONLY, new BStatusNumeric(),null);
  
  /**
   * Get the <code>aprilMin</code> property.
   * @see com.vykon.vykonPro.history.BMinTracker#aprilMin
   */
  public BStatusNumeric getAprilMin() { return (BStatusNumeric)get(aprilMin); }
  
  /**
   * Set the <code>aprilMin</code> property.
   * @see com.vykon.vykonPro.history.BMinTracker#aprilMin
   */
  public void setAprilMin(BStatusNumeric v) { set(aprilMin,v,null); }

////////////////////////////////////////////////////////////////
// Property "aprilTimestamp"
////////////////////////////////////////////////////////////////
  
  /**
   * Slot for the <code>aprilTimestamp</code> property.
   * @see com.vykon.vykonPro.history.BMinTracker#getAprilTimestamp
   * @see com.vykon.vykonPro.history.BMinTracker#setAprilTimestamp
   */
  public static final Property aprilTimestamp = newProperty(Flags.READONLY, BAbsTime.NULL,null);
  
  /**
   * Get the <code>aprilTimestamp</code> property.
   * @see com.vykon.vykonPro.history.BMinTracker#aprilTimestamp
   */
  public BAbsTime getAprilTimestamp() { return (BAbsTime)get(aprilTimestamp); }
  
  /**
   * Set the <code>aprilTimestamp</code> property.
   * @see com.vykon.vykonPro.history.BMinTracker#aprilTimestamp
   */
  public void setAprilTimestamp(BAbsTime v) { set(aprilTimestamp,v,null); }

////////////////////////////////////////////////////////////////
// Property "mayMin"
////////////////////////////////////////////////////////////////
  
  /**
   * Slot for the <code>mayMin</code> property.
   * @see com.vykon.vykonPro.history.BMinTracker#getMayMin
   * @see com.vykon.vykonPro.history.BMinTracker#setMayMin
   */
  public static final Property mayMin = newProperty(Flags.SUMMARY|Flags.READONLY, new BStatusNumeric(),null);
  
  /**
   * Get the <code>mayMin</code> property.
   * @see com.vykon.vykonPro.history.BMinTracker#mayMin
   */
  public BStatusNumeric getMayMin() { return (BStatusNumeric)get(mayMin); }
  
  /**
   * Set the <code>mayMin</code> property.
   * @see com.vykon.vykonPro.history.BMinTracker#mayMin
   */
  public void setMayMin(BStatusNumeric v) { set(mayMin,v,null); }

////////////////////////////////////////////////////////////////
// Property "mayTimestamp"
////////////////////////////////////////////////////////////////
  
  /**
   * Slot for the <code>mayTimestamp</code> property.
   * @see com.vykon.vykonPro.history.BMinTracker#getMayTimestamp
   * @see com.vykon.vykonPro.history.BMinTracker#setMayTimestamp
   */
  public static final Property mayTimestamp = newProperty(Flags.READONLY, BAbsTime.NULL,null);
  
  /**
   * Get the <code>mayTimestamp</code> property.
   * @see com.vykon.vykonPro.history.BMinTracker#mayTimestamp
   */
  public BAbsTime getMayTimestamp() { return (BAbsTime)get(mayTimestamp); }
  
  /**
   * Set the <code>mayTimestamp</code> property.
   * @see com.vykon.vykonPro.history.BMinTracker#mayTimestamp
   */
  public void setMayTimestamp(BAbsTime v) { set(mayTimestamp,v,null); }

////////////////////////////////////////////////////////////////
// Property "juneMin"
////////////////////////////////////////////////////////////////
  
  /**
   * Slot for the <code>juneMin</code> property.
   * @see com.vykon.vykonPro.history.BMinTracker#getJuneMin
   * @see com.vykon.vykonPro.history.BMinTracker#setJuneMin
   */
  public static final Property juneMin = newProperty(Flags.SUMMARY|Flags.READONLY, new BStatusNumeric(),null);
  
  /**
   * Get the <code>juneMin</code> property.
   * @see com.vykon.vykonPro.history.BMinTracker#juneMin
   */
  public BStatusNumeric getJuneMin() { return (BStatusNumeric)get(juneMin); }
  
  /**
   * Set the <code>juneMin</code> property.
   * @see com.vykon.vykonPro.history.BMinTracker#juneMin
   */
  public void setJuneMin(BStatusNumeric v) { set(juneMin,v,null); }

////////////////////////////////////////////////////////////////
// Property "juneTimestamp"
////////////////////////////////////////////////////////////////
  
  /**
   * Slot for the <code>juneTimestamp</code> property.
   * @see com.vykon.vykonPro.history.BMinTracker#getJuneTimestamp
   * @see com.vykon.vykonPro.history.BMinTracker#setJuneTimestamp
   */
  public static final Property juneTimestamp = newProperty(Flags.READONLY, BAbsTime.NULL,null);
  
  /**
   * Get the <code>juneTimestamp</code> property.
   * @see com.vykon.vykonPro.history.BMinTracker#juneTimestamp
   */
  public BAbsTime getJuneTimestamp() { return (BAbsTime)get(juneTimestamp); }
  
  /**
   * Set the <code>juneTimestamp</code> property.
   * @see com.vykon.vykonPro.history.BMinTracker#juneTimestamp
   */
  public void setJuneTimestamp(BAbsTime v) { set(juneTimestamp,v,null); }

////////////////////////////////////////////////////////////////
// Property "julyMin"
////////////////////////////////////////////////////////////////
  
  /**
   * Slot for the <code>julyMin</code> property.
   * @see com.vykon.vykonPro.history.BMinTracker#getJulyMin
   * @see com.vykon.vykonPro.history.BMinTracker#setJulyMin
   */
  public static final Property julyMin = newProperty(Flags.SUMMARY|Flags.READONLY, new BStatusNumeric(),null);
  
  /**
   * Get the <code>julyMin</code> property.
   * @see com.vykon.vykonPro.history.BMinTracker#julyMin
   */
  public BStatusNumeric getJulyMin() { return (BStatusNumeric)get(julyMin); }
  
  /**
   * Set the <code>julyMin</code> property.
   * @see com.vykon.vykonPro.history.BMinTracker#julyMin
   */
  public void setJulyMin(BStatusNumeric v) { set(julyMin,v,null); }

////////////////////////////////////////////////////////////////
// Property "julyTimestamp"
////////////////////////////////////////////////////////////////
  
  /**
   * Slot for the <code>julyTimestamp</code> property.
   * @see com.vykon.vykonPro.history.BMinTracker#getJulyTimestamp
   * @see com.vykon.vykonPro.history.BMinTracker#setJulyTimestamp
   */
  public static final Property julyTimestamp = newProperty(Flags.READONLY, BAbsTime.NULL,null);
  
  /**
   * Get the <code>julyTimestamp</code> property.
   * @see com.vykon.vykonPro.history.BMinTracker#julyTimestamp
   */
  public BAbsTime getJulyTimestamp() { return (BAbsTime)get(julyTimestamp); }
  
  /**
   * Set the <code>julyTimestamp</code> property.
   * @see com.vykon.vykonPro.history.BMinTracker#julyTimestamp
   */
  public void setJulyTimestamp(BAbsTime v) { set(julyTimestamp,v,null); }

////////////////////////////////////////////////////////////////
// Property "augustMin"
////////////////////////////////////////////////////////////////
  
  /**
   * Slot for the <code>augustMin</code> property.
   * @see com.vykon.vykonPro.history.BMinTracker#getAugustMin
   * @see com.vykon.vykonPro.history.BMinTracker#setAugustMin
   */
  public static final Property augustMin = newProperty(Flags.SUMMARY|Flags.READONLY, new BStatusNumeric(),null);
  
  /**
   * Get the <code>augustMin</code> property.
   * @see com.vykon.vykonPro.history.BMinTracker#augustMin
   */
  public BStatusNumeric getAugustMin() { return (BStatusNumeric)get(augustMin); }
  
  /**
   * Set the <code>augustMin</code> property.
   * @see com.vykon.vykonPro.history.BMinTracker#augustMin
   */
  public void setAugustMin(BStatusNumeric v) { set(augustMin,v,null); }

////////////////////////////////////////////////////////////////
// Property "augustTimestamp"
////////////////////////////////////////////////////////////////
  
  /**
   * Slot for the <code>augustTimestamp</code> property.
   * @see com.vykon.vykonPro.history.BMinTracker#getAugustTimestamp
   * @see com.vykon.vykonPro.history.BMinTracker#setAugustTimestamp
   */
  public static final Property augustTimestamp = newProperty(Flags.READONLY, BAbsTime.NULL,null);
  
  /**
   * Get the <code>augustTimestamp</code> property.
   * @see com.vykon.vykonPro.history.BMinTracker#augustTimestamp
   */
  public BAbsTime getAugustTimestamp() { return (BAbsTime)get(augustTimestamp); }
  
  /**
   * Set the <code>augustTimestamp</code> property.
   * @see com.vykon.vykonPro.history.BMinTracker#augustTimestamp
   */
  public void setAugustTimestamp(BAbsTime v) { set(augustTimestamp,v,null); }

////////////////////////////////////////////////////////////////
// Property "septemberMin"
////////////////////////////////////////////////////////////////
  
  /**
   * Slot for the <code>septemberMin</code> property.
   * @see com.vykon.vykonPro.history.BMinTracker#getSeptemberMin
   * @see com.vykon.vykonPro.history.BMinTracker#setSeptemberMin
   */
  public static final Property septemberMin = newProperty(Flags.SUMMARY|Flags.READONLY, new BStatusNumeric(),null);
  
  /**
   * Get the <code>septemberMin</code> property.
   * @see com.vykon.vykonPro.history.BMinTracker#septemberMin
   */
  public BStatusNumeric getSeptemberMin() { return (BStatusNumeric)get(septemberMin); }
  
  /**
   * Set the <code>septemberMin</code> property.
   * @see com.vykon.vykonPro.history.BMinTracker#septemberMin
   */
  public void setSeptemberMin(BStatusNumeric v) { set(septemberMin,v,null); }

////////////////////////////////////////////////////////////////
// Property "septemberTimestamp"
////////////////////////////////////////////////////////////////
  
  /**
   * Slot for the <code>septemberTimestamp</code> property.
   * @see com.vykon.vykonPro.history.BMinTracker#getSeptemberTimestamp
   * @see com.vykon.vykonPro.history.BMinTracker#setSeptemberTimestamp
   */
  public static final Property septemberTimestamp = newProperty(Flags.READONLY, BAbsTime.NULL,null);
  
  /**
   * Get the <code>septemberTimestamp</code> property.
   * @see com.vykon.vykonPro.history.BMinTracker#septemberTimestamp
   */
  public BAbsTime getSeptemberTimestamp() { return (BAbsTime)get(septemberTimestamp); }
  
  /**
   * Set the <code>septemberTimestamp</code> property.
   * @see com.vykon.vykonPro.history.BMinTracker#septemberTimestamp
   */
  public void setSeptemberTimestamp(BAbsTime v) { set(septemberTimestamp,v,null); }

////////////////////////////////////////////////////////////////
// Property "octoberMin"
////////////////////////////////////////////////////////////////
  
  /**
   * Slot for the <code>octoberMin</code> property.
   * @see com.vykon.vykonPro.history.BMinTracker#getOctoberMin
   * @see com.vykon.vykonPro.history.BMinTracker#setOctoberMin
   */
  public static final Property octoberMin = newProperty(Flags.SUMMARY|Flags.READONLY, new BStatusNumeric(),null);
  
  /**
   * Get the <code>octoberMin</code> property.
   * @see com.vykon.vykonPro.history.BMinTracker#octoberMin
   */
  public BStatusNumeric getOctoberMin() { return (BStatusNumeric)get(octoberMin); }
  
  /**
   * Set the <code>octoberMin</code> property.
   * @see com.vykon.vykonPro.history.BMinTracker#octoberMin
   */
  public void setOctoberMin(BStatusNumeric v) { set(octoberMin,v,null); }

////////////////////////////////////////////////////////////////
// Property "octoberTimestamp"
////////////////////////////////////////////////////////////////
  
  /**
   * Slot for the <code>octoberTimestamp</code> property.
   * @see com.vykon.vykonPro.history.BMinTracker#getOctoberTimestamp
   * @see com.vykon.vykonPro.history.BMinTracker#setOctoberTimestamp
   */
  public static final Property octoberTimestamp = newProperty(Flags.READONLY, BAbsTime.NULL,null);
  
  /**
   * Get the <code>octoberTimestamp</code> property.
   * @see com.vykon.vykonPro.history.BMinTracker#octoberTimestamp
   */
  public BAbsTime getOctoberTimestamp() { return (BAbsTime)get(octoberTimestamp); }
  
  /**
   * Set the <code>octoberTimestamp</code> property.
   * @see com.vykon.vykonPro.history.BMinTracker#octoberTimestamp
   */
  public void setOctoberTimestamp(BAbsTime v) { set(octoberTimestamp,v,null); }

////////////////////////////////////////////////////////////////
// Property "novemberMin"
////////////////////////////////////////////////////////////////
  
  /**
   * Slot for the <code>novemberMin</code> property.
   * @see com.vykon.vykonPro.history.BMinTracker#getNovemberMin
   * @see com.vykon.vykonPro.history.BMinTracker#setNovemberMin
   */
  public static final Property novemberMin = newProperty(Flags.SUMMARY|Flags.READONLY, new BStatusNumeric(),null);
  
  /**
   * Get the <code>novemberMin</code> property.
   * @see com.vykon.vykonPro.history.BMinTracker#novemberMin
   */
  public BStatusNumeric getNovemberMin() { return (BStatusNumeric)get(novemberMin); }
  
  /**
   * Set the <code>novemberMin</code> property.
   * @see com.vykon.vykonPro.history.BMinTracker#novemberMin
   */
  public void setNovemberMin(BStatusNumeric v) { set(novemberMin,v,null); }

////////////////////////////////////////////////////////////////
// Property "novemberTimestamp"
////////////////////////////////////////////////////////////////
  
  /**
   * Slot for the <code>novemberTimestamp</code> property.
   * @see com.vykon.vykonPro.history.BMinTracker#getNovemberTimestamp
   * @see com.vykon.vykonPro.history.BMinTracker#setNovemberTimestamp
   */
  public static final Property novemberTimestamp = newProperty(Flags.READONLY, BAbsTime.NULL,null);
  
  /**
   * Get the <code>novemberTimestamp</code> property.
   * @see com.vykon.vykonPro.history.BMinTracker#novemberTimestamp
   */
  public BAbsTime getNovemberTimestamp() { return (BAbsTime)get(novemberTimestamp); }
  
  /**
   * Set the <code>novemberTimestamp</code> property.
   * @see com.vykon.vykonPro.history.BMinTracker#novemberTimestamp
   */
  public void setNovemberTimestamp(BAbsTime v) { set(novemberTimestamp,v,null); }

////////////////////////////////////////////////////////////////
// Property "decemberMin"
////////////////////////////////////////////////////////////////
  
  /**
   * Slot for the <code>decemberMin</code> property.
   * @see com.vykon.vykonPro.history.BMinTracker#getDecemberMin
   * @see com.vykon.vykonPro.history.BMinTracker#setDecemberMin
   */
  public static final Property decemberMin = newProperty(Flags.SUMMARY|Flags.READONLY, new BStatusNumeric(),null);
  
  /**
   * Get the <code>decemberMin</code> property.
   * @see com.vykon.vykonPro.history.BMinTracker#decemberMin
   */
  public BStatusNumeric getDecemberMin() { return (BStatusNumeric)get(decemberMin); }
  
  /**
   * Set the <code>decemberMin</code> property.
   * @see com.vykon.vykonPro.history.BMinTracker#decemberMin
   */
  public void setDecemberMin(BStatusNumeric v) { set(decemberMin,v,null); }

////////////////////////////////////////////////////////////////
// Property "decemberTimestamp"
////////////////////////////////////////////////////////////////
  
  /**
   * Slot for the <code>decemberTimestamp</code> property.
   * @see com.vykon.vykonPro.history.BMinTracker#getDecemberTimestamp
   * @see com.vykon.vykonPro.history.BMinTracker#setDecemberTimestamp
   */
  public static final Property decemberTimestamp = newProperty(Flags.READONLY, BAbsTime.NULL,null);
  
  /**
   * Get the <code>decemberTimestamp</code> property.
   * @see com.vykon.vykonPro.history.BMinTracker#decemberTimestamp
   */
  public BAbsTime getDecemberTimestamp() { return (BAbsTime)get(decemberTimestamp); }
  
  /**
   * Set the <code>decemberTimestamp</code> property.
   * @see com.vykon.vykonPro.history.BMinTracker#decemberTimestamp
   */
  public void setDecemberTimestamp(BAbsTime v) { set(decemberTimestamp,v,null); }

////////////////////////////////////////////////////////////////
// Action "calculate"
////////////////////////////////////////////////////////////////
  
  /**
   * Slot for the <code>calculate</code> action.
   * @see com.vykon.vykonPro.history.BMinTracker#calculate()
   */
  public static final Action calculate = newAction(Flags.HIDDEN,null);
  
  /**
   * Invoke the <code>calculate</code> action.
   * @see com.vykon.vykonPro.history.BMinTracker#calculate
   */
  public void calculate() { invoke(calculate,null,null); }

////////////////////////////////////////////////////////////////
// Action "ticketExpired"
////////////////////////////////////////////////////////////////
  
  /**
   * Slot for the <code>ticketExpired</code> action.
   * @see com.vykon.vykonPro.history.BMinTracker#ticketExpired()
   */
  public static final Action ticketExpired = newAction(Flags.HIDDEN,null);
  
  /**
   * Invoke the <code>ticketExpired</code> action.
   * @see com.vykon.vykonPro.history.BMinTracker#ticketExpired
   */
  public void ticketExpired() { invoke(ticketExpired,null,null); }

////////////////////////////////////////////////////////////////
// Action "resetMins"
////////////////////////////////////////////////////////////////
  
  /**
   * Slot for the <code>resetMins</code> action.
   * @see com.vykon.vykonPro.history.BMinTracker#resetMins()
   */
  public static final Action resetMins = newAction(0,null);
  
  /**
   * Invoke the <code>resetMins</code> action.
   * @see com.vykon.vykonPro.history.BMinTracker#resetMins
   */
  public void resetMins() { invoke(resetMins,null,null); }

////////////////////////////////////////////////////////////////
// Type
////////////////////////////////////////////////////////////////
  
  public Type getType() { return TYPE; }
  public static final Type TYPE = Sys.loadType(BMinTracker.class);

/*+ ------------ END BAJA AUTO GENERATED CODE -------------- +*/

  public void started()
  {
    if(!getEnabled()) return;
    calculate();
    initClockTicket();
    
  }
  
  public void stopped() throws Exception
  {
    if (ticket != null)
      ticket.cancel();
  }
  
  public void atSteadyState()
  {
    calculate();
  }
  
  public BFacets getSlotFacets(Slot slot)
  {
    if(slot.equals(in) || slot.getName().endsWith("Min"))
      return getFacets();
    
    return super.getSlotFacets(slot);
  }

  
  public void clockChanged(BRelTime value)
  {
    if(getEnabled()) initClockTicket();
  }

  
  private void initClockTicket()
  {
    if (ticket != null) ticket.cancel();
    
    //need to calculate the BAbsTime for the start of next month to call
    //the component in case no change in value, but there has been a change
    //in the current month.
    now = Clock.time();
    BMonth currentMonth = now.getMonth();
    int currentYear = now.getYear();
    int currentDay = now.getDay();
    
    BAbsTime firstOfMonth = null;
    BAbsTime nextMonth = null;
    
    if(getDateMode().getOrdinal()==BDateModeEnum.FIRST_OF_MONTH)
    {
      firstOfMonth = BAbsTime.make(currentYear, currentMonth, 1, 0, 0, 15, 0);
      nextMonth = firstOfMonth.nextMonth();
    }
    else
    {
      //using billing cycle
      if(currentDay < getBillingCycleStartDay())
      {
        nextMonth = BAbsTime.make(currentYear, currentMonth, getBillingCycleStartDay(), 0, 0, 15, 0);
      }
      else
      {
        firstOfMonth = BAbsTime.make(currentYear, currentMonth, getBillingCycleStartDay(), 0, 0, 15, 0);
        nextMonth = firstOfMonth.nextMonth();
      }
    }
    
    //schedule object to execute next month
    ticket = Clock.schedule(this, nextMonth, ticketExpired, null);
  }
  
  
  public void doTicketExpired()
  {
    doCalculate();
    initClockTicket();
  }
  
  
  public void changed(Property prop, Context context)
  {
    super.changed(prop, context);
    if (!Sys.atSteadyState() || !isRunning())
      return;

    if(prop.equals(in) && getEnabled())
    {
      //check if new peak is set
      if(getIn().getStatus().isValid())
      {
        calculate();
      }
    }
    else if(prop.equals(enabled))
    {
      if(getEnabled())
      {
        //transitioned from disabled to enabled
        initClockTicket();
        
        //check current value
        doCalculate();
        
      }
      else
      {
        //transitioned from enabled to disabled so clean up
        if (ticket != null)
          ticket.cancel();
      }
    }
    else if(prop.equals(dateMode))
    {
      initClockTicket();
    }
    else if(prop.equals(billingCycleStartDay))
    {
      if(getDateMode().getOrdinal()==BDateModeEnum.BILLING_CYCLE)
        initClockTicket();
    }
  }
  
  public void doCalculate()
  {
    //check current value
    now = Clock.time();
    int month = now.getMonth().getMonthOfYear();
    int year = now.getYear();
    int day = now.getDay();
    double inValue = getIn().getValue();
    
    if(getDateMode().getOrdinal()==BDateModeEnum.FIRST_OF_MONTH)
    {
      checkMin(inValue, month, year);
    }
    else
    {
      int billDay = getBillingCycleStartDay();
      if(day<billDay)
      {
        //still previous month so shift month back
        BAbsTime prevMonth = now.prevMonth();
        checkMin(inValue, prevMonth.getMonth().getMonthOfYear(), prevMonth.getYear());
      }
      else
      {
        //at least the bill day, so check this month's peak
        checkMin(inValue, month, year);
      }
    }
  }
  
  
  public void doResetMins()
  {
    now = Clock.time();
    setLastReset(now);
    getJanuaryMin().setValue(Double.POSITIVE_INFINITY);
    setJanuaryTimestamp(BAbsTime.NULL);
    getFebruaryMin().setValue(Double.POSITIVE_INFINITY);
    setFebruaryTimestamp(BAbsTime.NULL);
    getMarchMin().setValue(Double.POSITIVE_INFINITY);
    setMarchTimestamp(BAbsTime.NULL);
    getAprilMin().setValue(Double.POSITIVE_INFINITY);
    setAprilTimestamp(BAbsTime.NULL);
    getMayMin().setValue(Double.POSITIVE_INFINITY);
    setMayTimestamp(BAbsTime.NULL);
    getJuneMin().setValue(Double.POSITIVE_INFINITY);
    setJuneTimestamp(BAbsTime.NULL);
    getJulyMin().setValue(Double.POSITIVE_INFINITY);
    setJulyTimestamp(BAbsTime.NULL);
    getAugustMin().setValue(Double.POSITIVE_INFINITY);
    setAugustTimestamp(BAbsTime.NULL);
    getSeptemberMin().setValue(Double.POSITIVE_INFINITY);
    setSeptemberTimestamp(BAbsTime.NULL);
    getOctoberMin().setValue(Double.POSITIVE_INFINITY);
    setOctoberTimestamp(BAbsTime.NULL);
    getNovemberMin().setValue(Double.POSITIVE_INFINITY);
    setNovemberTimestamp(BAbsTime.NULL);
    getDecemberMin().setValue(Double.POSITIVE_INFINITY);
    setDecemberTimestamp(BAbsTime.NULL);
    
    calculate();
  }
  
  
  private void checkMin(double v, int m, int y)
  {
    //TODO bail if NaN
    
    switch(m)
    {
      case 1: //January
        if(v <= getJanuaryMin().getValue() || getJanuaryTimestamp().getYear()!=y)
        {
          getJanuaryMin().setValue(v);
          setJanuaryTimestamp(now);
        }
        break;
        
      case 2: //February
        if(v <= getFebruaryMin().getValue() || getFebruaryTimestamp().getYear()!=y)
        {
          getFebruaryMin().setValue(v);
          setFebruaryTimestamp(now);
        }
        break;
        
      case 3: //March
        if(v <= getMarchMin().getValue() || getMarchTimestamp().getYear()!=y)
        {
          getMarchMin().setValue(v);
          setMarchTimestamp(now);
        }
        break;
        
      case 4: //April
        if(v <= getAprilMin().getValue() || getAprilTimestamp().getYear()!=y)
        {
          getAprilMin().setValue(v);
          setAprilTimestamp(now);
        }
        break;
        
      case 5: //May
        if(v <= getMayMin().getValue() || getMayTimestamp().getYear()!=y)
        {
          getMayMin().setValue(v);
          setMayTimestamp(now);
        }
        break;
        
      case 6: //June
        if(v <= getJuneMin().getValue() || getJuneTimestamp().getYear()!=y)
        {
          getJuneMin().setValue(v);
          setJuneTimestamp(now);
        }
        break;
        
      case 7: //July
        if(v <= getJulyMin().getValue() || getJulyTimestamp().getYear()!=y)
        {
          getJulyMin().setValue(v);
          setJulyTimestamp(now);
        }
        break;
        
      case 8: //August
        if(v <= getAugustMin().getValue() || getAugustTimestamp().getYear()!=y)
        {
          getAugustMin().setValue(v);
          setAugustTimestamp(now);
        }
        break;
        
      case 9: //September
        if(v <= getSeptemberMin().getValue() || getSeptemberTimestamp().getYear()!=y)
        {
          getSeptemberMin().setValue(v);
          setSeptemberTimestamp(now);
        }
        break;
        
      case 10: //October
        if(v <= getOctoberMin().getValue() || getOctoberTimestamp().getYear()!=y)
        {
          getOctoberMin().setValue(v);
          setOctoberTimestamp(now);
        }
        break;
        
      case 11: //November
        if(v <= getNovemberMin().getValue() || getNovemberTimestamp().getYear()!=y)
        {
          getNovemberMin().setValue(v);
          setNovemberTimestamp(now);
        }
        break;
        
      case 12: //December
        if(v <= getDecemberMin().getValue() || getDecemberTimestamp().getYear()!=y)
        {
          getDecemberMin().setValue(v);
          setDecemberTimestamp(now);
        }
        break;
    }
    
  }

  public BStatusNumeric[] getMins()
  {
    BStatusNumeric[] peaks = new BStatusNumeric[12];
    peaks[0]=(BStatusNumeric)getJanuaryMin().newCopy();
    peaks[1]=(BStatusNumeric)getFebruaryMin().newCopy();
    peaks[2]=(BStatusNumeric)getMarchMin().newCopy();
    peaks[3]=(BStatusNumeric)getAprilMin().newCopy();
    peaks[4]=(BStatusNumeric)getMayMin().newCopy();
    peaks[5]=(BStatusNumeric)getJuneMin().newCopy();
    peaks[6]=(BStatusNumeric)getJulyMin().newCopy();
    peaks[7]=(BStatusNumeric)getAugustMin().newCopy();
    peaks[8]=(BStatusNumeric)getSeptemberMin().newCopy();
    peaks[9]=(BStatusNumeric)getOctoberMin().newCopy();
    peaks[10]=(BStatusNumeric)getNovemberMin().newCopy();
    peaks[11]=(BStatusNumeric)getDecemberMin().newCopy();
    return peaks;
  }

  public BAbsTime[] getTimestamps()
  {
    BAbsTime[] tstamps = new BAbsTime[12];
    tstamps[0]=(BAbsTime)getJanuaryTimestamp().newCopy();
    tstamps[1]=(BAbsTime)getFebruaryTimestamp().newCopy();
    tstamps[2]=(BAbsTime)getMarchTimestamp().newCopy();
    tstamps[3]=(BAbsTime)getAprilTimestamp().newCopy();
    tstamps[4]=(BAbsTime)getMayTimestamp().newCopy();
    tstamps[5]=(BAbsTime)getJuneTimestamp().newCopy();
    tstamps[6]=(BAbsTime)getJulyTimestamp().newCopy();
    tstamps[7]=(BAbsTime)getAugustTimestamp().newCopy();
    tstamps[8]=(BAbsTime)getSeptemberTimestamp().newCopy();
    tstamps[9]=(BAbsTime)getOctoberTimestamp().newCopy();
    tstamps[10]=(BAbsTime)getNovemberTimestamp().newCopy();
    tstamps[11]=(BAbsTime)getDecemberTimestamp().newCopy();
    return tstamps;
  }

//////////////////////////////////////////////////
// local variables
//////////////////////////////////////////////////
  BAbsTime now = null;
  Clock.Ticket ticket = null;

  
////////////////////////////////////////////////////////////////
// Icon
////////////////////////////////////////////////////////////////
  
  /**
   * Get the icon.
   */
  public BIcon getIcon() { return icon; }
  private static final BIcon icon = BIcon.std("arrowDown.png");

}
