package com.vykon.vykonPro.hvac;

import javax.baja.status.BStatusBoolean;
import javax.baja.sys.BComponent;
import javax.baja.sys.BDynamicEnum;
import javax.baja.sys.BEnum;
import javax.baja.sys.BEnumRange;
import javax.baja.sys.Context;
import javax.baja.sys.Flags;
import javax.baja.sys.Property;
import javax.baja.sys.Sys;
import javax.baja.sys.Topic;
import javax.baja.sys.Type;

import com.vykon.vykonPro.enums.BSequencerOutputEnum;

public class BBooleanToSequencerCmd
    extends BComponent
{
  /*-
   class BBooleanToBalancerCmd
   {
     properties
     {
       in: BStatusBoolean
         flags { summary }
         default {[ new BStatusBoolean() ]}
       
       outputSelector: BEnum
         default {[ ( BDynamicEnum.make(0, BEnumRange.make(BSequencerOutputEnum.TYPE))) ]}
     }
     actions
     {
     
     }
     topics
     {
       manCmdOut:BManualSequencerCmd
     }
   }
   -*/
/*+ ------------ BEGIN BAJA AUTO GENERATED CODE ------------ +*/
/*@ $com.vykon.vykonPro.hvac.BBooleanToSequencerCmd(1540323505)1.0$ @*/
/* Generated Sun Mar 28 16:22:27 EDT 2010 by Slot-o-Matic 2000 (c) Tridium, Inc. 2000 */

////////////////////////////////////////////////////////////////
// Property "in"
////////////////////////////////////////////////////////////////
  
  /**
   * Slot for the <code>in</code> property.
   * @see com.vykon.vykonPro.hvac.BBooleanToSequencerCmd#getIn
   * @see com.vykon.vykonPro.hvac.BBooleanToSequencerCmd#setIn
   */
  public static final Property in = newProperty(Flags.SUMMARY, new BStatusBoolean(),null);
  
  /**
   * Get the <code>in</code> property.
   * @see com.vykon.vykonPro.hvac.BBooleanToSequencerCmd#in
   */
  public BStatusBoolean getIn() { return (BStatusBoolean)get(in); }
  
  /**
   * Set the <code>in</code> property.
   * @see com.vykon.vykonPro.hvac.BBooleanToSequencerCmd#in
   */
  public void setIn(BStatusBoolean v) { set(in,v,null); }

////////////////////////////////////////////////////////////////
// Property "outputSelector"
////////////////////////////////////////////////////////////////
  
  /**
   * Slot for the <code>outputSelector</code> property.
   * @see com.vykon.vykonPro.hvac.BBooleanToSequencerCmd#getOutputSelector
   * @see com.vykon.vykonPro.hvac.BBooleanToSequencerCmd#setOutputSelector
   */
  public static final Property outputSelector = newProperty(0, ( BDynamicEnum.make(0, BEnumRange.make(BSequencerOutputEnum.TYPE))),null);
  
  /**
   * Get the <code>outputSelector</code> property.
   * @see com.vykon.vykonPro.hvac.BBooleanToSequencerCmd#outputSelector
   */
  public BEnum getOutputSelector() { return (BEnum)get(outputSelector); }
  
  /**
   * Set the <code>outputSelector</code> property.
   * @see com.vykon.vykonPro.hvac.BBooleanToSequencerCmd#outputSelector
   */
  public void setOutputSelector(BEnum v) { set(outputSelector,v,null); }

////////////////////////////////////////////////////////////////
// Topic "manCmdOut"
////////////////////////////////////////////////////////////////
  
  /**
   * Slot for the <code>manCmdOut</code> topic.
   * @see com.vykon.vykonPro.hvac.BBooleanToSequencerCmd#fireManCmdOut
   */
  public static final Topic manCmdOut = newTopic(0,null);
  
  /**
   * Fire an event for the <code>manCmdOut</code> topic.
   * @see com.vykon.vykonPro.hvac.BBooleanToSequencerCmd#manCmdOut
   */
  public void fireManCmdOut(BManualSequencerCmd event) { fire(manCmdOut, event, null); }

////////////////////////////////////////////////////////////////
// Type
////////////////////////////////////////////////////////////////
  
  public Type getType() { return TYPE; }
  public static final Type TYPE = Sys.loadType(BBooleanToSequencerCmd.class);

/*+ ------------ END BAJA AUTO GENERATED CODE -------------- +*/


  public BBooleanToSequencerCmd()
  {
    
  }
  
  public void changed(Property p, Context cx)
  {
    super.changed(p, cx);
    if (!Sys.atSteadyState() || !isRunning())
      return;

    if(p == in || p == outputSelector)
    {
      //fire the topic
      BManualSequencerCmd msc = new BManualSequencerCmd(getIn().getValue(), getOutputSelector());
      fireManCmdOut(msc);
    }
  }
}
