package com.vykon.vykonPro.hvac;

import javax.baja.sys.BDynamicEnum;
import javax.baja.sys.BEnum;
import javax.baja.sys.BEnumRange;
import javax.baja.sys.BFacets;
import javax.baja.sys.BStruct;
import javax.baja.sys.Property;
import javax.baja.sys.Sys;
import javax.baja.sys.Type;

import com.vykon.vykonPro.enums.BRuntimeBalancerOutputEnum;

public class BManualBalancerCmd
    extends BStruct
{
  /*-
   class BManualBalancerCmd
   {
     properties
     {
       command: boolean
         default {[ false ]}
         slotfacets {[ BFacets.makeBoolean("disable output", "enable output") ]}
         
       output: BEnum
         default {[ ( BDynamicEnum.make(0, BEnumRange.make(BRuntimeBalancerOutputEnum.TYPE))) ]}
     }
   }
   
   -*/
/*+ ------------ BEGIN BAJA AUTO GENERATED CODE ------------ +*/
/*@ $com.vykon.vykonPro.hvac.BManualBalancerCmd(3782271185)1.0$ @*/
/* Generated Wed Mar 11 14:20:58 ACT 2009 by Slot-o-Matic 2000 (c) Tridium, Inc. 2000 */

////////////////////////////////////////////////////////////////
// Property "command"
////////////////////////////////////////////////////////////////
  
  /**
   * Slot for the <code>command</code> property.
   * @see com.vykon.vykonPro.hvac.BManualBalancerCmd#getCommand
   * @see com.vykon.vykonPro.hvac.BManualBalancerCmd#setCommand
   */
  public static final Property command = newProperty(0, false,BFacets.makeBoolean("disable output", "enable output"));
  
  /**
   * Get the <code>command</code> property.
   * @see com.vykon.vykonPro.hvac.BManualBalancerCmd#command
   */
  public boolean getCommand() { return getBoolean(command); }
  
  /**
   * Set the <code>command</code> property.
   * @see com.vykon.vykonPro.hvac.BManualBalancerCmd#command
   */
  public void setCommand(boolean v) { setBoolean(command,v,null); }

////////////////////////////////////////////////////////////////
// Property "output"
////////////////////////////////////////////////////////////////
  
  /**
   * Slot for the <code>output</code> property.
   * @see com.vykon.vykonPro.hvac.BManualBalancerCmd#getOutput
   * @see com.vykon.vykonPro.hvac.BManualBalancerCmd#setOutput
   */
  public static final Property output = newProperty(0, ( BDynamicEnum.make(0, BEnumRange.make(BRuntimeBalancerOutputEnum.TYPE))),null);
  
  /**
   * Get the <code>output</code> property.
   * @see com.vykon.vykonPro.hvac.BManualBalancerCmd#output
   */
  public BEnum getOutput() { return (BEnum)get(output); }
  
  /**
   * Set the <code>output</code> property.
   * @see com.vykon.vykonPro.hvac.BManualBalancerCmd#output
   */
  public void setOutput(BEnum v) { set(output,v,null); }

////////////////////////////////////////////////////////////////
// Type
////////////////////////////////////////////////////////////////
  
  public Type getType() { return TYPE; }
  public static final Type TYPE = Sys.loadType(BManualBalancerCmd.class);

/*+ ------------ END BAJA AUTO GENERATED CODE -------------- +*/

  //no argument constructor
  public BManualBalancerCmd()
  {
    
  }
  
  public BManualBalancerCmd(boolean command, BEnum output)
  {
    setCommand(command);
    setOutput(output);
  }
}
