package com.vykon.vykonPro.hvac;

import javax.baja.collection.BITable;
import javax.baja.collection.TableCursor;
import javax.baja.naming.BOrd;
import javax.baja.status.BStatus;
import javax.baja.status.BStatusNumeric;
import javax.baja.status.BStatusString;
import javax.baja.sys.Action;
import javax.baja.sys.BAbsTime;
import javax.baja.sys.BComponent;
import javax.baja.sys.BDouble;
import javax.baja.sys.BFacets;
import javax.baja.sys.BIcon;
import javax.baja.sys.BObject;
import javax.baja.sys.BRelTime;
import javax.baja.sys.BValue;
import javax.baja.sys.Clock;
import javax.baja.sys.Context;
import javax.baja.sys.Cursor;
import javax.baja.sys.Flags;
import javax.baja.sys.Property;
import javax.baja.sys.Slot;
import javax.baja.sys.Sys;
import javax.baja.sys.Type;
import javax.baja.util.BFormat;
import javax.baja.util.IFuture;
import javax.baja.util.Invocation;
import javax.baja.sys.Subscriber;
import javax.baja.sys.BComponentEvent;

import java.util.ArrayList;

import com.vykon.vykonPro.util.BVykonProService;

public class BMinMaxAvgBql
    extends BComponent
{
  /*-
   class BMinMaxAvgBql
   {
     properties
     {
       status: BStatus
           -- The status of the component
           flags { readonly, transient }
           default {[ BStatus.ok ]}
           
      faultCause: String
           -- The fault cause.
           flags { readonly, transient }
           default {[ "" ]}
       
       enabled: boolean
         --Property used to enable or disable the component.
         default{[ true ]}
         slotfacets{[BFacets.makeBoolean("enabled", "disabled")]}
       
       pointQuery:BOrd
         -- bql qury to find components
         default{[ BOrd.NULL ]}
         
       numberOfPoints:int
         -- number of components found by query
         flags{ summary, readonly, transient }
         default{[ 0 ]}
       
       facets:BFacets
         -- facets applied to the avg, min and max slots
         default{[ BFacets.NULL ]}
       
       count:int
         -- number of components used in calculating the avg, sum, min and max values. This number may be
         -- less than the numberOfPoints if any of the components have an invalid status or their value
         -- is Double.NaN.
         flags{ summary, readonly, transient }
         default{[ 0 ]}
         
       avg:BStatusNumeric
         -- average value of the components found by the query
         flags{ summary, readonly, transient }
         default{[ new BStatusNumeric() ]}
       
       sum:BStatusNumeric
         -- sum of values of the components found by the query
         flags{ summary, readonly, transient }
         default{[ new BStatusNumeric() ]}
       
       min:BStatusNumeric
         -- minimum value of the components found by the query.
         flags{ summary, readonly, transient }
         default{[ new BStatusNumeric() ]}
         
       minZoneIdentifier:BStatusString
         -- string identifier for the zone with the minimum value.
         flags{ summary, readonly, transient }
         default{[ new BStatusString() ]}
         
       max:BStatusNumeric
         -- maximum value of the components found by the query.
         flags{ summary, readonly, transient }
         default{[ new BStatusNumeric() ]}
         
       maxZoneIdentifier:BStatusString
         -- string identifier for the zone with the maximum value.
         flags{ summary, readonly, transient }
         default{[ new BStatusString() ]}
         
       zoneIdentifierFormat:BFormat
         -- format used and resolved against the component ord (as a base) to resolve the zone identifier string
         flags{  }
         default{[ BFormat.make("%name%") ]}
         
       updateValuesInterval:BRelTime
         -- the interval at which the values are processed and updated.
         flags{ }
         default{[ BRelTime.makeSeconds(15) ]}
         slotfacets {[ BFacets.make(BFacets.MIN,BRelTime.makeSeconds(1)) ]}
         
       refreshQueryInterval:BRelTime
         -- the interval at which the bql query is executed to update the array list of components
         flags{ }
         default{[ BRelTime.makeHours(12) ]}
         slotfacets {[ BFacets.make(BFacets.MIN,BRelTime.makeMinutes(1)) ]}
         
       startDelay:BRelTime
         -- the time after component start before the component list is initialized the first time.
         flags{ operator }
         default{[ BRelTime.makeMinutes(1) ]}
         slotfacets{[ BFacets.make(BFacets.MIN,BRelTime.makeSeconds(1)) ]}
         
       nextRefreshTime: BAbsTime
           -- the next time the component is scheduled to refresh the bql query
           flags{ hidden, readonly }
           default{[ BAbsTime.NULL ]}
     }
     actions
     {
       calculate()
         flags{ hidden }
         
         
       initializeList()
                
       refreshQuery()
         flags{ async, hidden }
     }
     topics
     {
     
     }
   }
   -*/
/*+ ------------ BEGIN BAJA AUTO GENERATED CODE ------------ +*/
/*@ $com.vykon.vykonPro.hvac.BMinMaxAvgBql(4249950015)1.0$ @*/
/* Generated Wed Aug 01 14:38:48 EDT 2012 by Slot-o-Matic 2000 (c) Tridium, Inc. 2000 */

////////////////////////////////////////////////////////////////
// Property "status"
////////////////////////////////////////////////////////////////
  
  /**
   * Slot for the <code>status</code> property.
   * The status of the component
   * @see com.vykon.vykonPro.hvac.BMinMaxAvgBql#getStatus
   * @see com.vykon.vykonPro.hvac.BMinMaxAvgBql#setStatus
   */
  public static final Property status = newProperty(Flags.READONLY|Flags.TRANSIENT, BStatus.ok,null);
  
  /**
   * Get the <code>status</code> property.
   * @see com.vykon.vykonPro.hvac.BMinMaxAvgBql#status
   */
  public BStatus getStatus() { return (BStatus)get(status); }
  
  /**
   * Set the <code>status</code> property.
   * @see com.vykon.vykonPro.hvac.BMinMaxAvgBql#status
   */
  public void setStatus(BStatus v) { set(status,v,null); }

////////////////////////////////////////////////////////////////
// Property "faultCause"
////////////////////////////////////////////////////////////////
  
  /**
   * Slot for the <code>faultCause</code> property.
   * The fault cause.
   * @see com.vykon.vykonPro.hvac.BMinMaxAvgBql#getFaultCause
   * @see com.vykon.vykonPro.hvac.BMinMaxAvgBql#setFaultCause
   */
  public static final Property faultCause = newProperty(Flags.READONLY|Flags.TRANSIENT, "",null);
  
  /**
   * Get the <code>faultCause</code> property.
   * @see com.vykon.vykonPro.hvac.BMinMaxAvgBql#faultCause
   */
  public String getFaultCause() { return getString(faultCause); }
  
  /**
   * Set the <code>faultCause</code> property.
   * @see com.vykon.vykonPro.hvac.BMinMaxAvgBql#faultCause
   */
  public void setFaultCause(String v) { setString(faultCause,v,null); }

////////////////////////////////////////////////////////////////
// Property "enabled"
////////////////////////////////////////////////////////////////
  
  /**
   * Slot for the <code>enabled</code> property.
   * Property used to enable or disable the component.
   * @see com.vykon.vykonPro.hvac.BMinMaxAvgBql#getEnabled
   * @see com.vykon.vykonPro.hvac.BMinMaxAvgBql#setEnabled
   */
  public static final Property enabled = newProperty(0, true,BFacets.makeBoolean("enabled", "disabled"));
  
  /**
   * Get the <code>enabled</code> property.
   * @see com.vykon.vykonPro.hvac.BMinMaxAvgBql#enabled
   */
  public boolean getEnabled() { return getBoolean(enabled); }
  
  /**
   * Set the <code>enabled</code> property.
   * @see com.vykon.vykonPro.hvac.BMinMaxAvgBql#enabled
   */
  public void setEnabled(boolean v) { setBoolean(enabled,v,null); }

////////////////////////////////////////////////////////////////
// Property "pointQuery"
////////////////////////////////////////////////////////////////
  
  /**
   * Slot for the <code>pointQuery</code> property.
   * bql qury to find components
   * @see com.vykon.vykonPro.hvac.BMinMaxAvgBql#getPointQuery
   * @see com.vykon.vykonPro.hvac.BMinMaxAvgBql#setPointQuery
   */
  public static final Property pointQuery = newProperty(0, BOrd.NULL,null);
  
  /**
   * Get the <code>pointQuery</code> property.
   * @see com.vykon.vykonPro.hvac.BMinMaxAvgBql#pointQuery
   */
  public BOrd getPointQuery() { return (BOrd)get(pointQuery); }
  
  /**
   * Set the <code>pointQuery</code> property.
   * @see com.vykon.vykonPro.hvac.BMinMaxAvgBql#pointQuery
   */
  public void setPointQuery(BOrd v) { set(pointQuery,v,null); }

////////////////////////////////////////////////////////////////
// Property "numberOfPoints"
////////////////////////////////////////////////////////////////
  
  /**
   * Slot for the <code>numberOfPoints</code> property.
   * number of components found by query
   * @see com.vykon.vykonPro.hvac.BMinMaxAvgBql#getNumberOfPoints
   * @see com.vykon.vykonPro.hvac.BMinMaxAvgBql#setNumberOfPoints
   */
  public static final Property numberOfPoints = newProperty(Flags.SUMMARY|Flags.READONLY|Flags.TRANSIENT, 0,null);
  
  /**
   * Get the <code>numberOfPoints</code> property.
   * @see com.vykon.vykonPro.hvac.BMinMaxAvgBql#numberOfPoints
   */
  public int getNumberOfPoints() { return getInt(numberOfPoints); }
  
  /**
   * Set the <code>numberOfPoints</code> property.
   * @see com.vykon.vykonPro.hvac.BMinMaxAvgBql#numberOfPoints
   */
  public void setNumberOfPoints(int v) { setInt(numberOfPoints,v,null); }

////////////////////////////////////////////////////////////////
// Property "facets"
////////////////////////////////////////////////////////////////
  
  /**
   * Slot for the <code>facets</code> property.
   * facets applied to the avg, min and max slots
   * @see com.vykon.vykonPro.hvac.BMinMaxAvgBql#getFacets
   * @see com.vykon.vykonPro.hvac.BMinMaxAvgBql#setFacets
   */
  public static final Property facets = newProperty(0, BFacets.NULL,null);
  
  /**
   * Get the <code>facets</code> property.
   * @see com.vykon.vykonPro.hvac.BMinMaxAvgBql#facets
   */
  public BFacets getFacets() { return (BFacets)get(facets); }
  
  /**
   * Set the <code>facets</code> property.
   * @see com.vykon.vykonPro.hvac.BMinMaxAvgBql#facets
   */
  public void setFacets(BFacets v) { set(facets,v,null); }

////////////////////////////////////////////////////////////////
// Property "count"
////////////////////////////////////////////////////////////////
  
  /**
   * Slot for the <code>count</code> property.
   * number of components used in calculating the avg, sum, min and max values. This number may be less than the numberOfPoints if any of the components have an invalid status or their value is Double.NaN.
   * @see com.vykon.vykonPro.hvac.BMinMaxAvgBql#getCount
   * @see com.vykon.vykonPro.hvac.BMinMaxAvgBql#setCount
   */
  public static final Property count = newProperty(Flags.SUMMARY|Flags.READONLY|Flags.TRANSIENT, 0,null);
  
  /**
   * Get the <code>count</code> property.
   * @see com.vykon.vykonPro.hvac.BMinMaxAvgBql#count
   */
  public int getCount() { return getInt(count); }
  
  /**
   * Set the <code>count</code> property.
   * @see com.vykon.vykonPro.hvac.BMinMaxAvgBql#count
   */
  public void setCount(int v) { setInt(count,v,null); }

////////////////////////////////////////////////////////////////
// Property "avg"
////////////////////////////////////////////////////////////////
  
  /**
   * Slot for the <code>avg</code> property.
   * average value of the components found by the query
   * @see com.vykon.vykonPro.hvac.BMinMaxAvgBql#getAvg
   * @see com.vykon.vykonPro.hvac.BMinMaxAvgBql#setAvg
   */
  public static final Property avg = newProperty(Flags.SUMMARY|Flags.READONLY|Flags.TRANSIENT, new BStatusNumeric(),null);
  
  /**
   * Get the <code>avg</code> property.
   * @see com.vykon.vykonPro.hvac.BMinMaxAvgBql#avg
   */
  public BStatusNumeric getAvg() { return (BStatusNumeric)get(avg); }
  
  /**
   * Set the <code>avg</code> property.
   * @see com.vykon.vykonPro.hvac.BMinMaxAvgBql#avg
   */
  public void setAvg(BStatusNumeric v) { set(avg,v,null); }

////////////////////////////////////////////////////////////////
// Property "sum"
////////////////////////////////////////////////////////////////
  
  /**
   * Slot for the <code>sum</code> property.
   * sum of values of the components found by the query
   * @see com.vykon.vykonPro.hvac.BMinMaxAvgBql#getSum
   * @see com.vykon.vykonPro.hvac.BMinMaxAvgBql#setSum
   */
  public static final Property sum = newProperty(Flags.SUMMARY|Flags.READONLY|Flags.TRANSIENT, new BStatusNumeric(),null);
  
  /**
   * Get the <code>sum</code> property.
   * @see com.vykon.vykonPro.hvac.BMinMaxAvgBql#sum
   */
  public BStatusNumeric getSum() { return (BStatusNumeric)get(sum); }
  
  /**
   * Set the <code>sum</code> property.
   * @see com.vykon.vykonPro.hvac.BMinMaxAvgBql#sum
   */
  public void setSum(BStatusNumeric v) { set(sum,v,null); }

////////////////////////////////////////////////////////////////
// Property "min"
////////////////////////////////////////////////////////////////
  
  /**
   * Slot for the <code>min</code> property.
   * minimum value of the components found by the query.
   * @see com.vykon.vykonPro.hvac.BMinMaxAvgBql#getMin
   * @see com.vykon.vykonPro.hvac.BMinMaxAvgBql#setMin
   */
  public static final Property min = newProperty(Flags.SUMMARY|Flags.READONLY|Flags.TRANSIENT, new BStatusNumeric(),null);
  
  /**
   * Get the <code>min</code> property.
   * @see com.vykon.vykonPro.hvac.BMinMaxAvgBql#min
   */
  public BStatusNumeric getMin() { return (BStatusNumeric)get(min); }
  
  /**
   * Set the <code>min</code> property.
   * @see com.vykon.vykonPro.hvac.BMinMaxAvgBql#min
   */
  public void setMin(BStatusNumeric v) { set(min,v,null); }

////////////////////////////////////////////////////////////////
// Property "minZoneIdentifier"
////////////////////////////////////////////////////////////////
  
  /**
   * Slot for the <code>minZoneIdentifier</code> property.
   * string identifier for the zone with the minimum value.
   * @see com.vykon.vykonPro.hvac.BMinMaxAvgBql#getMinZoneIdentifier
   * @see com.vykon.vykonPro.hvac.BMinMaxAvgBql#setMinZoneIdentifier
   */
  public static final Property minZoneIdentifier = newProperty(Flags.SUMMARY|Flags.READONLY|Flags.TRANSIENT, new BStatusString(),null);
  
  /**
   * Get the <code>minZoneIdentifier</code> property.
   * @see com.vykon.vykonPro.hvac.BMinMaxAvgBql#minZoneIdentifier
   */
  public BStatusString getMinZoneIdentifier() { return (BStatusString)get(minZoneIdentifier); }
  
  /**
   * Set the <code>minZoneIdentifier</code> property.
   * @see com.vykon.vykonPro.hvac.BMinMaxAvgBql#minZoneIdentifier
   */
  public void setMinZoneIdentifier(BStatusString v) { set(minZoneIdentifier,v,null); }

////////////////////////////////////////////////////////////////
// Property "max"
////////////////////////////////////////////////////////////////
  
  /**
   * Slot for the <code>max</code> property.
   * maximum value of the components found by the query.
   * @see com.vykon.vykonPro.hvac.BMinMaxAvgBql#getMax
   * @see com.vykon.vykonPro.hvac.BMinMaxAvgBql#setMax
   */
  public static final Property max = newProperty(Flags.SUMMARY|Flags.READONLY|Flags.TRANSIENT, new BStatusNumeric(),null);
  
  /**
   * Get the <code>max</code> property.
   * @see com.vykon.vykonPro.hvac.BMinMaxAvgBql#max
   */
  public BStatusNumeric getMax() { return (BStatusNumeric)get(max); }
  
  /**
   * Set the <code>max</code> property.
   * @see com.vykon.vykonPro.hvac.BMinMaxAvgBql#max
   */
  public void setMax(BStatusNumeric v) { set(max,v,null); }

////////////////////////////////////////////////////////////////
// Property "maxZoneIdentifier"
////////////////////////////////////////////////////////////////
  
  /**
   * Slot for the <code>maxZoneIdentifier</code> property.
   * string identifier for the zone with the maximum value.
   * @see com.vykon.vykonPro.hvac.BMinMaxAvgBql#getMaxZoneIdentifier
   * @see com.vykon.vykonPro.hvac.BMinMaxAvgBql#setMaxZoneIdentifier
   */
  public static final Property maxZoneIdentifier = newProperty(Flags.SUMMARY|Flags.READONLY|Flags.TRANSIENT, new BStatusString(),null);
  
  /**
   * Get the <code>maxZoneIdentifier</code> property.
   * @see com.vykon.vykonPro.hvac.BMinMaxAvgBql#maxZoneIdentifier
   */
  public BStatusString getMaxZoneIdentifier() { return (BStatusString)get(maxZoneIdentifier); }
  
  /**
   * Set the <code>maxZoneIdentifier</code> property.
   * @see com.vykon.vykonPro.hvac.BMinMaxAvgBql#maxZoneIdentifier
   */
  public void setMaxZoneIdentifier(BStatusString v) { set(maxZoneIdentifier,v,null); }

////////////////////////////////////////////////////////////////
// Property "zoneIdentifierFormat"
////////////////////////////////////////////////////////////////
  
  /**
   * Slot for the <code>zoneIdentifierFormat</code> property.
   * format used and resolved against the component ord
   * (as a base) to resolve the zone identifier string
   * @see com.vykon.vykonPro.hvac.BMinMaxAvgBql#getZoneIdentifierFormat
   * @see com.vykon.vykonPro.hvac.BMinMaxAvgBql#setZoneIdentifierFormat
   */
  public static final Property zoneIdentifierFormat = newProperty(0, BFormat.make("%name%"),null);
  
  /**
   * Get the <code>zoneIdentifierFormat</code> property.
   * @see com.vykon.vykonPro.hvac.BMinMaxAvgBql#zoneIdentifierFormat
   */
  public BFormat getZoneIdentifierFormat() { return (BFormat)get(zoneIdentifierFormat); }
  
  /**
   * Set the <code>zoneIdentifierFormat</code> property.
   * @see com.vykon.vykonPro.hvac.BMinMaxAvgBql#zoneIdentifierFormat
   */
  public void setZoneIdentifierFormat(BFormat v) { set(zoneIdentifierFormat,v,null); }

////////////////////////////////////////////////////////////////
// Property "updateValuesInterval"
////////////////////////////////////////////////////////////////
  
  /**
   * Slot for the <code>updateValuesInterval</code> property.
   * the interval at which the values are processed and
   * updated.
   * @see com.vykon.vykonPro.hvac.BMinMaxAvgBql#getUpdateValuesInterval
   * @see com.vykon.vykonPro.hvac.BMinMaxAvgBql#setUpdateValuesInterval
   */
  public static final Property updateValuesInterval = newProperty(0, BRelTime.makeSeconds(15),BFacets.make(BFacets.MIN,BRelTime.makeSeconds(1)));
  
  /**
   * Get the <code>updateValuesInterval</code> property.
   * @see com.vykon.vykonPro.hvac.BMinMaxAvgBql#updateValuesInterval
   */
  public BRelTime getUpdateValuesInterval() { return (BRelTime)get(updateValuesInterval); }
  
  /**
   * Set the <code>updateValuesInterval</code> property.
   * @see com.vykon.vykonPro.hvac.BMinMaxAvgBql#updateValuesInterval
   */
  public void setUpdateValuesInterval(BRelTime v) { set(updateValuesInterval,v,null); }

////////////////////////////////////////////////////////////////
// Property "refreshQueryInterval"
////////////////////////////////////////////////////////////////
  
  /**
   * Slot for the <code>refreshQueryInterval</code> property.
   * the interval at which the bql query is executed to
   * update the array list of components
   * @see com.vykon.vykonPro.hvac.BMinMaxAvgBql#getRefreshQueryInterval
   * @see com.vykon.vykonPro.hvac.BMinMaxAvgBql#setRefreshQueryInterval
   */
  public static final Property refreshQueryInterval = newProperty(0, BRelTime.makeHours(12),BFacets.make(BFacets.MIN,BRelTime.makeMinutes(1)));
  
  /**
   * Get the <code>refreshQueryInterval</code> property.
   * @see com.vykon.vykonPro.hvac.BMinMaxAvgBql#refreshQueryInterval
   */
  public BRelTime getRefreshQueryInterval() { return (BRelTime)get(refreshQueryInterval); }
  
  /**
   * Set the <code>refreshQueryInterval</code> property.
   * @see com.vykon.vykonPro.hvac.BMinMaxAvgBql#refreshQueryInterval
   */
  public void setRefreshQueryInterval(BRelTime v) { set(refreshQueryInterval,v,null); }

////////////////////////////////////////////////////////////////
// Property "startDelay"
////////////////////////////////////////////////////////////////
  
  /**
   * Slot for the <code>startDelay</code> property.
   * the time after component start before the component
   * list is initialized the first time.
   * @see com.vykon.vykonPro.hvac.BMinMaxAvgBql#getStartDelay
   * @see com.vykon.vykonPro.hvac.BMinMaxAvgBql#setStartDelay
   */
  public static final Property startDelay = newProperty(Flags.OPERATOR, BRelTime.makeMinutes(1),BFacets.make(BFacets.MIN,BRelTime.makeSeconds(1)));
  
  /**
   * Get the <code>startDelay</code> property.
   * @see com.vykon.vykonPro.hvac.BMinMaxAvgBql#startDelay
   */
  public BRelTime getStartDelay() { return (BRelTime)get(startDelay); }
  
  /**
   * Set the <code>startDelay</code> property.
   * @see com.vykon.vykonPro.hvac.BMinMaxAvgBql#startDelay
   */
  public void setStartDelay(BRelTime v) { set(startDelay,v,null); }

////////////////////////////////////////////////////////////////
// Property "nextRefreshTime"
////////////////////////////////////////////////////////////////
  
  /**
   * Slot for the <code>nextRefreshTime</code> property.
   * the next time the component is scheduled to refresh
   * the bql query
   * @see com.vykon.vykonPro.hvac.BMinMaxAvgBql#getNextRefreshTime
   * @see com.vykon.vykonPro.hvac.BMinMaxAvgBql#setNextRefreshTime
   */
  public static final Property nextRefreshTime = newProperty(Flags.HIDDEN|Flags.READONLY, BAbsTime.NULL,null);
  
  /**
   * Get the <code>nextRefreshTime</code> property.
   * @see com.vykon.vykonPro.hvac.BMinMaxAvgBql#nextRefreshTime
   */
  public BAbsTime getNextRefreshTime() { return (BAbsTime)get(nextRefreshTime); }
  
  /**
   * Set the <code>nextRefreshTime</code> property.
   * @see com.vykon.vykonPro.hvac.BMinMaxAvgBql#nextRefreshTime
   */
  public void setNextRefreshTime(BAbsTime v) { set(nextRefreshTime,v,null); }

////////////////////////////////////////////////////////////////
// Action "calculate"
////////////////////////////////////////////////////////////////
  
  /**
   * Slot for the <code>calculate</code> action.
   * @see com.vykon.vykonPro.hvac.BMinMaxAvgBql#calculate()
   */
  public static final Action calculate = newAction(Flags.HIDDEN,null);
  
  /**
   * Invoke the <code>calculate</code> action.
   * @see com.vykon.vykonPro.hvac.BMinMaxAvgBql#calculate
   */
  public void calculate() { invoke(calculate,null,null); }

////////////////////////////////////////////////////////////////
// Action "initializeList"
////////////////////////////////////////////////////////////////
  
  /**
   * Slot for the <code>initializeList</code> action.
   * @see com.vykon.vykonPro.hvac.BMinMaxAvgBql#initializeList()
   */
  public static final Action initializeList = newAction(0,null);
  
  /**
   * Invoke the <code>initializeList</code> action.
   * @see com.vykon.vykonPro.hvac.BMinMaxAvgBql#initializeList
   */
  public void initializeList() { invoke(initializeList,null,null); }

////////////////////////////////////////////////////////////////
// Action "refreshQuery"
////////////////////////////////////////////////////////////////
  
  /**
   * Slot for the <code>refreshQuery</code> action.
   * @see com.vykon.vykonPro.hvac.BMinMaxAvgBql#refreshQuery()
   */
  public static final Action refreshQuery = newAction(Flags.ASYNC|Flags.HIDDEN,null);
  
  /**
   * Invoke the <code>refreshQuery</code> action.
   * @see com.vykon.vykonPro.hvac.BMinMaxAvgBql#refreshQuery
   */
  public void refreshQuery() { invoke(refreshQuery,null,null); }

////////////////////////////////////////////////////////////////
// Type
////////////////////////////////////////////////////////////////
  
  public Type getType() { return TYPE; }
  public static final Type TYPE = Sys.loadType(BMinMaxAvgBql.class);

/*+ ------------ END BAJA AUTO GENERATED CODE -------------- +*/

  public void started()
  {
    checkForService();
    
    if(getEnabled())
    {
      //initializeList();
      initStartTicket();
      
      initCalcTicket();
      initClockTicket();
    }

    sub = new MySub();
  }

  public void stopped()
  {
    if (ticket != null) ticket.cancel();
    if (calcTicket != null) calcTicket.cancel();
    if (startTicket != null) startTicket.cancel();

    if(sub!=null)
    {
      sub.unsubscribeAll();
      sub=null;
    }
  }
  
  protected final void checkForService()
  {
    if(BVykonProService.getInstance()==null)
    {
      setStatus(BStatus.fault);
      setFaultCause("This component requires the VykonPro service in the station");
    }
    else if(BVykonProService.getInstance().isDisabled())
    {
      setStatus(BStatus.fault);
      setFaultCause("The vykonPro service is disabled");
    }
    else
    {
      setStatus(BStatus.ok);
      setFaultCause("");
    }
  }
  
  public BFacets getSlotFacets(Slot slot)
  {
    if (slot.equals(avg) || slot.equals(min) || slot.equals(max) || slot.equals(sum))
      return getFacets();
    return super.getSlotFacets(slot);

  }
  
  public void clockChanged(BRelTime value)
  {
    if(getEnabled() )
    {
      initClockTicket();
      initCalcTicket();
    }
  }
  
  public void changed(Property property, Context context)
  {

    super.changed(property, context);
    if (!Sys.atSteadyState() || !isRunning())
      return;

    if (getEnabled())
    {
      if (property.equals(refreshQueryInterval))
      {  
        refreshChanged = true;
        initClockTicket();
      }  
      else if (property.equals(updateValuesInterval))
        initCalcTicket();
    }

    if (property.equals(zoneIdentifierFormat))
      calculate();
    else if (property.equals(pointQuery))
      initializeList();

    else if (property.equals(enabled))
    {
      if (getEnabled())
      {
        doInitializeList();
        initCalcTicket();
        initClockTicket();
      }
      else
      {
        //transitioned from enabled to disabled so cancel tickets
        if (ticket != null)
          ticket.cancel();
        if (calcTicket != null)
          calcTicket.cancel();
      }
    }

  }
  
  private void initStartTicket()
  {
    if(startTicket != null) startTicket.cancel();
    startTicket = Clock.schedule(this, getStartDelay(), initializeList, null);
  }
  
  void initClockTicket()
  {            
    /*
     * 8/1/2012 added nextRefreshTime property to latch when the next query is to be
     * performed. When clock was changing it kept pushing this out and the refresh was
     * never happening.
     */
    BAbsTime next = getNextRefreshTime();
    if(refreshChanged)
    {
      refreshChanged = false;
      next = BAbsTime.NULL;
    }
    
    BAbsTime current = Clock.time();
    
    if(next==BAbsTime.NULL)
    {
      // have never scheduled a refresh
      setNextRefreshTime(current.add(getRefreshQueryInterval()));
      next = getNextRefreshTime();
    }
    else if(current.isAfter(next))
    {
      // we are past last refresh time, so bump time until in future
      while(next.isBefore(current))
        next = next.add(getRefreshQueryInterval());
        
      setNextRefreshTime(next);
    }
    else
    {
      if(current.add(getRefreshQueryInterval()).isBefore(getNextRefreshTime()))
        setNextRefreshTime(current.add(getRefreshQueryInterval()));
    }
    
    if (ticket != null) ticket.cancel();
    //ticket = Clock.schedule(this, getRefreshQueryInterval(), refreshQuery, null);
    ticket = Clock.schedulePeriodically(this, next, getRefreshQueryInterval(), refreshQuery, null);
  }
  
  void initCalcTicket()
  {
    if (calcTicket != null) calcTicket.cancel();
    BRelTime interval = getUpdateValuesInterval().getMillis()>=BRelTime.MILLIS_IN_SECOND ? getUpdateValuesInterval() : DEF_TIME;
    calcTicket = Clock.schedule(this, interval, calculate, null);
  }
  
  public IFuture post(Action action, BValue argument, Context cx)
  {
    if(action == refreshQuery)
      return BVykonProService.getInstance().getWorker().post(new Invocation(this, action, argument, cx));
    else
      return super.post(action, argument, cx);
  }
  
  
  public void doInitializeList()
  {
    if(!getEnabled()) return;
    if(!getStatus().isOk())
    {
      checkForService();
      if(!getStatus().isOk()) return;
    }
    
    if(startTicket != null) startTicket.cancel();
    
    //execute bql query and store result as an array of BComponents
    if(getPointQuery().isNull())
    {
      //set the fault status and cause
      setStatus(BStatus.fault);
      setFaultCause("must specify a point query");
      return;
    }
    else
    {
      //point query is specified, status is ok
      setStatus(BStatus.ok);
      setFaultCause("");
    }  
    
    refreshQuery();
  }

  public void doCalculate() throws Exception
  {
    if(!getEnabled()) return;
    if(!getStatus().isOk())
    {
      checkForService();
      if(!getStatus().isOk()) return;
    }
    
    if(getPointQuery().isNull())
    {
      initCalcTicket();
      return;
    }

    if(result==null)
    {
      //we haven't gotten the list back yet from the refreshQuery method
      //so just reset the timer and return
      initCalcTicket();
	  
	  // check if ticket is null or nextRefreshTime is in past...need to update ticket and
      // refresh query
      BAbsTime current = Clock.time();
      if(ticket==null || getNextRefreshTime().isBefore(current))
      {
        refreshQuery();
        initClockTicket();
      }
	  
      return;
    }
    
    //initialize values for each execution
    int num=0;
    double avg=0;
    double min=Double.POSITIVE_INFINITY;
    double max=Double.NEGATIVE_INFINITY;
    String minZ="";
    String maxZ="";
    
    //call timer to setup next execution
    initCalcTicket();

    /*
    try(Cursor cursor = result.cursor())
    {
      BComponent comp;
      BStatusNumeric n;
      double nValue;

      while(cursor.next())
      {
        comp = (BComponent)cursor.get();
        if(comp.get("out")!=null && comp.get("out").getType().is(BStatusNumeric.TYPE))
        {
          // lease the component to subscribe it
          //comp.lease(0, getUpdateValuesInterval().getMillis()+ 5000);
          if(!comp.isSubscribed())
          {
            System.out.println("subscribing the " + comp.getSlotPath());
            sub.subscribe(comp);
          }
          else System.out.println(comp.getSlotPath() + " is already subscribed");

          n = (BStatusNumeric)comp.get("out");
          if(n.getStatus().isValid() && BDouble.make(n.getValue())!=BDouble.NaN)
          {
            nValue = n.getValue();

            if (nValue < min)
            {
              min = nValue;
              minZ = getZoneIdentifierFormat().format(comp);
            }

            if (nValue > max)
            {
              max = nValue;
              maxZ = getZoneIdentifierFormat().format(comp);
            }

            avg = avg + nValue;
            num++;
          }
        }
      }

      System.out.println("finished cursor in " + (Clock.millis()-start));
    }
    catch(Exception e)
    {
      System.out.println(this.getSlotPath() + " - error calculating values");
      e.printStackTrace();
    }
    */


    BComponent comp;
    BStatusNumeric n;
    double nValue;

    for(int i=0; i<myComps.size(); i++)
    {
      comp = (BComponent)myComps.get(i);
      if(comp.get("out")!=null && comp.get("out").getType().is(BStatusNumeric.TYPE))
      {
        // lease the component to subscribe it
        if(!comp.isSubscribed()) sub.subscribe(comp);

        n = (BStatusNumeric)comp.get("out");
        if(n.getStatus().isValid() && BDouble.make(n.getValue())!=BDouble.NaN)
        {
          nValue = n.getValue();

          if (nValue < min)
          {
            min = nValue;
            minZ = getZoneIdentifierFormat().format(comp);
          }

          if (nValue > max)
          {
            max = nValue;
            maxZ = getZoneIdentifierFormat().format(comp);
          }

          avg = avg + nValue;
          num++;
        }
      }
    }

    getMinZoneIdentifier().setValue(minZ);
    getMaxZoneIdentifier().setValue(maxZ);  
    
    if(min == Double.POSITIVE_INFINITY) min = Double.NaN;
    if(max == Double.NEGATIVE_INFINITY) min = Double.NaN;
    
    if (num != 0)                 
    {
      getSum().setValue(avg);
      getAvg().setValue(avg/num);
      if(getAvg().getStatus().isNull()) getAvg().setStatus(BStatus.ok);
      if(getSum().getStatus().isNull()) getSum().setStatus(BStatus.ok);
    } 
    else                       
    {
      getSum().setStatus(BStatus.NULL);
      getAvg().setStatus(BStatus.NULL);
    }
    
    setCount(num);
    getMin().setValue(min);
    getMax().setValue(max);
  }
  
  public void doRefreshQuery()
  {
    result = (BITable)getPointQuery().get();
    myComps = new ArrayList<BComponent>();

    setNextRefreshTime(getNextRefreshTime().add(getRefreshQueryInterval()));
    int count = 0;
    try(TableCursor c = result.cursor())
    {
      while(c.next()) {
        count = count + 1;

        myComps.add((BComponent) c.get());
      }
    }
    catch(Exception e)
    {
      System.out.println(getSlotPath() + " - error trying to refresh the query");
      System.out.println(e);
    }

    setNumberOfPoints(count);
  }
  
  /**
   * Get the icon.
   */
  public BIcon getIcon()
  {
    return icon;
  }

  private static final BIcon icon = BIcon.std("control/numericPoint.png");

  protected class MySub extends Subscriber
  {
    public void event(BComponentEvent event)
    {
      // don't do anything
    }

  }
///////////////////////////////////////////////////////////////////////////
// local variables
///////////////////////////////////////////////////////////////////////////
  
  Clock.Ticket ticket;
  Clock.Ticket calcTicket;
  Clock.Ticket startTicket;
  BITable result = null;
  boolean refreshChanged = false;
  MySub sub = null;
  ArrayList myComps = null;
  private static BRelTime DEF_TIME = BRelTime.makeSeconds(15);
}
