package com.vykon.vykonPro.timer;

import javax.baja.status.BStatusBoolean;
import javax.baja.sys.Action;
import javax.baja.sys.BAbsTime;
import javax.baja.sys.BBoolean;
import javax.baja.sys.BComponent;
import javax.baja.sys.BFacets;
import javax.baja.sys.BIcon;
import javax.baja.sys.BRelTime;
import javax.baja.sys.Clock;
import javax.baja.sys.Context;
import javax.baja.sys.Flags;
import javax.baja.sys.Property;
import javax.baja.sys.Slot;
import javax.baja.sys.Sys;
import javax.baja.sys.Type;

public class BBooleanDelayWithTimer
    extends BComponent
{
  /*-
   class BBooleanDelayWithTimer
   {
     properties
     {
       updateTime: BRelTime
        default {[ BRelTime.make(500l) ]}
        slotfacets {[ BFacets.make(BFacets.SHOW_MILLISECONDS, BBoolean.TRUE, BFacets.MIN, BRelTime.make(500)) ]}
      
      timeFacets: BFacets
        flags{ operator }
        default {[ BFacets.make(BFacets.SHOW_MILLISECONDS, BBoolean.make(false)) ]}
        
      timeRemaining: BRelTime
        flags { transient, readonly, summary }
        default {[ BRelTime.make(0) ]}
        
      outFacets: BFacets
        -- These facets are applied against the out property.
        default {[ BFacets.makeBoolean() ]}
        
      in: BStatusBoolean
        flags { summary }
        default {[ new BStatusBoolean() ]}

      onDelay: BRelTime
        default {[ BRelTime.make(1000l) ]}
        slotfacets{[ BFacets.make(BFacets.MIN, BRelTime.make(500)) ]}
      
      offDelay: BRelTime
        default {[ BRelTime.make(1000l) ]}
        slotfacets{[ BFacets.make(BFacets.MIN, BRelTime.make(500)) ]}
        
      onDelayActive: boolean
        flags { transient, readonly }
        default {[ false ]}
      
      offDelayActive: boolean
        flags { transient, readonly }
        default {[ false ]}
      
      out: BStatusBoolean
        flags { transient, readonly, summary, defaultOnClone }
        default {[ new BStatusBoolean(false) ]}

      outNot: BStatusBoolean
        flags { transient, readonly, summary, defaultOnClone }
        default {[ new BStatusBoolean(true) ]}
        
      lastIn: boolean
        flags{ transient, readonly, hidden }
        default{[ false ]}
      
      
     }
     actions
     {
       onTimerExpired()
        flags { hidden }
        
       offTimerExpired()
        flags { hidden }
        
       timerExpired()
        flags { hidden }
     }
     topics
     {
     }
   }
   -*/
/*+ ------------ BEGIN BAJA AUTO GENERATED CODE ------------ +*/
/*@ $com.vykon.vykonPro.timer.BBooleanDelayWithTimer(3856121262)1.0$ @*/
/* Generated Thu Apr 17 08:38:57 EDT 2014 by Slot-o-Matic 2000 (c) Tridium, Inc. 2000 */

////////////////////////////////////////////////////////////////
// Property "updateTime"
////////////////////////////////////////////////////////////////
  
  /**
   * Slot for the <code>updateTime</code> property.
   * @see com.vykon.vykonPro.timer.BBooleanDelayWithTimer#getUpdateTime
   * @see com.vykon.vykonPro.timer.BBooleanDelayWithTimer#setUpdateTime
   */
  public static final Property updateTime = newProperty(0, BRelTime.make(500l),BFacets.make(BFacets.SHOW_MILLISECONDS, BBoolean.TRUE, BFacets.MIN, BRelTime.make(500)));
  
  /**
   * Get the <code>updateTime</code> property.
   * @see com.vykon.vykonPro.timer.BBooleanDelayWithTimer#updateTime
   */
  public BRelTime getUpdateTime() { return (BRelTime)get(updateTime); }
  
  /**
   * Set the <code>updateTime</code> property.
   * @see com.vykon.vykonPro.timer.BBooleanDelayWithTimer#updateTime
   */
  public void setUpdateTime(BRelTime v) { set(updateTime,v,null); }

////////////////////////////////////////////////////////////////
// Property "timeFacets"
////////////////////////////////////////////////////////////////
  
  /**
   * Slot for the <code>timeFacets</code> property.
   * @see com.vykon.vykonPro.timer.BBooleanDelayWithTimer#getTimeFacets
   * @see com.vykon.vykonPro.timer.BBooleanDelayWithTimer#setTimeFacets
   */
  public static final Property timeFacets = newProperty(Flags.OPERATOR, BFacets.make(BFacets.SHOW_MILLISECONDS, BBoolean.make(false)),null);
  
  /**
   * Get the <code>timeFacets</code> property.
   * @see com.vykon.vykonPro.timer.BBooleanDelayWithTimer#timeFacets
   */
  public BFacets getTimeFacets() { return (BFacets)get(timeFacets); }
  
  /**
   * Set the <code>timeFacets</code> property.
   * @see com.vykon.vykonPro.timer.BBooleanDelayWithTimer#timeFacets
   */
  public void setTimeFacets(BFacets v) { set(timeFacets,v,null); }

////////////////////////////////////////////////////////////////
// Property "timeRemaining"
////////////////////////////////////////////////////////////////
  
  /**
   * Slot for the <code>timeRemaining</code> property.
   * @see com.vykon.vykonPro.timer.BBooleanDelayWithTimer#getTimeRemaining
   * @see com.vykon.vykonPro.timer.BBooleanDelayWithTimer#setTimeRemaining
   */
  public static final Property timeRemaining = newProperty(Flags.TRANSIENT|Flags.READONLY|Flags.SUMMARY, BRelTime.make(0),null);
  
  /**
   * Get the <code>timeRemaining</code> property.
   * @see com.vykon.vykonPro.timer.BBooleanDelayWithTimer#timeRemaining
   */
  public BRelTime getTimeRemaining() { return (BRelTime)get(timeRemaining); }
  
  /**
   * Set the <code>timeRemaining</code> property.
   * @see com.vykon.vykonPro.timer.BBooleanDelayWithTimer#timeRemaining
   */
  public void setTimeRemaining(BRelTime v) { set(timeRemaining,v,null); }

////////////////////////////////////////////////////////////////
// Property "outFacets"
////////////////////////////////////////////////////////////////
  
  /**
   * Slot for the <code>outFacets</code> property.
   * These facets are applied against the out property.
   * @see com.vykon.vykonPro.timer.BBooleanDelayWithTimer#getOutFacets
   * @see com.vykon.vykonPro.timer.BBooleanDelayWithTimer#setOutFacets
   */
  public static final Property outFacets = newProperty(0, BFacets.makeBoolean(),null);
  
  /**
   * Get the <code>outFacets</code> property.
   * These facets are applied against the out property.
   * @see com.vykon.vykonPro.timer.BBooleanDelayWithTimer#outFacets
   */
  public BFacets getOutFacets() { return (BFacets)get(outFacets); }
  
  /**
   * Set the <code>outFacets</code> property.
   * These facets are applied against the out property.
   * @see com.vykon.vykonPro.timer.BBooleanDelayWithTimer#outFacets
   */
  public void setOutFacets(BFacets v) { set(outFacets,v,null); }

////////////////////////////////////////////////////////////////
// Property "in"
////////////////////////////////////////////////////////////////
  
  /**
   * Slot for the <code>in</code> property.
   * @see com.vykon.vykonPro.timer.BBooleanDelayWithTimer#getIn
   * @see com.vykon.vykonPro.timer.BBooleanDelayWithTimer#setIn
   */
  public static final Property in = newProperty(Flags.SUMMARY, new BStatusBoolean(),null);
  
  /**
   * Get the <code>in</code> property.
   * @see com.vykon.vykonPro.timer.BBooleanDelayWithTimer#in
   */
  public BStatusBoolean getIn() { return (BStatusBoolean)get(in); }
  
  /**
   * Set the <code>in</code> property.
   * @see com.vykon.vykonPro.timer.BBooleanDelayWithTimer#in
   */
  public void setIn(BStatusBoolean v) { set(in,v,null); }

////////////////////////////////////////////////////////////////
// Property "onDelay"
////////////////////////////////////////////////////////////////
  
  /**
   * Slot for the <code>onDelay</code> property.
   * @see com.vykon.vykonPro.timer.BBooleanDelayWithTimer#getOnDelay
   * @see com.vykon.vykonPro.timer.BBooleanDelayWithTimer#setOnDelay
   */
  public static final Property onDelay = newProperty(0, BRelTime.make(1000l),BFacets.make(BFacets.MIN, BRelTime.make(500)));
  
  /**
   * Get the <code>onDelay</code> property.
   * @see com.vykon.vykonPro.timer.BBooleanDelayWithTimer#onDelay
   */
  public BRelTime getOnDelay() { return (BRelTime)get(onDelay); }
  
  /**
   * Set the <code>onDelay</code> property.
   * @see com.vykon.vykonPro.timer.BBooleanDelayWithTimer#onDelay
   */
  public void setOnDelay(BRelTime v) { set(onDelay,v,null); }

////////////////////////////////////////////////////////////////
// Property "offDelay"
////////////////////////////////////////////////////////////////
  
  /**
   * Slot for the <code>offDelay</code> property.
   * @see com.vykon.vykonPro.timer.BBooleanDelayWithTimer#getOffDelay
   * @see com.vykon.vykonPro.timer.BBooleanDelayWithTimer#setOffDelay
   */
  public static final Property offDelay = newProperty(0, BRelTime.make(1000l),BFacets.make(BFacets.MIN, BRelTime.make(500)));
  
  /**
   * Get the <code>offDelay</code> property.
   * @see com.vykon.vykonPro.timer.BBooleanDelayWithTimer#offDelay
   */
  public BRelTime getOffDelay() { return (BRelTime)get(offDelay); }
  
  /**
   * Set the <code>offDelay</code> property.
   * @see com.vykon.vykonPro.timer.BBooleanDelayWithTimer#offDelay
   */
  public void setOffDelay(BRelTime v) { set(offDelay,v,null); }

////////////////////////////////////////////////////////////////
// Property "onDelayActive"
////////////////////////////////////////////////////////////////
  
  /**
   * Slot for the <code>onDelayActive</code> property.
   * @see com.vykon.vykonPro.timer.BBooleanDelayWithTimer#getOnDelayActive
   * @see com.vykon.vykonPro.timer.BBooleanDelayWithTimer#setOnDelayActive
   */
  public static final Property onDelayActive = newProperty(Flags.TRANSIENT|Flags.READONLY, false,null);
  
  /**
   * Get the <code>onDelayActive</code> property.
   * @see com.vykon.vykonPro.timer.BBooleanDelayWithTimer#onDelayActive
   */
  public boolean getOnDelayActive() { return getBoolean(onDelayActive); }
  
  /**
   * Set the <code>onDelayActive</code> property.
   * @see com.vykon.vykonPro.timer.BBooleanDelayWithTimer#onDelayActive
   */
  public void setOnDelayActive(boolean v) { setBoolean(onDelayActive,v,null); }

////////////////////////////////////////////////////////////////
// Property "offDelayActive"
////////////////////////////////////////////////////////////////
  
  /**
   * Slot for the <code>offDelayActive</code> property.
   * @see com.vykon.vykonPro.timer.BBooleanDelayWithTimer#getOffDelayActive
   * @see com.vykon.vykonPro.timer.BBooleanDelayWithTimer#setOffDelayActive
   */
  public static final Property offDelayActive = newProperty(Flags.TRANSIENT|Flags.READONLY, false,null);
  
  /**
   * Get the <code>offDelayActive</code> property.
   * @see com.vykon.vykonPro.timer.BBooleanDelayWithTimer#offDelayActive
   */
  public boolean getOffDelayActive() { return getBoolean(offDelayActive); }
  
  /**
   * Set the <code>offDelayActive</code> property.
   * @see com.vykon.vykonPro.timer.BBooleanDelayWithTimer#offDelayActive
   */
  public void setOffDelayActive(boolean v) { setBoolean(offDelayActive,v,null); }

////////////////////////////////////////////////////////////////
// Property "out"
////////////////////////////////////////////////////////////////
  
  /**
   * Slot for the <code>out</code> property.
   * @see com.vykon.vykonPro.timer.BBooleanDelayWithTimer#getOut
   * @see com.vykon.vykonPro.timer.BBooleanDelayWithTimer#setOut
   */
  public static final Property out = newProperty(Flags.TRANSIENT|Flags.READONLY|Flags.SUMMARY|Flags.DEFAULT_ON_CLONE, new BStatusBoolean(false),null);
  
  /**
   * Get the <code>out</code> property.
   * @see com.vykon.vykonPro.timer.BBooleanDelayWithTimer#out
   */
  public BStatusBoolean getOut() { return (BStatusBoolean)get(out); }
  
  /**
   * Set the <code>out</code> property.
   * @see com.vykon.vykonPro.timer.BBooleanDelayWithTimer#out
   */
  public void setOut(BStatusBoolean v) { set(out,v,null); }

////////////////////////////////////////////////////////////////
// Property "outNot"
////////////////////////////////////////////////////////////////
  
  /**
   * Slot for the <code>outNot</code> property.
   * @see com.vykon.vykonPro.timer.BBooleanDelayWithTimer#getOutNot
   * @see com.vykon.vykonPro.timer.BBooleanDelayWithTimer#setOutNot
   */
  public static final Property outNot = newProperty(Flags.TRANSIENT|Flags.READONLY|Flags.SUMMARY|Flags.DEFAULT_ON_CLONE, new BStatusBoolean(true),null);
  
  /**
   * Get the <code>outNot</code> property.
   * @see com.vykon.vykonPro.timer.BBooleanDelayWithTimer#outNot
   */
  public BStatusBoolean getOutNot() { return (BStatusBoolean)get(outNot); }
  
  /**
   * Set the <code>outNot</code> property.
   * @see com.vykon.vykonPro.timer.BBooleanDelayWithTimer#outNot
   */
  public void setOutNot(BStatusBoolean v) { set(outNot,v,null); }

////////////////////////////////////////////////////////////////
// Property "lastIn"
////////////////////////////////////////////////////////////////
  
  /**
   * Slot for the <code>lastIn</code> property.
   * @see com.vykon.vykonPro.timer.BBooleanDelayWithTimer#getLastIn
   * @see com.vykon.vykonPro.timer.BBooleanDelayWithTimer#setLastIn
   */
  public static final Property lastIn = newProperty(Flags.TRANSIENT|Flags.READONLY|Flags.HIDDEN, false,null);
  
  /**
   * Get the <code>lastIn</code> property.
   * @see com.vykon.vykonPro.timer.BBooleanDelayWithTimer#lastIn
   */
  public boolean getLastIn() { return getBoolean(lastIn); }
  
  /**
   * Set the <code>lastIn</code> property.
   * @see com.vykon.vykonPro.timer.BBooleanDelayWithTimer#lastIn
   */
  public void setLastIn(boolean v) { setBoolean(lastIn,v,null); }

////////////////////////////////////////////////////////////////
// Action "onTimerExpired"
////////////////////////////////////////////////////////////////
  
  /**
   * Slot for the <code>onTimerExpired</code> action.
   * @see com.vykon.vykonPro.timer.BBooleanDelayWithTimer#onTimerExpired()
   */
  public static final Action onTimerExpired = newAction(Flags.HIDDEN,null);
  
  /**
   * Invoke the <code>onTimerExpired</code> action.
   * @see com.vykon.vykonPro.timer.BBooleanDelayWithTimer#onTimerExpired
   */
  public void onTimerExpired() { invoke(onTimerExpired,null,null); }

////////////////////////////////////////////////////////////////
// Action "offTimerExpired"
////////////////////////////////////////////////////////////////
  
  /**
   * Slot for the <code>offTimerExpired</code> action.
   * @see com.vykon.vykonPro.timer.BBooleanDelayWithTimer#offTimerExpired()
   */
  public static final Action offTimerExpired = newAction(Flags.HIDDEN,null);
  
  /**
   * Invoke the <code>offTimerExpired</code> action.
   * @see com.vykon.vykonPro.timer.BBooleanDelayWithTimer#offTimerExpired
   */
  public void offTimerExpired() { invoke(offTimerExpired,null,null); }

////////////////////////////////////////////////////////////////
// Action "timerExpired"
////////////////////////////////////////////////////////////////
  
  /**
   * Slot for the <code>timerExpired</code> action.
   * @see com.vykon.vykonPro.timer.BBooleanDelayWithTimer#timerExpired()
   */
  public static final Action timerExpired = newAction(Flags.HIDDEN,null);
  
  /**
   * Invoke the <code>timerExpired</code> action.
   * @see com.vykon.vykonPro.timer.BBooleanDelayWithTimer#timerExpired
   */
  public void timerExpired() { invoke(timerExpired,null,null); }

////////////////////////////////////////////////////////////////
// Type
////////////////////////////////////////////////////////////////
  
  public Type getType() { return TYPE; }
  public static final Type TYPE = Sys.loadType(BBooleanDelayWithTimer.class);

/*+ ------------ END BAJA AUTO GENERATED CODE -------------- +*/

  /*
   * no argument constructor
   */
  public BBooleanDelayWithTimer()
  {
    
  }
  
  /**
   * Init if started after steady state has been reached.
   */
  public void started()
  {
    if(getIn().getValue() && !getOut().getValue())
    {
      //input is true and output is false so start on delay
      startOnTimer();
    }
    else if(!getIn().getValue() && getOut().getValue())
    {
      //input is false and output is true to so start off delay
      startOffTimer();
    }
    
    setLastIn(getIn().getValue());
    lastInput = getIn().getValue();
  }
  
  public void atSteadyState()
  {
    calculate();
  }
  
  /**
   * cancel all tickets
   */
  public void stopped()
  {
    if(ticket != null) ticket.cancel();
    if(onTicket != null) onTicket.cancel();
    if(offTicket != null) offTicket.cancel();
  }
  
  protected void initTimer()
  {
    if (ticket != null) ticket.cancel();
    ticket = Clock.schedulePeriodically(this, getUpdateTime(), timerExpired, null);
  }

/**
   * setoutput on in change.
   */
  public void changed(Property p, Context cx)
  {
    if (!isRunning()) return;

    if (p.equals(updateTime))
    {
      if(getOnDelayActive() || getOffDelayActive()) initTimer();
    }
    else if (p.equals(in))
    {
      calculate();
    }
  }
  
  public void calculate()
  {
    if(!getIn().getStatus().isValid())
      return;
    
    boolean input = getIn().getValue();
    lastInput = getLastIn();
    
    //input has changed from false to true
    if(input && !lastInput)
    {
      if(getOnDelay().getMillis() == 0l)
      {
        onTimerExpired();
      }
      else if(getOut().getValue())
      {
        //output is already true so cancel on time delay
        onTimerExpired();
      }
      else
      {
        startOnTimer();
      }
    }
    //input has changed from true to false
    else if(!input && lastInput)
    {
      if(getOffDelay().getMillis() == 0l)
      {
        offTimerExpired();
      }
      else if(!getOut().getValue())
      {
        //output is already false so cancel off time delay
        offTimerExpired();
      }
      else
      {  
        startOffTimer();
      }
    }
    else if(input && lastInput)
    {
      //both are true
      if(!getOut().getValue())
      {
        //input and lastInput are true, but out is still false
        if(!getOnDelayActive())
        {
          //for some reason the out doesn't match in and not in on delay mode
          startOnTimer();
        }
      }
    }
    else if(!input && !lastInput)
    {
      //both are false
      if(getOut().getValue())
      {
        //input and lastInput are false, but out is still true
        if(!getOffDelayActive())
        {
          //for some reason the out doesn't match in and not in off delay mode
          startOffTimer();
        }
      }
    }
    
    setLastIn(input);
  }

  private void setOutput(boolean value)
  {
    getOut().setValue(value);
    getOutNot().setValue(!value);
  }
  
  public void doOnTimerExpired()
  {
    setOutput(true);
    setOnDelayActive(false);
    setOffDelayActive(false);
    
    //cancel the update timer ticket
    if(ticket != null) ticket.cancel();
    if(onTicket != null) onTicket.cancel();
    if(offTicket != null) offTicket.cancel();
    
    //zero the time remaining
    setTimeRemaining(BRelTime.make(0));
  }

  public void doOffTimerExpired()
  {
    setOutput(false);
    setOnDelayActive(false);
    setOffDelayActive(false);
    
    //cancel the update timer ticket
    if(ticket != null) ticket.cancel();
    if(offTicket != null) offTicket.cancel();
    if(onTicket != null) onTicket.cancel();
    
    //zero the time remaining
    setTimeRemaining(BRelTime.make(0));
  }

  void startOnTimer()
  {
    if( offTicket != null) offTicket.cancel();
    if (onTicket != null) onTicket.cancel();
    onTicket = Clock.schedule(this, getOnDelay(), onTimerExpired, null);
    setOnDelayActive(true);
    setOffDelayActive(false);
    
    //calculate delayExpiration
    //now = Clock.time();
    //delayExpiration = now.add(getOnDelay());
    timerStartTicks = Clock.ticks();
    activeDelayExpirationTicks = timerStartTicks + getOnDelay().getMillis();
    
    //initTimer so that we can update count down timer
    initTimer();
  }    
  
  void startOffTimer()
  {            
    if (onTicket != null) onTicket.cancel();
    if (offTicket != null) offTicket.cancel();
    offTicket = Clock.schedule(this, getOffDelay(), offTimerExpired, null);
    setOffDelayActive(true);
    setOnDelayActive(false);
    
    //calculate delayExpiration
    //now = Clock.time();
    //delayExpiration = now.add(getOffDelay());
    timerStartTicks = Clock.ticks();
    activeDelayExpirationTicks = timerStartTicks + getOffDelay().getMillis();
    
    //initTimer so that we can update count down timer
    initTimer();
  }    
  
  public void doTimerExpired()
  {
    //now = Clock.time();
    //setTimeRemaining(BRelTime.make(delayExpiration.getMillis()-now.getMillis()));
    setTimeRemaining(BRelTime.make(activeDelayExpirationTicks - Clock.ticks()));
    
  }

  public String toString(Context cx)
  {
    return getOut().toString(cx);
  }

  /**
   * Apply the "facets" property to the "out" property.
  */
  public BFacets getSlotFacets(Slot slot)
  {
    if (slot == out) return getOutFacets();
    
    if (slot == timeRemaining) return getTimeFacets();
    
    return super.getSlotFacets(slot);
  }


  public BIcon getIcon() { return icon; }
  private static final BIcon icon = BIcon.std("control/trigger.png");

////////////////////////////////////////////////////////////////
// Attributes
////////////////////////////////////////////////////////////////

  BAbsTime now;
  BAbsTime delayExpiration;
  
  long timerStartTicks;
  long activeDelayExpirationTicks;
  
  Clock.Ticket ticket;      // Used to manage the current timer
  
  boolean lastInput = false;
  Clock.Ticket onTicket;      // Used to manage the current timer
  Clock.Ticket offTicket;      // Used to manage the current timer
  
}
