package com.vykon.vykonPro.util;

import javax.baja.status.BStatus;
import javax.baja.status.BStatusBoolean;
import javax.baja.sys.BComponent;
import javax.baja.sys.Context;
import javax.baja.sys.Flags;
import javax.baja.sys.Property;
import javax.baja.sys.Sys;
import javax.baja.sys.Type;

public class BBooleanSwitch
    extends BComponent
{
  /*-
   class BBooleanSwitch
   {
     properties
     {
       inSwitch:BStatusBoolean
        flags{ summary  }
        default{[ new BStatusBoolean() ]}
      
      falseOutput:BStatusBoolean
        flags{ summary  }
        default{[ new BStatusBoolean() ]}
      
      trueOutput:BStatusBoolean
        flags{ summary  }
        default{[ new BStatusBoolean() ]}
        
      nullOutput:BStatusBoolean
        flags{ }
        default{[ new BStatusBoolean(false) ]}
        
      out:BStatusBoolean
        flags{ summary, readonly}
        default{[ new BStatusBoolean() ]}
    
     }
     actions
     {
     }
     topics
     {
     }
   }
   -*/
/*+ ------------ BEGIN BAJA AUTO GENERATED CODE ------------ +*/
/*@ $com.vykon.vykonPro.util.BBooleanSwitch(3816554005)1.0$ @*/
/* Generated Tue Mar 16 16:05:22 EDT 2010 by Slot-o-Matic 2000 (c) Tridium, Inc. 2000 */

////////////////////////////////////////////////////////////////
// Property "inSwitch"
////////////////////////////////////////////////////////////////
  
  /**
   * Slot for the <code>inSwitch</code> property.
   * @see com.vykon.vykonPro.util.BBooleanSwitch#getInSwitch
   * @see com.vykon.vykonPro.util.BBooleanSwitch#setInSwitch
   */
  public static final Property inSwitch = newProperty(Flags.SUMMARY, new BStatusBoolean(),null);
  
  /**
   * Get the <code>inSwitch</code> property.
   * @see com.vykon.vykonPro.util.BBooleanSwitch#inSwitch
   */
  public BStatusBoolean getInSwitch() { return (BStatusBoolean)get(inSwitch); }
  
  /**
   * Set the <code>inSwitch</code> property.
   * @see com.vykon.vykonPro.util.BBooleanSwitch#inSwitch
   */
  public void setInSwitch(BStatusBoolean v) { set(inSwitch,v,null); }

////////////////////////////////////////////////////////////////
// Property "falseOutput"
////////////////////////////////////////////////////////////////
  
  /**
   * Slot for the <code>falseOutput</code> property.
   * @see com.vykon.vykonPro.util.BBooleanSwitch#getFalseOutput
   * @see com.vykon.vykonPro.util.BBooleanSwitch#setFalseOutput
   */
  public static final Property falseOutput = newProperty(Flags.SUMMARY, new BStatusBoolean(),null);
  
  /**
   * Get the <code>falseOutput</code> property.
   * @see com.vykon.vykonPro.util.BBooleanSwitch#falseOutput
   */
  public BStatusBoolean getFalseOutput() { return (BStatusBoolean)get(falseOutput); }
  
  /**
   * Set the <code>falseOutput</code> property.
   * @see com.vykon.vykonPro.util.BBooleanSwitch#falseOutput
   */
  public void setFalseOutput(BStatusBoolean v) { set(falseOutput,v,null); }

////////////////////////////////////////////////////////////////
// Property "trueOutput"
////////////////////////////////////////////////////////////////
  
  /**
   * Slot for the <code>trueOutput</code> property.
   * @see com.vykon.vykonPro.util.BBooleanSwitch#getTrueOutput
   * @see com.vykon.vykonPro.util.BBooleanSwitch#setTrueOutput
   */
  public static final Property trueOutput = newProperty(Flags.SUMMARY, new BStatusBoolean(),null);
  
  /**
   * Get the <code>trueOutput</code> property.
   * @see com.vykon.vykonPro.util.BBooleanSwitch#trueOutput
   */
  public BStatusBoolean getTrueOutput() { return (BStatusBoolean)get(trueOutput); }
  
  /**
   * Set the <code>trueOutput</code> property.
   * @see com.vykon.vykonPro.util.BBooleanSwitch#trueOutput
   */
  public void setTrueOutput(BStatusBoolean v) { set(trueOutput,v,null); }

////////////////////////////////////////////////////////////////
// Property "nullOutput"
////////////////////////////////////////////////////////////////
  
  /**
   * Slot for the <code>nullOutput</code> property.
   * @see com.vykon.vykonPro.util.BBooleanSwitch#getNullOutput
   * @see com.vykon.vykonPro.util.BBooleanSwitch#setNullOutput
   */
  public static final Property nullOutput = newProperty(0, new BStatusBoolean(false),null);
  
  /**
   * Get the <code>nullOutput</code> property.
   * @see com.vykon.vykonPro.util.BBooleanSwitch#nullOutput
   */
  public BStatusBoolean getNullOutput() { return (BStatusBoolean)get(nullOutput); }
  
  /**
   * Set the <code>nullOutput</code> property.
   * @see com.vykon.vykonPro.util.BBooleanSwitch#nullOutput
   */
  public void setNullOutput(BStatusBoolean v) { set(nullOutput,v,null); }

////////////////////////////////////////////////////////////////
// Property "out"
////////////////////////////////////////////////////////////////
  
  /**
   * Slot for the <code>out</code> property.
   * @see com.vykon.vykonPro.util.BBooleanSwitch#getOut
   * @see com.vykon.vykonPro.util.BBooleanSwitch#setOut
   */
  public static final Property out = newProperty(Flags.SUMMARY|Flags.READONLY, new BStatusBoolean(),null);
  
  /**
   * Get the <code>out</code> property.
   * @see com.vykon.vykonPro.util.BBooleanSwitch#out
   */
  public BStatusBoolean getOut() { return (BStatusBoolean)get(out); }
  
  /**
   * Set the <code>out</code> property.
   * @see com.vykon.vykonPro.util.BBooleanSwitch#out
   */
  public void setOut(BStatusBoolean v) { set(out,v,null); }

////////////////////////////////////////////////////////////////
// Type
////////////////////////////////////////////////////////////////
  
  public Type getType() { return TYPE; }
  public static final Type TYPE = Sys.loadType(BBooleanSwitch.class);

/*+ ------------ END BAJA AUTO GENERATED CODE -------------- +*/

  //the changed method gets called anytime one of the components properties changes (value or status)
  public void changed ( Property prop, Context cx)
  {
    //check to if one of these properties changed so we know to do something 
    if(prop==inSwitch || prop==falseOutput || prop==trueOutput || prop==nullOutput)      
     {
       //check the status of the inSwitch to see which output to use
       if(getInSwitch().getStatus().isValid())
       {     
         //since status is ok then we need to check the value to know which output to use
         if(getInSwitch().getValue()==true)
         {
           //inSwitch is true so we need to use the trueOutput. check the trueOutput status first
           if(getTrueOutput().getStatus().isValid())
           {
             //trueOutput status is ok, so just use whatever its value is and set out.status to ok
             getOut().setStatus(BStatus.ok);
             getOut().setValue(getTrueOutput().getValue());
           }
           else
           {
             //trueOutput status is not valid, so set output.status to null
             getOut().setStatus(BStatus.nullStatus);
           }
         }                                              
         else
         {
           //inSwitch is false so we need to use the falseOutput, check the falseOutput status first
           if(getFalseOutput().getStatus().isValid())
           {
             //falseOutput status is ok, so just use whatever its value is and set out.status to ok
             getOut().setStatus(BStatus.ok);
             getOut().setValue(getFalseOutput().getValue());
           }
           else
           {
             //falseOutput status is not valid, so set output.status to null
             getOut().setStatus(BStatus.nullStatus);
           }
         }
       }
       else
       {
         //input is null status so need to check nullOutput to see if it is null, true or false
         if(getNullOutput().getStatus().isValid())
         {
           //the nullOutput has an ok status so set the out.status to ok and out.value to nullOutput value
           getOut().setStatus(BStatus.ok);
           getOut().setValue(getNullOutput().getValue());
         }
         else
         {
           //the nullOutput was set to null so change the out.status to match
           getOut().setStatus(BStatus.nullStatus);
         }  
       }    
     }
  } 
}
