package com.vykon.vykonPro.util;

import javax.baja.sys.BStruct;
import javax.baja.sys.Property;
import javax.baja.sys.Sys;
import javax.baja.sys.Type;
import javax.baja.util.BTimeRange;

public class BTimeOfDay
    extends BStruct
{
  /*-
   class BTimeOfDay
   {
     properties
     {
       timeRange: BTimeRange
         -- A time range within any given day, with inclusive endpoints.
         default{[ new BTimeRange() ]}
      
       
     }
   }
   -*/
/*+ ------------ BEGIN BAJA AUTO GENERATED CODE ------------ +*/
/*@ $com.vykon.vykonPro.util.BTimeOfDay(1151617097)1.0$ @*/
/* Generated Thu Nov 11 09:52:10 EST 2010 by Slot-o-Matic 2000 (c) Tridium, Inc. 2000 */

////////////////////////////////////////////////////////////////
// Property "timeRange"
////////////////////////////////////////////////////////////////
  
  /**
   * Slot for the <code>timeRange</code> property.
   * A time range within any given day, with inclusive endpoints.
   * @see com.vykon.vykonPro.util.BTimeOfDay#getTimeRange
   * @see com.vykon.vykonPro.util.BTimeOfDay#setTimeRange
   */
  public static final Property timeRange = newProperty(0, new BTimeRange(),null);
  
  /**
   * Get the <code>timeRange</code> property.
   * @see com.vykon.vykonPro.util.BTimeOfDay#timeRange
   */
  public BTimeRange getTimeRange() { return (BTimeRange)get(timeRange); }
  
  /**
   * Set the <code>timeRange</code> property.
   * @see com.vykon.vykonPro.util.BTimeOfDay#timeRange
   */
  public void setTimeRange(BTimeRange v) { set(timeRange,v,null); }

////////////////////////////////////////////////////////////////
// Type
////////////////////////////////////////////////////////////////
  
  public Type getType() { return TYPE; }
  public static final Type TYPE = Sys.loadType(BTimeOfDay.class);

/*+ ------------ END BAJA AUTO GENERATED CODE -------------- +*/

  /*
   * no argument constructor
   */
  public BTimeOfDay()
  {
    setTimeRange(new BTimeRange());
  }
  
  public BTimeOfDay(BTimeRange tr)
  {
    setTimeRange(new BTimeRange(tr.getStartTime(),tr.getEndTime()));
  }

}
