package com.vykon.vykonPro.util;

import javax.baja.naming.BOrd;
import javax.baja.sys.BAbstractService;
import javax.baja.sys.BComponent;
import javax.baja.sys.BIService;
import javax.baja.sys.BIcon;
import javax.baja.sys.Flags;
import javax.baja.sys.Property;
import javax.baja.sys.Sys;
import javax.baja.sys.Type;
import javax.baja.util.BServiceContainer;

/**
 * BVykonProService performs common services for all VykonPro components.
 * 
 * @author
 * @creation 1 May 2008
 * @version $Revision: $ $Date: $
 * @since Baja 1.0
 */

public final class BVykonProService
    extends BAbstractService
    implements BIService
{
  /*-
  class BVykonProService
  {
    properties
    {
      worker:BVykonProWorker
        flags{ hidden }
        default{[ new BVykonProWorker() ]}
    }
      
    
  }
  -*/
/*+ ------------ BEGIN BAJA AUTO GENERATED CODE ------------ +*/
/*@ $com.vykon.vykonPro.util.BVykonProService(1807112555)1.0$ @*/
/* Generated Wed Aug 31 20:19:55 EDT 2011 by Slot-o-Matic 2000 (c) Tridium, Inc. 2000 */

////////////////////////////////////////////////////////////////
// Property "worker"
////////////////////////////////////////////////////////////////
  
  /**
   * Slot for the <code>worker</code> property.
   * @see com.vykon.vykonPro.util.BVykonProService#getWorker
   * @see com.vykon.vykonPro.util.BVykonProService#setWorker
   */
  public static final Property worker = newProperty(Flags.HIDDEN, new BVykonProWorker(),null);
  
  /**
   * Get the <code>worker</code> property.
   * @see com.vykon.vykonPro.util.BVykonProService#worker
   */
  public BVykonProWorker getWorker() { return (BVykonProWorker)get(worker); }
  
  /**
   * Set the <code>worker</code> property.
   * @see com.vykon.vykonPro.util.BVykonProService#worker
   */
  public void setWorker(BVykonProWorker v) { set(worker,v,null); }

////////////////////////////////////////////////////////////////
// Type
////////////////////////////////////////////////////////////////
  
  public Type getType() { return TYPE; }
  public static final Type TYPE = Sys.loadType(BVykonProService.class);

/*+ ------------ END BAJA AUTO GENERATED CODE -------------- +*/


  /**
   * Constructor.
   */
  public BVykonProService()
  {
  }


  public boolean isParentLegal ( BComponent parent)
  {
    return(parent instanceof BServiceContainer);
  }


  public synchronized void serviceStarted()
  {
    INSTANCE = this;
  }

  public synchronized void serviceStopped()
  {
    INSTANCE = null;
  }
  
  /**
   * Singleton
   */
  public static BVykonProService getInstance()
  {
    return INSTANCE;
  }
  
  /**
   * 
   */
  public Type[] getServiceTypes()
  {
    return serviceTypes;
  }

  private static Type[] serviceTypes = new Type[] { TYPE };
  
  private static BVykonProService INSTANCE = null;
  
  // //////////////////////////////////////////////////////////////
  // Icon
  // //////////////////////////////////////////////////////////////

  /**
   * Get the icon.
   */
  public BIcon getIcon()
  {
    return icon;
  }

  private static final BIcon icon = BIcon.make(BOrd.make("module://vykonPro/images/vykonDual16.png"));
  
  
}
