package com.vykon.vykonPro.util;

import javax.baja.collection.BITable;
import javax.baja.collection.Column;
import javax.baja.collection.TableCursor;
import javax.baja.naming.BOrd;
import javax.baja.sys.Action;
import javax.baja.sys.BComponent;
import javax.baja.sys.BDynamicEnum;
import javax.baja.sys.BEnumRange;
import javax.baja.sys.BIcon;
import javax.baja.sys.BValue;
import javax.baja.sys.Context;
import javax.baja.sys.Sys;
import javax.baja.sys.Type;
import javax.baja.nre.util.Array;

public class BWbMessenger
    extends BComponent
{
  /*-
   class BWbMessenger
   {
     properties
     {

     }
     actions
     {
       sendBroadcast(message:BBroadcastMessage)
         default {[ new BBroadcastMessage() ]}

       sendToSingleUser(message:BSingleCastMessage)
         default {[ new BSingleCastMessage() ]}
     }
     topics
     {

     }
   }
   -*/
/*+ ------------ BEGIN BAJA AUTO GENERATED CODE ------------ +*/
/*@ $com.vykon.vykonPro.util.BWbMessenger(2718385146)1.0$ @*/
/* Generated Wed May 27 09:54:47 EDT 2015 by Slot-o-Matic (c) Tridium, Inc. 2012 */

////////////////////////////////////////////////////////////////
// Action "sendBroadcast"
////////////////////////////////////////////////////////////////
  
  /**
   * Slot for the {@code sendBroadcast} action.
   * @see #sendBroadcast(BBroadcastMessage message)
   */
  public static final Action sendBroadcast = newAction(0,new BBroadcastMessage(),null);
  
  /**
   * Invoke the {@code sendBroadcast} action.
   * @see #sendBroadcast
   */
  public void sendBroadcast(BBroadcastMessage message) { invoke(sendBroadcast,message,null); }

////////////////////////////////////////////////////////////////
// Action "sendToSingleUser"
////////////////////////////////////////////////////////////////
  
  /**
   * Slot for the {@code sendToSingleUser} action.
   * @see #sendToSingleUser(BSingleCastMessage message)
   */
  public static final Action sendToSingleUser = newAction(0,new BSingleCastMessage(),null);
  
  /**
   * Invoke the {@code sendToSingleUser} action.
   * @see #sendToSingleUser
   */
  public void sendToSingleUser(BSingleCastMessage message) { invoke(sendToSingleUser,message,null); }

////////////////////////////////////////////////////////////////
// Type
////////////////////////////////////////////////////////////////
  
  @Override
  public Type getType() { return TYPE; }
  public static final Type TYPE = Sys.loadType(BWbMessenger.class);

/*+ ------------ END BAJA AUTO GENERATED CODE -------------- +*/

  public BValue getActionParameterDefault(Action action)
  {
     if (action == sendToSingleUser)
      return getDefaultSingleCastMessage();
     return super.getActionParameterDefault(action);
  }

  public BSingleCastMessage getDefaultSingleCastMessage()
  {
    /*
    BOrd serviceOrd = BOrd.make("service:baja:UserService");
    BUserService service = (BUserService)serviceOrd.resolve(this).get();
    service.lease();

    BUser[] users = (BUser[])service.getChildren(BUser.class);
    String[] names = new String[users.length];
    for(int i=0; i<users.length; i++)
    {
      names[i] = users[i].getUsername();
    }
     */

    BOrd queryOrd =
        BOrd
            .make("service:fox:FoxService|bql:select user.name from fox:FoxServerConnection");
    BITable res = (BITable) queryOrd.resolve(this).get();

    Array nameArray = new Array(String.class);
    Column userCol = res.getColumns().get(0);
    try(TableCursor c = res.cursor())
    {
      while (c.next())
      {
        if(!nameArray.contains(c.cell(userCol).toString()))
          nameArray.add(c.cell(userCol).toString());
      }
    }

    String[] names = (String[]) nameArray.trim();

    BEnumRange range = BEnumRange.make(names);
    BDynamicEnum user = BDynamicEnum.make(0, range);

    return new BSingleCastMessage(user, "", false);
  }

  public void doSendBroadcast(BBroadcastMessage msg, Context cx)
  {
    BWbMessengerNotification n = new BWbMessengerNotification();
    n.setTargetUser("all");
    n.setSourceUser(cx.getUser().getName());
    n.setMsg(msg.getMessage());
    n.setEchoMessage(msg.getEchoMessage());
    // Broadcast to everyone connected to this Station
    n.raise(true);
  }

  public void doSendToSingleUser(BSingleCastMessage msg, Context cx)
  {
    BWbMessengerNotification n = new BWbMessengerNotification();
    n.setTargetUser(msg.getUser().getTag());
    n.setSourceUser(cx.getUser().getName());
    n.setMsg(msg.getMessage());
    n.setEchoMessage(msg.getEchoMessage());
    n.raise(true);
  }


  public BIcon getIcon() { return icon; }
  private static final BIcon icon = BIcon.std("note.png");

}
