package com.vykon.vykonPro.conversion;

import javax.baja.naming.BOrd;
import javax.baja.status.BStatusString;
import javax.baja.sys.Action;
import javax.baja.sys.BComponent;
import javax.baja.sys.Context;
import javax.baja.sys.Flags;
import javax.baja.sys.Property;
import javax.baja.sys.Sys;
import javax.baja.sys.Type;


public class BStatusStringToOrd
    extends BComponent
{
  /*-
   class BStatusStringToOrd
   {
     properties
     {
      in: BStatusString
        --String which is converted to Ord
        flags{ summary }
        default {[ new BStatusString() ]}
      
      ord: BOrd
        --Resolved ord based on format text.
        flags{ readonly, summary }
        default{[ BOrd.DEFAULT ]}
     }
     actions
     {
       updateOrd()
     }
     topics
     {
     
     }
   }
   -*/
/*+ ------------ BEGIN BAJA AUTO GENERATED CODE ------------ +*/
/*@ $com.vykon.vykonPro.conversion.BStatusStringToOrd(2382145066)1.0$ @*/
/* Generated Tue Mar 16 15:47:15 EDT 2010 by Slot-o-Matic 2000 (c) Tridium, Inc. 2000 */

////////////////////////////////////////////////////////////////
// Property "in"
////////////////////////////////////////////////////////////////
  
  /**
   * Slot for the <code>in</code> property.
   * String which is converted to Ord
   * @see com.vykon.vykonPro.conversion.BStatusStringToOrd#getIn
   * @see com.vykon.vykonPro.conversion.BStatusStringToOrd#setIn
   */
  public static final Property in = newProperty(Flags.SUMMARY, new BStatusString(),null);
  
  /**
   * Get the <code>in</code> property.
   * @see com.vykon.vykonPro.conversion.BStatusStringToOrd#in
   */
  public BStatusString getIn() { return (BStatusString)get(in); }
  
  /**
   * Set the <code>in</code> property.
   * @see com.vykon.vykonPro.conversion.BStatusStringToOrd#in
   */
  public void setIn(BStatusString v) { set(in,v,null); }

////////////////////////////////////////////////////////////////
// Property "ord"
////////////////////////////////////////////////////////////////
  
  /**
   * Slot for the <code>ord</code> property.
   * Resolved ord based on format text.
   * @see com.vykon.vykonPro.conversion.BStatusStringToOrd#getOrd
   * @see com.vykon.vykonPro.conversion.BStatusStringToOrd#setOrd
   */
  public static final Property ord = newProperty(Flags.READONLY|Flags.SUMMARY, BOrd.DEFAULT,null);
  
  /**
   * Get the <code>ord</code> property.
   * @see com.vykon.vykonPro.conversion.BStatusStringToOrd#ord
   */
  public BOrd getOrd() { return (BOrd)get(ord); }
  
  /**
   * Set the <code>ord</code> property.
   * @see com.vykon.vykonPro.conversion.BStatusStringToOrd#ord
   */
  public void setOrd(BOrd v) { set(ord,v,null); }

////////////////////////////////////////////////////////////////
// Action "updateOrd"
////////////////////////////////////////////////////////////////
  
  /**
   * Slot for the <code>updateOrd</code> action.
   * @see com.vykon.vykonPro.conversion.BStatusStringToOrd#updateOrd()
   */
  public static final Action updateOrd = newAction(0,null);
  
  /**
   * Invoke the <code>updateOrd</code> action.
   * @see com.vykon.vykonPro.conversion.BStatusStringToOrd#updateOrd
   */
  public void updateOrd() { invoke(updateOrd,null,null); }

////////////////////////////////////////////////////////////////
// Type
////////////////////////////////////////////////////////////////
  
  public Type getType() { return TYPE; }
  public static final Type TYPE = Sys.loadType(BStatusStringToOrd.class);

/*+ ------------ END BAJA AUTO GENERATED CODE -------------- +*/


  public void started() throws Exception
  {
    updateOrd();
  }

  public void changed(Property property, Context context) 
  {
   super.changed(property, context);
    if( !Sys.atSteadyState() || !isRunning() )
     return;
  
    if(property.equals(in)) updateOrd();
  }
  
  public void doUpdateOrd()
  {
    setOrd(BOrd.make(getIn().getValue()));
  }
}
