package com.vykon.vykonPro.energy;

import javax.baja.status.BStatusNumeric;
import javax.baja.sys.Action;
import javax.baja.sys.BComponent;
import javax.baja.sys.BFacets;
import javax.baja.sys.Context;
import javax.baja.sys.Flags;
import javax.baja.sys.Property;
import javax.baja.sys.Slot;
import javax.baja.sys.Sys;
import javax.baja.sys.Type;

public class BAggregateConsumption
    extends BComponent
{
  /*-
   class BAggregateConsumption
   {
     properties
     {
       facets: BFacets
        -- These facets are applied against the out property.
        default {[ BFacets.DEFAULT ]}
        
      numberValues: int
        -- number of inputs
        default {[ 2 ]}
        slotfacets {[ BFacets.makeInt(null, 2, 10) ]}
        
      total: BStatusNumeric
        -- The running total of valid inputs
        flags { operator, readonly, summary }
        default {[ new BStatusNumeric() ]}
        
      in1: BStatusNumeric
        flags { summary }
        default {[ new BStatusNumeric() ]}
        
      in2: BStatusNumeric
        flags { summary }
        default {[ new BStatusNumeric() ]}
        
      in3: BStatusNumeric
        flags { summary }
        default {[ new BStatusNumeric() ]}
        
      in4: BStatusNumeric
        flags { summary }
        default {[ new BStatusNumeric() ]}
        
      in5: BStatusNumeric
        flags { summary }
        default {[ new BStatusNumeric() ]}
        
      in6: BStatusNumeric
        flags { summary }
        default {[ new BStatusNumeric() ]}
        
      in7: BStatusNumeric
        flags { summary }
        default {[ new BStatusNumeric() ]}
        
      in8: BStatusNumeric
        flags { summary }
        default {[ new BStatusNumeric() ]}
        
      in9: BStatusNumeric
        flags { summary }
        default {[ new BStatusNumeric() ]}
        
      in10: BStatusNumeric
        flags { summary }
        default {[ new BStatusNumeric() ]}
     }
     actions
     {
       calculate()
        flags{ hidden }
        
       resetTotal()
     }
     topics
     {
     }
   }
   -*/
/*+ ------------ BEGIN BAJA AUTO GENERATED CODE ------------ +*/
/*@ $com.vykon.vykonPro.energy.BAggregateConsumption(957959346)1.0$ @*/
/* Generated Mon Apr 11 13:43:34 EDT 2011 by Slot-o-Matic 2000 (c) Tridium, Inc. 2000 */

////////////////////////////////////////////////////////////////
// Property "facets"
////////////////////////////////////////////////////////////////
  
  /**
   * Slot for the <code>facets</code> property.
   * These facets are applied against the out property.
   * @see com.vykon.vykonPro.energy.BAggregateConsumption#getFacets
   * @see com.vykon.vykonPro.energy.BAggregateConsumption#setFacets
   */
  public static final Property facets = newProperty(0, BFacets.DEFAULT,null);
  
  /**
   * Get the <code>facets</code> property.
   * @see com.vykon.vykonPro.energy.BAggregateConsumption#facets
   */
  public BFacets getFacets() { return (BFacets)get(facets); }
  
  /**
   * Set the <code>facets</code> property.
   * @see com.vykon.vykonPro.energy.BAggregateConsumption#facets
   */
  public void setFacets(BFacets v) { set(facets,v,null); }

////////////////////////////////////////////////////////////////
// Property "numberValues"
////////////////////////////////////////////////////////////////
  
  /**
   * Slot for the <code>numberValues</code> property.
   * number of inputs
   * @see com.vykon.vykonPro.energy.BAggregateConsumption#getNumberValues
   * @see com.vykon.vykonPro.energy.BAggregateConsumption#setNumberValues
   */
  public static final Property numberValues = newProperty(0, 2,BFacets.makeInt(null, 2, 10));
  
  /**
   * Get the <code>numberValues</code> property.
   * @see com.vykon.vykonPro.energy.BAggregateConsumption#numberValues
   */
  public int getNumberValues() { return getInt(numberValues); }
  
  /**
   * Set the <code>numberValues</code> property.
   * @see com.vykon.vykonPro.energy.BAggregateConsumption#numberValues
   */
  public void setNumberValues(int v) { setInt(numberValues,v,null); }

////////////////////////////////////////////////////////////////
// Property "total"
////////////////////////////////////////////////////////////////
  
  /**
   * Slot for the <code>total</code> property.
   * The running total of valid inputs
   * @see com.vykon.vykonPro.energy.BAggregateConsumption#getTotal
   * @see com.vykon.vykonPro.energy.BAggregateConsumption#setTotal
   */
  public static final Property total = newProperty(Flags.OPERATOR|Flags.READONLY|Flags.SUMMARY, new BStatusNumeric(),null);
  
  /**
   * Get the <code>total</code> property.
   * @see com.vykon.vykonPro.energy.BAggregateConsumption#total
   */
  public BStatusNumeric getTotal() { return (BStatusNumeric)get(total); }
  
  /**
   * Set the <code>total</code> property.
   * @see com.vykon.vykonPro.energy.BAggregateConsumption#total
   */
  public void setTotal(BStatusNumeric v) { set(total,v,null); }

////////////////////////////////////////////////////////////////
// Property "in1"
////////////////////////////////////////////////////////////////
  
  /**
   * Slot for the <code>in1</code> property.
   * @see com.vykon.vykonPro.energy.BAggregateConsumption#getIn1
   * @see com.vykon.vykonPro.energy.BAggregateConsumption#setIn1
   */
  public static final Property in1 = newProperty(Flags.SUMMARY, new BStatusNumeric(),null);
  
  /**
   * Get the <code>in1</code> property.
   * @see com.vykon.vykonPro.energy.BAggregateConsumption#in1
   */
  public BStatusNumeric getIn1() { return (BStatusNumeric)get(in1); }
  
  /**
   * Set the <code>in1</code> property.
   * @see com.vykon.vykonPro.energy.BAggregateConsumption#in1
   */
  public void setIn1(BStatusNumeric v) { set(in1,v,null); }

////////////////////////////////////////////////////////////////
// Property "in2"
////////////////////////////////////////////////////////////////
  
  /**
   * Slot for the <code>in2</code> property.
   * @see com.vykon.vykonPro.energy.BAggregateConsumption#getIn2
   * @see com.vykon.vykonPro.energy.BAggregateConsumption#setIn2
   */
  public static final Property in2 = newProperty(Flags.SUMMARY, new BStatusNumeric(),null);
  
  /**
   * Get the <code>in2</code> property.
   * @see com.vykon.vykonPro.energy.BAggregateConsumption#in2
   */
  public BStatusNumeric getIn2() { return (BStatusNumeric)get(in2); }
  
  /**
   * Set the <code>in2</code> property.
   * @see com.vykon.vykonPro.energy.BAggregateConsumption#in2
   */
  public void setIn2(BStatusNumeric v) { set(in2,v,null); }

////////////////////////////////////////////////////////////////
// Property "in3"
////////////////////////////////////////////////////////////////
  
  /**
   * Slot for the <code>in3</code> property.
   * @see com.vykon.vykonPro.energy.BAggregateConsumption#getIn3
   * @see com.vykon.vykonPro.energy.BAggregateConsumption#setIn3
   */
  public static final Property in3 = newProperty(Flags.SUMMARY, new BStatusNumeric(),null);
  
  /**
   * Get the <code>in3</code> property.
   * @see com.vykon.vykonPro.energy.BAggregateConsumption#in3
   */
  public BStatusNumeric getIn3() { return (BStatusNumeric)get(in3); }
  
  /**
   * Set the <code>in3</code> property.
   * @see com.vykon.vykonPro.energy.BAggregateConsumption#in3
   */
  public void setIn3(BStatusNumeric v) { set(in3,v,null); }

////////////////////////////////////////////////////////////////
// Property "in4"
////////////////////////////////////////////////////////////////
  
  /**
   * Slot for the <code>in4</code> property.
   * @see com.vykon.vykonPro.energy.BAggregateConsumption#getIn4
   * @see com.vykon.vykonPro.energy.BAggregateConsumption#setIn4
   */
  public static final Property in4 = newProperty(Flags.SUMMARY, new BStatusNumeric(),null);
  
  /**
   * Get the <code>in4</code> property.
   * @see com.vykon.vykonPro.energy.BAggregateConsumption#in4
   */
  public BStatusNumeric getIn4() { return (BStatusNumeric)get(in4); }
  
  /**
   * Set the <code>in4</code> property.
   * @see com.vykon.vykonPro.energy.BAggregateConsumption#in4
   */
  public void setIn4(BStatusNumeric v) { set(in4,v,null); }

////////////////////////////////////////////////////////////////
// Property "in5"
////////////////////////////////////////////////////////////////
  
  /**
   * Slot for the <code>in5</code> property.
   * @see com.vykon.vykonPro.energy.BAggregateConsumption#getIn5
   * @see com.vykon.vykonPro.energy.BAggregateConsumption#setIn5
   */
  public static final Property in5 = newProperty(Flags.SUMMARY, new BStatusNumeric(),null);
  
  /**
   * Get the <code>in5</code> property.
   * @see com.vykon.vykonPro.energy.BAggregateConsumption#in5
   */
  public BStatusNumeric getIn5() { return (BStatusNumeric)get(in5); }
  
  /**
   * Set the <code>in5</code> property.
   * @see com.vykon.vykonPro.energy.BAggregateConsumption#in5
   */
  public void setIn5(BStatusNumeric v) { set(in5,v,null); }

////////////////////////////////////////////////////////////////
// Property "in6"
////////////////////////////////////////////////////////////////
  
  /**
   * Slot for the <code>in6</code> property.
   * @see com.vykon.vykonPro.energy.BAggregateConsumption#getIn6
   * @see com.vykon.vykonPro.energy.BAggregateConsumption#setIn6
   */
  public static final Property in6 = newProperty(Flags.SUMMARY, new BStatusNumeric(),null);
  
  /**
   * Get the <code>in6</code> property.
   * @see com.vykon.vykonPro.energy.BAggregateConsumption#in6
   */
  public BStatusNumeric getIn6() { return (BStatusNumeric)get(in6); }
  
  /**
   * Set the <code>in6</code> property.
   * @see com.vykon.vykonPro.energy.BAggregateConsumption#in6
   */
  public void setIn6(BStatusNumeric v) { set(in6,v,null); }

////////////////////////////////////////////////////////////////
// Property "in7"
////////////////////////////////////////////////////////////////
  
  /**
   * Slot for the <code>in7</code> property.
   * @see com.vykon.vykonPro.energy.BAggregateConsumption#getIn7
   * @see com.vykon.vykonPro.energy.BAggregateConsumption#setIn7
   */
  public static final Property in7 = newProperty(Flags.SUMMARY, new BStatusNumeric(),null);
  
  /**
   * Get the <code>in7</code> property.
   * @see com.vykon.vykonPro.energy.BAggregateConsumption#in7
   */
  public BStatusNumeric getIn7() { return (BStatusNumeric)get(in7); }
  
  /**
   * Set the <code>in7</code> property.
   * @see com.vykon.vykonPro.energy.BAggregateConsumption#in7
   */
  public void setIn7(BStatusNumeric v) { set(in7,v,null); }

////////////////////////////////////////////////////////////////
// Property "in8"
////////////////////////////////////////////////////////////////
  
  /**
   * Slot for the <code>in8</code> property.
   * @see com.vykon.vykonPro.energy.BAggregateConsumption#getIn8
   * @see com.vykon.vykonPro.energy.BAggregateConsumption#setIn8
   */
  public static final Property in8 = newProperty(Flags.SUMMARY, new BStatusNumeric(),null);
  
  /**
   * Get the <code>in8</code> property.
   * @see com.vykon.vykonPro.energy.BAggregateConsumption#in8
   */
  public BStatusNumeric getIn8() { return (BStatusNumeric)get(in8); }
  
  /**
   * Set the <code>in8</code> property.
   * @see com.vykon.vykonPro.energy.BAggregateConsumption#in8
   */
  public void setIn8(BStatusNumeric v) { set(in8,v,null); }

////////////////////////////////////////////////////////////////
// Property "in9"
////////////////////////////////////////////////////////////////
  
  /**
   * Slot for the <code>in9</code> property.
   * @see com.vykon.vykonPro.energy.BAggregateConsumption#getIn9
   * @see com.vykon.vykonPro.energy.BAggregateConsumption#setIn9
   */
  public static final Property in9 = newProperty(Flags.SUMMARY, new BStatusNumeric(),null);
  
  /**
   * Get the <code>in9</code> property.
   * @see com.vykon.vykonPro.energy.BAggregateConsumption#in9
   */
  public BStatusNumeric getIn9() { return (BStatusNumeric)get(in9); }
  
  /**
   * Set the <code>in9</code> property.
   * @see com.vykon.vykonPro.energy.BAggregateConsumption#in9
   */
  public void setIn9(BStatusNumeric v) { set(in9,v,null); }

////////////////////////////////////////////////////////////////
// Property "in10"
////////////////////////////////////////////////////////////////
  
  /**
   * Slot for the <code>in10</code> property.
   * @see com.vykon.vykonPro.energy.BAggregateConsumption#getIn10
   * @see com.vykon.vykonPro.energy.BAggregateConsumption#setIn10
   */
  public static final Property in10 = newProperty(Flags.SUMMARY, new BStatusNumeric(),null);
  
  /**
   * Get the <code>in10</code> property.
   * @see com.vykon.vykonPro.energy.BAggregateConsumption#in10
   */
  public BStatusNumeric getIn10() { return (BStatusNumeric)get(in10); }
  
  /**
   * Set the <code>in10</code> property.
   * @see com.vykon.vykonPro.energy.BAggregateConsumption#in10
   */
  public void setIn10(BStatusNumeric v) { set(in10,v,null); }

////////////////////////////////////////////////////////////////
// Action "calculate"
////////////////////////////////////////////////////////////////
  
  /**
   * Slot for the <code>calculate</code> action.
   * @see com.vykon.vykonPro.energy.BAggregateConsumption#calculate()
   */
  public static final Action calculate = newAction(Flags.HIDDEN,null);
  
  /**
   * Invoke the <code>calculate</code> action.
   * @see com.vykon.vykonPro.energy.BAggregateConsumption#calculate
   */
  public void calculate() { invoke(calculate,null,null); }

////////////////////////////////////////////////////////////////
// Action "resetTotal"
////////////////////////////////////////////////////////////////
  
  /**
   * Slot for the <code>resetTotal</code> action.
   * @see com.vykon.vykonPro.energy.BAggregateConsumption#resetTotal()
   */
  public static final Action resetTotal = newAction(0,null);
  
  /**
   * Invoke the <code>resetTotal</code> action.
   * @see com.vykon.vykonPro.energy.BAggregateConsumption#resetTotal
   */
  public void resetTotal() { invoke(resetTotal,null,null); }

////////////////////////////////////////////////////////////////
// Type
////////////////////////////////////////////////////////////////
  
  public Type getType() { return TYPE; }
  public static final Type TYPE = Sys.loadType(BAggregateConsumption.class);

/*+ ------------ END BAJA AUTO GENERATED CODE -------------- +*/

  public BFacets getSlotFacets(Slot slot)
  {
    if (slot.equals(total) || slot.getName().startsWith("in"))
      return getFacets();
    return super.getSlotFacets(slot);

  }
  
  public void changed(Property property, Context context) 
  {
    super.changed(property, context);
    if (!Sys.atSteadyState() || !isRunning())
      return;

    if (property == numberValues)
    {
      initNumberValues();
      //calculate();
    }
    else if (property.getName().startsWith("in"))
    {
      calculate();
    }
  }
  
  public void started()
  {
    initNumberValues();
    storeLastValues();
  }

  public void doCalculate()
  {
    double tot = 0d;
    double currentVal;
    double lastVal;
    BStatusNumeric sn;
    
    for(int i=1; i<=numValues; i++)
    {
      sn = getInStatusValue(i);
      if(sn.getStatus().isValid())
      {
        currentVal = sn.getValue();
        if(currentVal!=Double.NaN && currentVal!=Double.POSITIVE_INFINITY && currentVal!=Double.NEGATIVE_INFINITY)
        {
          lastVal = lastVals[i];
          if(lastVal != Double.NaN)
          {
            tot = tot + (currentVal - lastVal);
          }
          else
          {
            tot = tot + currentVal;
          }
          
          lastVals[i] = currentVal;
        }
      }
    }
    
    getTotal().setValue(getTotal().getValue() + tot);
    
  }
  
  public void doResetTotal()
  {
    getTotal().setValue(0);
    storeLastValues();
  }

  public final BStatusNumeric getInStatusValue(int select)
  {
    switch (select)
    {
      case 1:
        return getIn1();
      case 2:
        return getIn2();
      case 3:
        return getIn3();
      case 4:
        return getIn4();
      case 5:
        return getIn5();
      case 6:
        return getIn6();
      case 7:
        return getIn7();
      case 8:
        return getIn8();
      case 9:
        return getIn9();
      case 10:
        return getIn10();
    }
    return new BStatusNumeric();
  }
  
  private void storeLastValues()
  {
    for(int i=1; i<=10; i++)
    {
      BStatusNumeric value = getInStatusValue(i);
      double dval = value.getValue();
      
      if(!value.getStatus().isNull() && dval!=Double.NaN && dval!=Double.NEGATIVE_INFINITY && dval!=Double.POSITIVE_INFINITY)
        lastVals[i] = dval;
      else lastVals[i] = Double.NaN;
    } 
  }
  
  private void initNumberValues()
  {
    numValues = getNumberValues();
    int setFlags;
    for(int i = 1; i <= 10; i++)
    {
      if(i > numValues)
        setFlags = Flags.HIDDEN;
      else
        setFlags = Flags.SUMMARY;
      
      try 
      {
        setFlags(getSlot("in"+i), setFlags, null);
      } 
      catch(Exception e) 
      {
        
      }
    }
  }
  
  
  private int numValues = 2;
  private double[] lastVals = new double[11];
}
