package com.vykon.vykonPro.energy;

import javax.baja.sys.BAbsTime;
import javax.baja.sys.BFacets;
import javax.baja.sys.BStruct;
import javax.baja.sys.Flags;
import javax.baja.sys.Property;
import javax.baja.sys.Sys;
import javax.baja.sys.Type;

public class BDemandProperties
    extends BStruct
{
  /*-
   class BDemandProperties
   {
     properties
     {
       maxKw: double
         flags{ operator }
         default{[ 0 ]}
         slotfacets{[ MIN=0 ]}
         
       maxKwTimestamp: BAbsTime
         flags{ operator }
         default{[ BAbsTime.NULL ]}
         
       maxKwOffPeak: double
         flags{ operator }
         default{[ 0 ]}
         slotfacets{[ MIN=0 ]}
         
       maxKwOffPeakTimestamp: BAbsTime
         flags{ operator }
         default{[ BAbsTime.NULL ]}
         
       maxKwOnPeak: double
         flags{ operator }
         default{[ 0 ]}
         slotfacets{[ MIN=0 ]}
         
       maxKwOnPeakTimestamp: BAbsTime
         flags{ operator }
         default{[ BAbsTime.NULL ]}
         
       
     }
   }
   -*/
/*+ ------------ BEGIN BAJA AUTO GENERATED CODE ------------ +*/
/*@ $com.vykon.vykonPro.energy.BDemandProperties(2695334521)1.0$ @*/
/* Generated Fri Apr 16 09:40:42 EDT 2010 by Slot-o-Matic 2000 (c) Tridium, Inc. 2000 */

////////////////////////////////////////////////////////////////
// Property "maxKw"
////////////////////////////////////////////////////////////////
  
  /**
   * Slot for the <code>maxKw</code> property.
   * @see com.vykon.vykonPro.energy.BDemandProperties#getMaxKw
   * @see com.vykon.vykonPro.energy.BDemandProperties#setMaxKw
   */
  public static final Property maxKw = newProperty(Flags.OPERATOR, 0,BFacets.make(BFacets.MIN,0));
  
  /**
   * Get the <code>maxKw</code> property.
   * @see com.vykon.vykonPro.energy.BDemandProperties#maxKw
   */
  public double getMaxKw() { return getDouble(maxKw); }
  
  /**
   * Set the <code>maxKw</code> property.
   * @see com.vykon.vykonPro.energy.BDemandProperties#maxKw
   */
  public void setMaxKw(double v) { setDouble(maxKw,v,null); }

////////////////////////////////////////////////////////////////
// Property "maxKwTimestamp"
////////////////////////////////////////////////////////////////
  
  /**
   * Slot for the <code>maxKwTimestamp</code> property.
   * @see com.vykon.vykonPro.energy.BDemandProperties#getMaxKwTimestamp
   * @see com.vykon.vykonPro.energy.BDemandProperties#setMaxKwTimestamp
   */
  public static final Property maxKwTimestamp = newProperty(Flags.OPERATOR, BAbsTime.NULL,null);
  
  /**
   * Get the <code>maxKwTimestamp</code> property.
   * @see com.vykon.vykonPro.energy.BDemandProperties#maxKwTimestamp
   */
  public BAbsTime getMaxKwTimestamp() { return (BAbsTime)get(maxKwTimestamp); }
  
  /**
   * Set the <code>maxKwTimestamp</code> property.
   * @see com.vykon.vykonPro.energy.BDemandProperties#maxKwTimestamp
   */
  public void setMaxKwTimestamp(BAbsTime v) { set(maxKwTimestamp,v,null); }

////////////////////////////////////////////////////////////////
// Property "maxKwOffPeak"
////////////////////////////////////////////////////////////////
  
  /**
   * Slot for the <code>maxKwOffPeak</code> property.
   * @see com.vykon.vykonPro.energy.BDemandProperties#getMaxKwOffPeak
   * @see com.vykon.vykonPro.energy.BDemandProperties#setMaxKwOffPeak
   */
  public static final Property maxKwOffPeak = newProperty(Flags.OPERATOR, 0,BFacets.make(BFacets.MIN,0));
  
  /**
   * Get the <code>maxKwOffPeak</code> property.
   * @see com.vykon.vykonPro.energy.BDemandProperties#maxKwOffPeak
   */
  public double getMaxKwOffPeak() { return getDouble(maxKwOffPeak); }
  
  /**
   * Set the <code>maxKwOffPeak</code> property.
   * @see com.vykon.vykonPro.energy.BDemandProperties#maxKwOffPeak
   */
  public void setMaxKwOffPeak(double v) { setDouble(maxKwOffPeak,v,null); }

////////////////////////////////////////////////////////////////
// Property "maxKwOffPeakTimestamp"
////////////////////////////////////////////////////////////////
  
  /**
   * Slot for the <code>maxKwOffPeakTimestamp</code> property.
   * @see com.vykon.vykonPro.energy.BDemandProperties#getMaxKwOffPeakTimestamp
   * @see com.vykon.vykonPro.energy.BDemandProperties#setMaxKwOffPeakTimestamp
   */
  public static final Property maxKwOffPeakTimestamp = newProperty(Flags.OPERATOR, BAbsTime.NULL,null);
  
  /**
   * Get the <code>maxKwOffPeakTimestamp</code> property.
   * @see com.vykon.vykonPro.energy.BDemandProperties#maxKwOffPeakTimestamp
   */
  public BAbsTime getMaxKwOffPeakTimestamp() { return (BAbsTime)get(maxKwOffPeakTimestamp); }
  
  /**
   * Set the <code>maxKwOffPeakTimestamp</code> property.
   * @see com.vykon.vykonPro.energy.BDemandProperties#maxKwOffPeakTimestamp
   */
  public void setMaxKwOffPeakTimestamp(BAbsTime v) { set(maxKwOffPeakTimestamp,v,null); }

////////////////////////////////////////////////////////////////
// Property "maxKwOnPeak"
////////////////////////////////////////////////////////////////
  
  /**
   * Slot for the <code>maxKwOnPeak</code> property.
   * @see com.vykon.vykonPro.energy.BDemandProperties#getMaxKwOnPeak
   * @see com.vykon.vykonPro.energy.BDemandProperties#setMaxKwOnPeak
   */
  public static final Property maxKwOnPeak = newProperty(Flags.OPERATOR, 0,BFacets.make(BFacets.MIN,0));
  
  /**
   * Get the <code>maxKwOnPeak</code> property.
   * @see com.vykon.vykonPro.energy.BDemandProperties#maxKwOnPeak
   */
  public double getMaxKwOnPeak() { return getDouble(maxKwOnPeak); }
  
  /**
   * Set the <code>maxKwOnPeak</code> property.
   * @see com.vykon.vykonPro.energy.BDemandProperties#maxKwOnPeak
   */
  public void setMaxKwOnPeak(double v) { setDouble(maxKwOnPeak,v,null); }

////////////////////////////////////////////////////////////////
// Property "maxKwOnPeakTimestamp"
////////////////////////////////////////////////////////////////
  
  /**
   * Slot for the <code>maxKwOnPeakTimestamp</code> property.
   * @see com.vykon.vykonPro.energy.BDemandProperties#getMaxKwOnPeakTimestamp
   * @see com.vykon.vykonPro.energy.BDemandProperties#setMaxKwOnPeakTimestamp
   */
  public static final Property maxKwOnPeakTimestamp = newProperty(Flags.OPERATOR, BAbsTime.NULL,null);
  
  /**
   * Get the <code>maxKwOnPeakTimestamp</code> property.
   * @see com.vykon.vykonPro.energy.BDemandProperties#maxKwOnPeakTimestamp
   */
  public BAbsTime getMaxKwOnPeakTimestamp() { return (BAbsTime)get(maxKwOnPeakTimestamp); }
  
  /**
   * Set the <code>maxKwOnPeakTimestamp</code> property.
   * @see com.vykon.vykonPro.energy.BDemandProperties#maxKwOnPeakTimestamp
   */
  public void setMaxKwOnPeakTimestamp(BAbsTime v) { set(maxKwOnPeakTimestamp,v,null); }

////////////////////////////////////////////////////////////////
// Type
////////////////////////////////////////////////////////////////
  
  public Type getType() { return TYPE; }
  public static final Type TYPE = Sys.loadType(BDemandProperties.class);

/*+ ------------ END BAJA AUTO GENERATED CODE -------------- +*/

  public BDemandProperties()
  {
    
  }
  
  public BDemandProperties(double maxKw, BAbsTime peak, double maxKwOffPeak, BAbsTime peak1, double maxKwOnPeak, BAbsTime peak2)
  {
    setMaxKw(maxKw);
    setMaxKwTimestamp(peak);
    setMaxKwOffPeak(maxKwOffPeak);
    setMaxKwOffPeakTimestamp(peak1);
    setMaxKwOnPeak(maxKwOnPeak);
    setMaxKwOnPeakTimestamp(peak2);
  }

}
