package com.vykon.vykonPro.hvac;

import javax.baja.collection.BITable;
import javax.baja.collection.TableCursor;
import javax.baja.naming.BOrd;
import javax.baja.status.BStatus;
import javax.baja.status.BStatusBoolean;
import javax.baja.status.BStatusEnum;
import javax.baja.sys.Action;
import javax.baja.sys.BAbsTime;
import javax.baja.sys.BComponent;
import javax.baja.sys.BEnumRange;
import javax.baja.sys.BFacets;
import javax.baja.sys.BIcon;
import javax.baja.sys.BRelTime;
import javax.baja.sys.BString;
import javax.baja.sys.BValue;
import javax.baja.sys.Clock;
import javax.baja.sys.Context;
import javax.baja.sys.Cursor;
import javax.baja.sys.Flags;
import javax.baja.sys.Property;
import javax.baja.sys.Slot;
import javax.baja.sys.Sys;
import javax.baja.sys.Type;
import javax.baja.util.IFuture;
import javax.baja.util.Invocation;
import com.vykon.vykonPro.util.BVykonProService;
import javax.baja.sys.Subscriber;
import javax.baja.sys.BComponentEvent;

import java.util.ArrayList;

public class BEnumBql
    extends BComponent
{
  /*-
   class BBooleanBql
   {
     properties
     {
       status: BStatus
           -- The status of the component
           flags { readonly, transient }
           default {[ BStatus.ok ]}
           
      faultCause: String
           -- The fault cause.
           flags { readonly, transient }
           default {[ "" ]}
       
       enabled: boolean
         --Property used to enable or disable the component.
         default{[ true ]}
         slotfacets{[BFacets.makeBoolean("enabled", "disabled")]}
         
       pointQuery:BOrd
         -- bql qury to find components
         default{[ BOrd.NULL ]}
         
       numberOfPoints:int
         -- number of components found by query
         flags{ summary, readonly, transient }
         default{[ 0 ]}
       
       count:int
         -- number of components used in evaluating the orOut and andOut properties. This number may be
         -- less than the numberOfPoints if any of the components have an invalid status.
         flags{ summary, readonly, transient }
         default{[ 0 ]}
       
       matchFacets:BFacets
          -- The facets used in selecting the match values
          flags{ operator }
          default{[ BFacets.NULL ]}
          
       matchValues:BEnumRange
         -- The enum value to match against the components found using the bql query
         flags{ operator }
         default{[ BEnumRange.DEFAULT ]}
         slotfacets {[ BFacets.make(BFacets.FIELD_EDITOR, BString.make("alarm:EnumAlarmRangeFE")) ]}
       
       numberOfPointsMatching:int
         -- number of the processed components which have a matching enum ordinal
         flags{ summary, readonly, transient }
         default{[ 0 ]}
       
       facets:BFacets
         -- facets applied to the orOut and andOut max slots
         default{[ BFacets.NULL ]}
         
       orOut:BStatusBoolean
         -- logical or value of the components found by the query compared to the matchEnumValue
         flags{ summary, readonly, transient }
         default{[ new BStatusBoolean(false) ]}
       
       andOut:BStatusBoolean
         -- logical and value of the components found by the query compared to the matchEnumValue
         flags{ summary, readonly, transient }
         default{[ new BStatusBoolean(false) ]}
         
       updateValuesInterval:BRelTime
         -- the interval at which the values are processed and updated.
         flags{ operator }
         default{[ BRelTime.makeSeconds(15) ]}
         slotfacets {[ BFacets.make(BFacets.MIN,BRelTime.makeSeconds(1)) ]}
         
       refreshQueryInterval:BRelTime
         -- the interval at which the bql query is executed to update the array list of components
         flags{ operator }
         default{[ BRelTime.makeHours(12) ]}
         slotfacets {[ BFacets.make(BFacets.MIN,BRelTime.makeMinutes(1)) ]}
         
       startDelay:BRelTime
         -- the time after component start before the component list is initialized the first time.
         flags{ operator }
         default{[ BRelTime.makeMinutes(1) ]}
         slotfacets{[ BFacets.make(BFacets.MIN,BRelTime.makeSeconds(1)) ]}
         
       nextRefreshTime: BAbsTime
           -- the next time the component is scheduled to refresh the bql query
           flags{ hidden, readonly }
           default{[ BAbsTime.NULL ]}  
     }
     actions
     {
       calculate()
         flags{ hidden }
         
       initializeList()
                
       refreshQuery()
         flags{ async, hidden }
     }
     topics
     {
     }
     
   }
   -*/
/*+ ------------ BEGIN BAJA AUTO GENERATED CODE ------------ +*/
/*@ $com.vykon.vykonPro.hvac.BEnumBql(3176444530)1.0$ @*/
/* Generated Thu Aug 02 17:25:30 EDT 2012 by Slot-o-Matic 2000 (c) Tridium, Inc. 2000 */

////////////////////////////////////////////////////////////////
// Property "status"
////////////////////////////////////////////////////////////////
  
  /**
   * Slot for the <code>status</code> property.
   * The status of the component
   * @see com.vykon.vykonPro.hvac.BEnumBql#getStatus
   * @see com.vykon.vykonPro.hvac.BEnumBql#setStatus
   */
  public static final Property status = newProperty(Flags.READONLY|Flags.TRANSIENT, BStatus.ok,null);
  
  /**
   * Get the <code>status</code> property.
   * @see com.vykon.vykonPro.hvac.BEnumBql#status
   */
  public BStatus getStatus() { return (BStatus)get(status); }
  
  /**
   * Set the <code>status</code> property.
   * @see com.vykon.vykonPro.hvac.BEnumBql#status
   */
  public void setStatus(BStatus v) { set(status,v,null); }

////////////////////////////////////////////////////////////////
// Property "faultCause"
////////////////////////////////////////////////////////////////
  
  /**
   * Slot for the <code>faultCause</code> property.
   * The fault cause.
   * @see com.vykon.vykonPro.hvac.BEnumBql#getFaultCause
   * @see com.vykon.vykonPro.hvac.BEnumBql#setFaultCause
   */
  public static final Property faultCause = newProperty(Flags.READONLY|Flags.TRANSIENT, "",null);
  
  /**
   * Get the <code>faultCause</code> property.
   * @see com.vykon.vykonPro.hvac.BEnumBql#faultCause
   */
  public String getFaultCause() { return getString(faultCause); }
  
  /**
   * Set the <code>faultCause</code> property.
   * @see com.vykon.vykonPro.hvac.BEnumBql#faultCause
   */
  public void setFaultCause(String v) { setString(faultCause,v,null); }

////////////////////////////////////////////////////////////////
// Property "enabled"
////////////////////////////////////////////////////////////////
  
  /**
   * Slot for the <code>enabled</code> property.
   * Property used to enable or disable the component.
   * @see com.vykon.vykonPro.hvac.BEnumBql#getEnabled
   * @see com.vykon.vykonPro.hvac.BEnumBql#setEnabled
   */
  public static final Property enabled = newProperty(0, true,BFacets.makeBoolean("enabled", "disabled"));
  
  /**
   * Get the <code>enabled</code> property.
   * @see com.vykon.vykonPro.hvac.BEnumBql#enabled
   */
  public boolean getEnabled() { return getBoolean(enabled); }
  
  /**
   * Set the <code>enabled</code> property.
   * @see com.vykon.vykonPro.hvac.BEnumBql#enabled
   */
  public void setEnabled(boolean v) { setBoolean(enabled,v,null); }

////////////////////////////////////////////////////////////////
// Property "pointQuery"
////////////////////////////////////////////////////////////////
  
  /**
   * Slot for the <code>pointQuery</code> property.
   * bql qury to find components
   * @see com.vykon.vykonPro.hvac.BEnumBql#getPointQuery
   * @see com.vykon.vykonPro.hvac.BEnumBql#setPointQuery
   */
  public static final Property pointQuery = newProperty(0, BOrd.NULL,null);
  
  /**
   * Get the <code>pointQuery</code> property.
   * @see com.vykon.vykonPro.hvac.BEnumBql#pointQuery
   */
  public BOrd getPointQuery() { return (BOrd)get(pointQuery); }
  
  /**
   * Set the <code>pointQuery</code> property.
   * @see com.vykon.vykonPro.hvac.BEnumBql#pointQuery
   */
  public void setPointQuery(BOrd v) { set(pointQuery,v,null); }

////////////////////////////////////////////////////////////////
// Property "numberOfPoints"
////////////////////////////////////////////////////////////////
  
  /**
   * Slot for the <code>numberOfPoints</code> property.
   * number of components found by query
   * @see com.vykon.vykonPro.hvac.BEnumBql#getNumberOfPoints
   * @see com.vykon.vykonPro.hvac.BEnumBql#setNumberOfPoints
   */
  public static final Property numberOfPoints = newProperty(Flags.SUMMARY|Flags.READONLY|Flags.TRANSIENT, 0,null);
  
  /**
   * Get the <code>numberOfPoints</code> property.
   * @see com.vykon.vykonPro.hvac.BEnumBql#numberOfPoints
   */
  public int getNumberOfPoints() { return getInt(numberOfPoints); }
  
  /**
   * Set the <code>numberOfPoints</code> property.
   * @see com.vykon.vykonPro.hvac.BEnumBql#numberOfPoints
   */
  public void setNumberOfPoints(int v) { setInt(numberOfPoints,v,null); }

////////////////////////////////////////////////////////////////
// Property "count"
////////////////////////////////////////////////////////////////
  
  /**
   * Slot for the <code>count</code> property.
   * number of components used in evaluating the orOut and andOut properties. This number may be less than the numberOfPoints if any of the components have an invalid status.
   * @see com.vykon.vykonPro.hvac.BEnumBql#getCount
   * @see com.vykon.vykonPro.hvac.BEnumBql#setCount
   */
  public static final Property count = newProperty(Flags.SUMMARY|Flags.READONLY|Flags.TRANSIENT, 0,null);
  
  /**
   * Get the <code>count</code> property.
   * @see com.vykon.vykonPro.hvac.BEnumBql#count
   */
  public int getCount() { return getInt(count); }
  
  /**
   * Set the <code>count</code> property.
   * @see com.vykon.vykonPro.hvac.BEnumBql#count
   */
  public void setCount(int v) { setInt(count,v,null); }

////////////////////////////////////////////////////////////////
// Property "matchFacets"
////////////////////////////////////////////////////////////////
  
  /**
   * Slot for the <code>matchFacets</code> property.
   * The facets used in selecting the match values
   * @see com.vykon.vykonPro.hvac.BEnumBql#getMatchFacets
   * @see com.vykon.vykonPro.hvac.BEnumBql#setMatchFacets
   */
  public static final Property matchFacets = newProperty(Flags.OPERATOR, BFacets.NULL,null);
  
  /**
   * Get the <code>matchFacets</code> property.
   * @see com.vykon.vykonPro.hvac.BEnumBql#matchFacets
   */
  public BFacets getMatchFacets() { return (BFacets)get(matchFacets); }
  
  /**
   * Set the <code>matchFacets</code> property.
   * @see com.vykon.vykonPro.hvac.BEnumBql#matchFacets
   */
  public void setMatchFacets(BFacets v) { set(matchFacets,v,null); }

////////////////////////////////////////////////////////////////
// Property "matchValues"
////////////////////////////////////////////////////////////////
  
  /**
   * Slot for the <code>matchValues</code> property.
   * The enum value to match against the components found
   * using the bql query
   * @see com.vykon.vykonPro.hvac.BEnumBql#getMatchValues
   * @see com.vykon.vykonPro.hvac.BEnumBql#setMatchValues
   */
  public static final Property matchValues = newProperty(Flags.OPERATOR, BEnumRange.DEFAULT,BFacets.make(BFacets.FIELD_EDITOR, BString.make("alarm:EnumAlarmRangeFE")));
  
  /**
   * Get the <code>matchValues</code> property.
   * @see com.vykon.vykonPro.hvac.BEnumBql#matchValues
   */
  public BEnumRange getMatchValues() { return (BEnumRange)get(matchValues); }
  
  /**
   * Set the <code>matchValues</code> property.
   * @see com.vykon.vykonPro.hvac.BEnumBql#matchValues
   */
  public void setMatchValues(BEnumRange v) { set(matchValues,v,null); }

////////////////////////////////////////////////////////////////
// Property "numberOfPointsMatching"
////////////////////////////////////////////////////////////////
  
  /**
   * Slot for the <code>numberOfPointsMatching</code> property.
   * number of the processed components which have a matching
   * enum ordinal
   * @see com.vykon.vykonPro.hvac.BEnumBql#getNumberOfPointsMatching
   * @see com.vykon.vykonPro.hvac.BEnumBql#setNumberOfPointsMatching
   */
  public static final Property numberOfPointsMatching = newProperty(Flags.SUMMARY|Flags.READONLY|Flags.TRANSIENT, 0,null);
  
  /**
   * Get the <code>numberOfPointsMatching</code> property.
   * @see com.vykon.vykonPro.hvac.BEnumBql#numberOfPointsMatching
   */
  public int getNumberOfPointsMatching() { return getInt(numberOfPointsMatching); }
  
  /**
   * Set the <code>numberOfPointsMatching</code> property.
   * @see com.vykon.vykonPro.hvac.BEnumBql#numberOfPointsMatching
   */
  public void setNumberOfPointsMatching(int v) { setInt(numberOfPointsMatching,v,null); }

////////////////////////////////////////////////////////////////
// Property "facets"
////////////////////////////////////////////////////////////////
  
  /**
   * Slot for the <code>facets</code> property.
   * facets applied to the orOut and andOut max slots
   * @see com.vykon.vykonPro.hvac.BEnumBql#getFacets
   * @see com.vykon.vykonPro.hvac.BEnumBql#setFacets
   */
  public static final Property facets = newProperty(0, BFacets.NULL,null);
  
  /**
   * Get the <code>facets</code> property.
   * @see com.vykon.vykonPro.hvac.BEnumBql#facets
   */
  public BFacets getFacets() { return (BFacets)get(facets); }
  
  /**
   * Set the <code>facets</code> property.
   * @see com.vykon.vykonPro.hvac.BEnumBql#facets
   */
  public void setFacets(BFacets v) { set(facets,v,null); }

////////////////////////////////////////////////////////////////
// Property "orOut"
////////////////////////////////////////////////////////////////
  
  /**
   * Slot for the <code>orOut</code> property.
   * logical or value of the components found by the query
   * compared to the matchEnumValue
   * @see com.vykon.vykonPro.hvac.BEnumBql#getOrOut
   * @see com.vykon.vykonPro.hvac.BEnumBql#setOrOut
   */
  public static final Property orOut = newProperty(Flags.SUMMARY|Flags.READONLY|Flags.TRANSIENT, new BStatusBoolean(false),null);
  
  /**
   * Get the <code>orOut</code> property.
   * @see com.vykon.vykonPro.hvac.BEnumBql#orOut
   */
  public BStatusBoolean getOrOut() { return (BStatusBoolean)get(orOut); }
  
  /**
   * Set the <code>orOut</code> property.
   * @see com.vykon.vykonPro.hvac.BEnumBql#orOut
   */
  public void setOrOut(BStatusBoolean v) { set(orOut,v,null); }

////////////////////////////////////////////////////////////////
// Property "andOut"
////////////////////////////////////////////////////////////////
  
  /**
   * Slot for the <code>andOut</code> property.
   * logical and value of the components found by the query
   * compared to the matchEnumValue
   * @see com.vykon.vykonPro.hvac.BEnumBql#getAndOut
   * @see com.vykon.vykonPro.hvac.BEnumBql#setAndOut
   */
  public static final Property andOut = newProperty(Flags.SUMMARY|Flags.READONLY|Flags.TRANSIENT, new BStatusBoolean(false),null);
  
  /**
   * Get the <code>andOut</code> property.
   * @see com.vykon.vykonPro.hvac.BEnumBql#andOut
   */
  public BStatusBoolean getAndOut() { return (BStatusBoolean)get(andOut); }
  
  /**
   * Set the <code>andOut</code> property.
   * @see com.vykon.vykonPro.hvac.BEnumBql#andOut
   */
  public void setAndOut(BStatusBoolean v) { set(andOut,v,null); }

////////////////////////////////////////////////////////////////
// Property "updateValuesInterval"
////////////////////////////////////////////////////////////////
  
  /**
   * Slot for the <code>updateValuesInterval</code> property.
   * the interval at which the values are processed and
   * updated.
   * @see com.vykon.vykonPro.hvac.BEnumBql#getUpdateValuesInterval
   * @see com.vykon.vykonPro.hvac.BEnumBql#setUpdateValuesInterval
   */
  public static final Property updateValuesInterval = newProperty(Flags.OPERATOR, BRelTime.makeSeconds(15),BFacets.make(BFacets.MIN,BRelTime.makeSeconds(1)));
  
  /**
   * Get the <code>updateValuesInterval</code> property.
   * @see com.vykon.vykonPro.hvac.BEnumBql#updateValuesInterval
   */
  public BRelTime getUpdateValuesInterval() { return (BRelTime)get(updateValuesInterval); }
  
  /**
   * Set the <code>updateValuesInterval</code> property.
   * @see com.vykon.vykonPro.hvac.BEnumBql#updateValuesInterval
   */
  public void setUpdateValuesInterval(BRelTime v) { set(updateValuesInterval,v,null); }

////////////////////////////////////////////////////////////////
// Property "refreshQueryInterval"
////////////////////////////////////////////////////////////////
  
  /**
   * Slot for the <code>refreshQueryInterval</code> property.
   * the interval at which the bql query is executed to
   * update the array list of components
   * @see com.vykon.vykonPro.hvac.BEnumBql#getRefreshQueryInterval
   * @see com.vykon.vykonPro.hvac.BEnumBql#setRefreshQueryInterval
   */
  public static final Property refreshQueryInterval = newProperty(Flags.OPERATOR, BRelTime.makeHours(12),BFacets.make(BFacets.MIN,BRelTime.makeMinutes(1)));
  
  /**
   * Get the <code>refreshQueryInterval</code> property.
   * @see com.vykon.vykonPro.hvac.BEnumBql#refreshQueryInterval
   */
  public BRelTime getRefreshQueryInterval() { return (BRelTime)get(refreshQueryInterval); }
  
  /**
   * Set the <code>refreshQueryInterval</code> property.
   * @see com.vykon.vykonPro.hvac.BEnumBql#refreshQueryInterval
   */
  public void setRefreshQueryInterval(BRelTime v) { set(refreshQueryInterval,v,null); }

////////////////////////////////////////////////////////////////
// Property "startDelay"
////////////////////////////////////////////////////////////////
  
  /**
   * Slot for the <code>startDelay</code> property.
   * the time after component start before the component
   * list is initialized the first time.
   * @see com.vykon.vykonPro.hvac.BEnumBql#getStartDelay
   * @see com.vykon.vykonPro.hvac.BEnumBql#setStartDelay
   */
  public static final Property startDelay = newProperty(Flags.OPERATOR, BRelTime.makeMinutes(1),BFacets.make(BFacets.MIN,BRelTime.makeSeconds(1)));
  
  /**
   * Get the <code>startDelay</code> property.
   * @see com.vykon.vykonPro.hvac.BEnumBql#startDelay
   */
  public BRelTime getStartDelay() { return (BRelTime)get(startDelay); }
  
  /**
   * Set the <code>startDelay</code> property.
   * @see com.vykon.vykonPro.hvac.BEnumBql#startDelay
   */
  public void setStartDelay(BRelTime v) { set(startDelay,v,null); }

////////////////////////////////////////////////////////////////
// Property "nextRefreshTime"
////////////////////////////////////////////////////////////////
  
  /**
   * Slot for the <code>nextRefreshTime</code> property.
   * the next time the component is scheduled to refresh
   * the bql query
   * @see com.vykon.vykonPro.hvac.BEnumBql#getNextRefreshTime
   * @see com.vykon.vykonPro.hvac.BEnumBql#setNextRefreshTime
   */
  public static final Property nextRefreshTime = newProperty(Flags.HIDDEN|Flags.READONLY, BAbsTime.NULL,null);
  
  /**
   * Get the <code>nextRefreshTime</code> property.
   * @see com.vykon.vykonPro.hvac.BEnumBql#nextRefreshTime
   */
  public BAbsTime getNextRefreshTime() { return (BAbsTime)get(nextRefreshTime); }
  
  /**
   * Set the <code>nextRefreshTime</code> property.
   * @see com.vykon.vykonPro.hvac.BEnumBql#nextRefreshTime
   */
  public void setNextRefreshTime(BAbsTime v) { set(nextRefreshTime,v,null); }

////////////////////////////////////////////////////////////////
// Action "calculate"
////////////////////////////////////////////////////////////////
  
  /**
   * Slot for the <code>calculate</code> action.
   * @see com.vykon.vykonPro.hvac.BEnumBql#calculate()
   */
  public static final Action calculate = newAction(Flags.HIDDEN,null);
  
  /**
   * Invoke the <code>calculate</code> action.
   * @see com.vykon.vykonPro.hvac.BEnumBql#calculate
   */
  public void calculate() { invoke(calculate,null,null); }

////////////////////////////////////////////////////////////////
// Action "initializeList"
////////////////////////////////////////////////////////////////
  
  /**
   * Slot for the <code>initializeList</code> action.
   * @see com.vykon.vykonPro.hvac.BEnumBql#initializeList()
   */
  public static final Action initializeList = newAction(0,null);
  
  /**
   * Invoke the <code>initializeList</code> action.
   * @see com.vykon.vykonPro.hvac.BEnumBql#initializeList
   */
  public void initializeList() { invoke(initializeList,null,null); }

////////////////////////////////////////////////////////////////
// Action "refreshQuery"
////////////////////////////////////////////////////////////////
  
  /**
   * Slot for the <code>refreshQuery</code> action.
   * @see com.vykon.vykonPro.hvac.BEnumBql#refreshQuery()
   */
  public static final Action refreshQuery = newAction(Flags.ASYNC|Flags.HIDDEN,null);
  
  /**
   * Invoke the <code>refreshQuery</code> action.
   * @see com.vykon.vykonPro.hvac.BEnumBql#refreshQuery
   */
  public void refreshQuery() { invoke(refreshQuery,null,null); }

////////////////////////////////////////////////////////////////
// Type
////////////////////////////////////////////////////////////////
  
  public Type getType() { return TYPE; }
  public static final Type TYPE = Sys.loadType(BEnumBql.class);

/*+ ------------ END BAJA AUTO GENERATED CODE -------------- +*/

  public void started()
  {
    checkForService();
    
    if(getEnabled() && getStatus().isOk())
    {
      //creates a list of components from the bql query
      //initializeList();
      initStartTicket();
      
      initClockTicket();  //periodically refreshes list of components
      initCalcTicket();   //periodically upates outputs
    }

    sub = new MySub();
  }

  public void stopped()
  {
    if (ticket != null) ticket.cancel();
    if (calcTicket != null) calcTicket.cancel();
    if (startTicket != null) startTicket.cancel();

    if(sub!=null)
    {
      sub.unsubscribeAll();
      sub=null;
    }
  }
  
  private final void checkForService()
  {
    if(BVykonProService.getInstance()==null)
    {
      setStatus(BStatus.fault);
      setFaultCause("This component requires the VykonPro service in the station");
    }
    else if(BVykonProService.getInstance().isDisabled())
    {
      setStatus(BStatus.fault);
      setFaultCause("The vykonPro service is disabled");
    }
    else
    {
      setStatus(BStatus.ok);
      setFaultCause("");
    }
  }
  
  public BFacets getSlotFacets(Slot slot)
  {
    if (slot.equals(orOut) || slot.equals(andOut))
      return getFacets();
    
    if (slot.equals(matchValues))
      return BFacets.make(getMatchFacets(), super.getSlotFacets(slot));
    
    return super.getSlotFacets(slot);

  }
  
  public void clockChanged(BRelTime value)
  {
    if(getEnabled())
    {
      initClockTicket();
      initCalcTicket();
    }
  }
  
  public void changed(Property property, Context context) 
  {
    super.changed(property, context);
    if( !Sys.atSteadyState() || !isRunning() )
     return;
    
    if(property.equals(pointQuery)) initializeList();
    
    if (getEnabled())
    {
      if (property.equals(refreshQueryInterval))
      {  
        refreshChanged = true;
        initClockTicket();
      }  
      else if (property.equals(updateValuesInterval))
        initCalcTicket();
    }
    
    if(property.equals(enabled))
    {
      if(getEnabled())
      {
        //transitioned from disabled to enabled so build component list and start tickets
        initializeList();
        calculate();
        initClockTicket();  //periodically refreshes list of components
      }
      else
      {
        //transitioned from enabled to disabled so cancel tickets
        if (ticket != null) ticket.cancel();
        if (calcTicket != null) calcTicket.cancel();
      }
    }
  }
  
  public IFuture post(Action action, BValue argument, Context cx)
  {
    if(action == refreshQuery)
      return BVykonProService.getInstance().getWorker().post(new Invocation(this, action, argument, cx));
    else
      return super.post(action, argument, cx);
  }
  
  public void doInitializeList()
  {
    if(!getEnabled()) return;
    if(!getStatus().isOk())
    {
      checkForService();
      if(!getStatus().isOk()) return;
    }
    
    if(startTicket != null) startTicket.cancel();
        
    //check that the pointQuery has something in it
    if(getPointQuery().isNull())
    {
      //set the fault status and cause
      setStatus(BStatus.fault);
      setFaultCause("must specify a point query");
      return;
    }
    else
    {
      //point query is specified, status is ok
      setStatus(BStatus.ok);
      setFaultCause("");
    }
        
    refreshQuery();
  }
  
  private void initStartTicket()
  {
    if(startTicket != null) startTicket.cancel();
    startTicket = Clock.schedule(this, getStartDelay(), initializeList, null);
  }
  
  void initClockTicket()
  {            
    /*
     * 8/1/2012 added nextRefreshTime property to latch when the next query is to be
     * performed. When clock was changing it kept pushing this out and the refresh was
     * never happening.
     */
    BAbsTime next = getNextRefreshTime();
    if(refreshChanged)
    {
      refreshChanged = false;
      next = BAbsTime.NULL;
    }
    
    BAbsTime current = Clock.time();
    
    if(next==BAbsTime.NULL)
    {
      // have never scheduled a refresh
      setNextRefreshTime(current.add(getRefreshQueryInterval()));
      next = getNextRefreshTime();
    }
    else if(current.isAfter(next))
    {
      // we are past last refresh time, so bump time until in future
      while(next.isBefore(current))
        next = next.add(getRefreshQueryInterval());
        
      setNextRefreshTime(next);
    }
    else
    {
      if(current.add(getRefreshQueryInterval()).isBefore(getNextRefreshTime()))
        setNextRefreshTime(current.add(getRefreshQueryInterval()));
    }
    
    if (ticket != null) ticket.cancel();
    //ticket = Clock.schedule(this, getRefreshQueryInterval(), refreshQuery, null);
    ticket = Clock.schedulePeriodically(this, next, getRefreshQueryInterval(), refreshQuery, null);
  }
  
  void initCalcTicket()
  {
    if (calcTicket != null) calcTicket.cancel();
    BRelTime interval = getUpdateValuesInterval().getMillis()>=BRelTime.MILLIS_IN_SECOND ? getUpdateValuesInterval() : DEF_TIME;
    calcTicket = Clock.schedule(this, interval, calculate, null);
  }
  
  public void doCalculate() throws Exception
  {
    if(!getEnabled()) return;
    if(!getStatus().isOk())
    {
      checkForService();
      if(!getStatus().isOk()) return;
    }
    
    if(getPointQuery().isNull()) 
    {  
      initCalcTicket();
      return;
    }
    
    if(result==null)
    {
      //we haven't gotten the list back yet from the refreshQuery method
      //so just reset the timer and return
      initCalcTicket();
	  
	  // check if ticket is null or nextRefreshTime is in past...need to update ticket and
      // refresh query
      BAbsTime current = Clock.time();
      if(ticket==null || getNextRefreshTime().isBefore(current))
      {
        refreshQuery();
        initClockTicket();
      }
	  
      return;
    }
    
    //initialize values for each execution
    int totalTrue=0;
    int num = 0;
    
    //call timer to setup next execution
    initCalcTicket();


    BComponent comp;
    BStatusEnum b;
    int[] match = getMatchValues().getOrdinals();

    for(int i=0; i<myComps.size(); i++)
    {
      comp = (BComponent) myComps.get(i);
      if (comp.get("out") != null && comp.get("out").getType().is(BStatusEnum.TYPE))
      {
        // lease the component to subscribe it
        if (!comp.isSubscribed()) sub.subscribe(comp);

        b = (BStatusEnum)comp.get("out");
        if(b.getStatus().isValid())
        {
          num++;
          for(int j=0; j< match.length; j++)
          {
            if(b.getEnum().getOrdinal()==match[j])
            {
              totalTrue = totalTrue+1;
              break;
            }
          }
        }
      }
    }

    /*
        try(Cursor cursor = result.cursor())
    {
      BComponent comp;
      BStatusEnum b;
      int[] match = getMatchValues().getOrdinals();

      while(cursor.next())
      {
        comp = (BComponent)cursor.get();
        if(comp.get("out")!=null && comp.get("out").getType().is(BStatusEnum.TYPE))
        {
          comp.lease(0, getUpdateValuesInterval().getMillis()+5000);

          b = (BStatusEnum)comp.get("out");
          if(b.getStatus().isValid())
          {
            num++;
            for(int j=0; j< match.length; j++)
            {
              if(b.getEnum().getOrdinal()==match[j])
              {
                totalTrue = totalTrue+1;
                break;
              }
            }
          }
        }
      }
    }
    catch(Exception e)
    {
      System.out.println(this.getSlotPath() + " - error calculating values");
      System.out.println(e);
    }
    */

    setNumberOfPointsMatching(totalTrue);
    setCount(num);
    
    if(totalTrue>0) getOrOut().setValue(true);
    else getOrOut().setValue(false);
    
    //if(totalTrue==getNumberOfPoints()) getAndOut().setValue(true);
    if(totalTrue==num) getAndOut().setValue(true);
    else getAndOut().setValue(false);
  }
  
  public void doRefreshQuery()
  {
    result = (BITable)getPointQuery().get();
    myComps = new ArrayList<BComponent>();

    setNextRefreshTime(getNextRefreshTime().add(getRefreshQueryInterval()));
    int count = 0;
    try(TableCursor c = result.cursor())
    {
      while(c.next())
      {
        count = count + 1;
        myComps.add((BComponent) c.get());
      }
    }
    catch(Exception e)
    {
      System.out.println(getSlotPath() + " - error trying to refresh the query");
      System.out.println(e);
    }

    setNumberOfPoints(count);
  }


  /**
   * Get the icon.
   */
  public BIcon getIcon()
  {
    return icon;
  }

  private static final BIcon icon = BIcon.std("control/enumPoint.png");

  protected class MySub extends Subscriber
  {
    public void event(BComponentEvent event)
    {
      // don't do anything
    }

  }
  
///////////////////////////////////////////////////////////////////////////
// local variables
///////////////////////////////////////////////////////////////////////////
  
  Clock.Ticket ticket;
  Clock.Ticket calcTicket;
  Clock.Ticket startTicket;
  BITable result = null;
  boolean refreshChanged = false;
  MySub sub = null;
  ArrayList myComps = null;
  private static BRelTime DEF_TIME = BRelTime.makeSeconds(15);
}
