package com.vykon.vykonPro.hvac;

import javax.baja.collection.BITable;
import javax.baja.collection.TableCursor;
import javax.baja.naming.BOrd;
import javax.baja.naming.SlotPath;
import javax.baja.status.BStatus;
import javax.baja.status.BStatusNumeric;
import javax.baja.sys.BComponent;
import javax.baja.sys.BAbsTime;
import javax.baja.sys.Clock;
import javax.baja.sys.BDouble;
import javax.baja.sys.BFacets;
import javax.baja.sys.BString;
import javax.baja.sys.Cursor;
import javax.baja.sys.Flags;
import javax.baja.sys.Property;
import javax.baja.sys.Slot;
import javax.baja.sys.Sys;
import javax.baja.sys.Type;
import javax.baja.sys.Subscriber;
import javax.baja.sys.BComponentEvent;

import java.util.ArrayList;

public class BMinMaxAvgBqlWithLimits
    extends BMinMaxAvgBql
{
  /*-
   class BMinMaxAvgBqlWithLimits
   {
     properties
     {
       upperLimit: BStatusNumeric
         -- The upper limit used when evaluating a zone's compliance.
         default{[ new BStatusNumeric(80) ]}
         flags{ operator }

       lowerLimit: BStatusNumeric
         -- The lower limit used when evaluating a zone's compliance.
         default{[ new BStatusNumeric(60) ]}
         flags{ operator }

       excludeValues: boolean
         -- If excludeValues = true, any values > upperLimit or values < lowerLimit are
         -- excluded from the calculation for min, max, avg and count
         default{[ false ]}
         flags{ operator }
         slotfacets{[BFacets.makeBoolean("exclude values", "include values")]}

       outOfRangeZones: BZoneListExt
         default{[ new BZoneListExt() ]}
         flags{ readonly }
     }
     actions
     {
     }
     topics
     {
     }
   }
   -*/
/*+ ------------ BEGIN BAJA AUTO GENERATED CODE ------------ +*/
/*@ $com.vykon.vykonPro.hvac.BMinMaxAvgBqlWithLimits(2128266041)1.0$ @*/
/* Generated Fri Oct 26 16:09:59 EDT 2012 by Slot-o-Matic 2000 (c) Tridium, Inc. 2000 */

////////////////////////////////////////////////////////////////
// Property "upperLimit"
////////////////////////////////////////////////////////////////
  
  /**
   * Slot for the <code>upperLimit</code> property.
   * The upper limit used when evaluating a zone's compliance.
   * @see com.vykon.vykonPro.hvac.BMinMaxAvgBqlWithLimits#getUpperLimit
   * @see com.vykon.vykonPro.hvac.BMinMaxAvgBqlWithLimits#setUpperLimit
   */
  public static final Property upperLimit = newProperty(Flags.OPERATOR, new BStatusNumeric(80),null);
  
  /**
   * Get the <code>upperLimit</code> property.
   * @see com.vykon.vykonPro.hvac.BMinMaxAvgBqlWithLimits#upperLimit
   */
  public BStatusNumeric getUpperLimit() { return (BStatusNumeric)get(upperLimit); }
  
  /**
   * Set the <code>upperLimit</code> property.
   * @see com.vykon.vykonPro.hvac.BMinMaxAvgBqlWithLimits#upperLimit
   */
  public void setUpperLimit(BStatusNumeric v) { set(upperLimit,v,null); }

////////////////////////////////////////////////////////////////
// Property "lowerLimit"
////////////////////////////////////////////////////////////////
  
  /**
   * Slot for the <code>lowerLimit</code> property.
   * The lower limit used when evaluating a zone's compliance.
   * @see com.vykon.vykonPro.hvac.BMinMaxAvgBqlWithLimits#getLowerLimit
   * @see com.vykon.vykonPro.hvac.BMinMaxAvgBqlWithLimits#setLowerLimit
   */
  public static final Property lowerLimit = newProperty(Flags.OPERATOR, new BStatusNumeric(60),null);
  
  /**
   * Get the <code>lowerLimit</code> property.
   * @see com.vykon.vykonPro.hvac.BMinMaxAvgBqlWithLimits#lowerLimit
   */
  public BStatusNumeric getLowerLimit() { return (BStatusNumeric)get(lowerLimit); }
  
  /**
   * Set the <code>lowerLimit</code> property.
   * @see com.vykon.vykonPro.hvac.BMinMaxAvgBqlWithLimits#lowerLimit
   */
  public void setLowerLimit(BStatusNumeric v) { set(lowerLimit,v,null); }

////////////////////////////////////////////////////////////////
// Property "excludeValues"
////////////////////////////////////////////////////////////////
  
  /**
   * Slot for the <code>excludeValues</code> property.
   * If excludeValues = true, any values > upperLimit or
   * values < lowerLimit are excluded from the calculation
   * for min, max, avg and count
   * @see com.vykon.vykonPro.hvac.BMinMaxAvgBqlWithLimits#getExcludeValues
   * @see com.vykon.vykonPro.hvac.BMinMaxAvgBqlWithLimits#setExcludeValues
   */
  public static final Property excludeValues = newProperty(Flags.OPERATOR, false,BFacets.makeBoolean("exclude values", "include values"));
  
  /**
   * Get the <code>excludeValues</code> property.
   * @see com.vykon.vykonPro.hvac.BMinMaxAvgBqlWithLimits#excludeValues
   */
  public boolean getExcludeValues() { return getBoolean(excludeValues); }
  
  /**
   * Set the <code>excludeValues</code> property.
   * @see com.vykon.vykonPro.hvac.BMinMaxAvgBqlWithLimits#excludeValues
   */
  public void setExcludeValues(boolean v) { setBoolean(excludeValues,v,null); }

////////////////////////////////////////////////////////////////
// Property "outOfRangeZones"
////////////////////////////////////////////////////////////////
  
  /**
   * Slot for the <code>outOfRangeZones</code> property.
   * @see com.vykon.vykonPro.hvac.BMinMaxAvgBqlWithLimits#getOutOfRangeZones
   * @see com.vykon.vykonPro.hvac.BMinMaxAvgBqlWithLimits#setOutOfRangeZones
   */
  public static final Property outOfRangeZones = newProperty(Flags.READONLY, new BZoneListExt(),null);
  
  /**
   * Get the <code>outOfRangeZones</code> property.
   * @see com.vykon.vykonPro.hvac.BMinMaxAvgBqlWithLimits#outOfRangeZones
   */
  public BZoneListExt getOutOfRangeZones() { return (BZoneListExt)get(outOfRangeZones); }
  
  /**
   * Set the <code>outOfRangeZones</code> property.
   * @see com.vykon.vykonPro.hvac.BMinMaxAvgBqlWithLimits#outOfRangeZones
   */
  public void setOutOfRangeZones(BZoneListExt v) { set(outOfRangeZones,v,null); }

////////////////////////////////////////////////////////////////
// Type
////////////////////////////////////////////////////////////////
  
  public Type getType() { return TYPE; }
  public static final Type TYPE = Sys.loadType(BMinMaxAvgBqlWithLimits.class);

/*+ ------------ END BAJA AUTO GENERATED CODE -------------- +*/

  public void started()
  {
    zoneExt = this.getOutOfRangeZones();
    sub = new MySub();
    super.started();
  }

  public void stopped()
  {
    super.stopped();

    if(sub!=null)
    {
      sub.unsubscribeAll();
      sub=null;
    }
  }

  public BFacets getSlotFacets(Slot slot)
  {
    if (slot.equals(upperLimit) || slot.equals(lowerLimit) )
      return getFacets();
    return super.getSlotFacets(slot);

  }

  public void doCalculate() throws Exception
  {
    if(!getEnabled()) return;
    if(!getStatus().isOk())
    {
      checkForService();
      if(!getStatus().isOk()) return;
    }

    if(getPointQuery().isNull())
    {
      initCalcTicket();
      return;
    }

    if(result==null)
    {
      //we haven't gotten the list back yet from the refreshQuery method
      //so just reset the timer and return
      initCalcTicket();
	  
	  // check if ticket is null or nextRefreshTime is in past...need to update ticket and
      // refresh query
      BAbsTime current = Clock.time();
      if(ticket==null || getNextRefreshTime().isBefore(current))
      {
        refreshQuery();
        initClockTicket();
      }
	  
      return;
    }

    //initialize values for each execution
    int num=0;
    double avg=0;
    double min=Double.POSITIVE_INFINITY;
    double max=Double.NEGATIVE_INFINITY;
    String minZ="";
    String maxZ="";

    int validCount=0;
    int oorCount = 0;
    double upper = getUpperLimit().getValue();
    double lower = getLowerLimit().getValue();

    BOrd hypOrd = ((BZoneListExt)zoneExt).getHyperlink();

    //call timer to setup next execution
    initCalcTicket();

    BComponent comp;
    BStatusNumeric n;
    double nValue;
    String name, compName;

    for(int i=0; i<myComps.size(); i++)
    {
      comp = (BComponent)myComps.get(i);
      if(comp.get("out")!=null && comp.get("out").getType().is(BStatusNumeric.TYPE))
      {
        // lease the component to subscribe it
        if(!comp.isSubscribed()) sub.subscribe(comp);

        n = (BStatusNumeric)comp.get("out");
        if(n.getStatus().isValid() && BDouble.make(n.getValue())!=BDouble.NaN)
        {
          nValue = n.getValue();

          validCount++;
          name = getZoneIdentifierFormat().format(comp);
          compName = SlotPath.escape(name + "_" + comp.getName());

          //check if zone should be excluded lowerLimit < nValue < upperLimit
          if(nValue<lower || nValue>upper)
          {
            oorCount++;

            //add zoneInfo if it doesn't already exist
            if(zoneExt.get(compName)==null)
            {
              BOrd nord = BOrd.make("station:|" + comp.getSlotPathOrd());

              if(hypOrd != BOrd.NULL && hypOrd != BOrd.DEFAULT)
              {
                nord = BOrd.make(nord, hypOrd).normalize();
              }

              BZoneInfo zi = new BZoneInfo(name,(BStatusNumeric) n.newCopy(),nord, getFacets());
              zoneExt.add(compName, zi,Flags.TRANSIENT);
            }
            else
            {
              //zoneInfo exists so update it
              BZoneInfo zi = (BZoneInfo) zoneExt.get(compName);
              zi.setOut((BStatusNumeric) n.newCopy());
            }
          }
          else  //value is within limits so remove from list if there
          {
            if(zoneExt.get(compName)!=null) zoneExt.remove(compName);
          }

          //check to see if excluding value not within limits
          if(getExcludeValues()==true)
          {
            //check if zone should be excluded lowerLimit < nValue < upperLimit
            if(nValue<lower || nValue>upper)
            {
              continue;
            }
          }

          if (nValue < min)
          {
            min = nValue;
            minZ = getZoneIdentifierFormat().format(comp);
          }

          if (nValue > max)
          {
            max = nValue;
            maxZ = getZoneIdentifierFormat().format(comp);
          }

          avg = avg + nValue;
          num++;
        }
      }
    }

    getMinZoneIdentifier().setValue(minZ);
    getMaxZoneIdentifier().setValue(maxZ);

    if(min == Double.POSITIVE_INFINITY) min = Double.NaN;
    if(max == Double.NEGATIVE_INFINITY) min = Double.NaN;

    if (num != 0)
    {
      getSum().setValue(avg);
      getAvg().setValue(avg/num);
      if(getAvg().getStatus().isNull()) getAvg().setStatus(BStatus.ok);
      if(getSum().getStatus().isNull()) getSum().setStatus(BStatus.ok);
    }
    else
    {
      getSum().setStatus(BStatus.NULL);
      getAvg().setStatus(BStatus.NULL);
    }

    setCount(num);
    getMin().setValue(min);
    getMax().setValue(max);

    String s = oorCount + " of " + validCount + " zones out of range";
    zoneExt.set(zoneExt.getProperty("out"), BString.make(s));

  }

  public void doRefreshQuery()
  {
    result = (BITable)getPointQuery().get();
    myComps = new ArrayList<BComponent>();

    zoneExt.removeAll();
    setNextRefreshTime(getNextRefreshTime().add(getRefreshQueryInterval()));
    int count = 0;
    try(TableCursor c = result.cursor())
    {
      while(c.next())
      {
        count = count + 1;
        myComps.add((BComponent) c.get());
      }
    }
    catch(Exception e)
    {
      System.out.println(getSlotPath() + " - error trying to refresh the query");
      System.out.println(e);
    }

    setNumberOfPoints(count);
  }

  ////////////////////////////////
  // local variables
  ////////////////////////////////

  BComponent zoneExt = null;
  MySub sub = null;

}
