package com.vykon.vykonPro.hvac;

import javax.baja.sys.BComplex;
import javax.baja.sys.BComponent;
import javax.baja.sys.BValue;
import javax.baja.sys.Context;
import javax.baja.sys.Property;
import javax.baja.sys.Sys;
import javax.baja.sys.Type;
import javax.baja.nre.util.TextUtil;

public class BRotationOrder
    extends BComponent
{
  /*-
   class BRotationOrder
   {
     properties
     {
       order: String
         default{[ "" ]}
     }
     actions
     {
     }
     topics
     {
     }
   }
   -*/
/*+ ------------ BEGIN BAJA AUTO GENERATED CODE ------------ +*/
/*@ $com.vykon.vykonPro.hvac.BRotationOrder(3301213309)1.0$ @*/
/* Generated Wed Apr 25 15:47:30 EDT 2012 by Slot-o-Matic 2000 (c) Tridium, Inc. 2000 */

////////////////////////////////////////////////////////////////
// Property "order"
////////////////////////////////////////////////////////////////
  
  /**
   * Slot for the <code>order</code> property.
   * @see com.vykon.vykonPro.hvac.BRotationOrder#getOrder
   * @see com.vykon.vykonPro.hvac.BRotationOrder#setOrder
   */
  public static final Property order = newProperty(0, "",null);
  
  /**
   * Get the <code>order</code> property.
   * @see com.vykon.vykonPro.hvac.BRotationOrder#order
   */
  public String getOrder() { return getString(order); }
  
  /**
   * Set the <code>order</code> property.
   * @see com.vykon.vykonPro.hvac.BRotationOrder#order
   */
  public void setOrder(String v) { setString(order,v,null); }

////////////////////////////////////////////////////////////////
// Type
////////////////////////////////////////////////////////////////
  
  public Type getType() { return TYPE; }
  public static final Type TYPE = Sys.loadType(BRotationOrder.class);

/*+ ------------ END BAJA AUTO GENERATED CODE -------------- +*/

  
  public void changed(Property p, Context cx)
  {
    super.changed(p, cx);
    if (!Sys.atSteadyState() || !isRunning())
      return;
    
    if(p==order)
    {
      BComplex parent = this.getParent();
      if(parent instanceof BRotationalLoadSequencer)
      {
        BRotationalLoadSequencer rls = (BRotationalLoadSequencer)parent;
        rls.checkNext();
      }
    }
    
    
  }
  
  public boolean isChildLegal (BComponent child) 
  {
    return child.getName().startsWith("out");
  }
  
  public void reordered (Context cx)
  {
    Property[] props = this.getDynamicPropertiesArray();
    StringBuffer sb = new StringBuffer();
    String name= "";
    boolean first = true;
    
    for(int i=0; i<props.length; i++)
    {
      name = props[i].getName();
      if(name.startsWith("out"))
      {
        if(first) first = false;
        else sb.append(',');
        sb.append(name.substring(name.length()-1));
      }
    }
    
    setOrder(sb.toString());
  }
  
  public void added ( Property property, Context context)
  {
    //super.added(property, context);
    
    String name = property.getName();
    if(name.startsWith("out"))
    {
      String tag = name.substring(name.length()-1);
      String current = getOrder();
      if(current.length()>0 && current.indexOf(tag)<0)
      {
        setOrder(getOrder() + "," + tag);
      }
      else if(current.indexOf(tag)<0)
      {
        setOrder(tag);
      }
    }
  }
  
  public void removed ( Property property, BValue oldValue, Context context)
  {
    String name = property.getName();
    if(name.startsWith("out"))
    {
      String tag = name.substring(name.length()-1);
      String current = getOrder();

      String[] outs = TextUtil.splitAndTrim(current, ',');

      StringBuffer sb = new StringBuffer();
      boolean first = true;
      
      for(int i=0; i<outs.length; i++)
      {
        if(!tag.equals(outs[i]))
        {
          if (first) first = false;
          else sb.append(",");
          sb.append(outs[i]);
        }
      }
      setOrder(sb.toString());
    }
  }

}
