package com.vykon.vykonPro.hvac;

import javax.baja.naming.BOrd;
import javax.baja.status.BStatusNumeric;
import javax.baja.sys.BComponent;
import javax.baja.sys.BFacets;
import javax.baja.sys.Flags;
import javax.baja.sys.Property;
import javax.baja.sys.Slot;
import javax.baja.sys.Sys;
import javax.baja.sys.Type;

public class BZoneInfo
    extends BComponent
{
  /*-
   class BZoneInfo
   {
     properties
     {
       zoneId: String
         default{[ "" ]}
         flags{ readonly }

       out: BStatusNumeric
         default{[ new BStatusNumeric() ]}
         flags{ readonly }

       ord: BOrd
         default{[ BOrd.NULL ]}
         flags{ readonly }

       facets:BFacets
         -- facets applied to the avg, min and max slots
         default{[ BFacets.NULL ]}
     }
     actions
     {
     }
     topics
     {
     }
   }
   -*/
/*+ ------------ BEGIN BAJA AUTO GENERATED CODE ------------ +*/
/*@ $com.vykon.vykonPro.hvac.BZoneInfo(2162103981)1.0$ @*/
/* Generated Fri Oct 26 16:09:59 EDT 2012 by Slot-o-Matic 2000 (c) Tridium, Inc. 2000 */

////////////////////////////////////////////////////////////////
// Property "zoneId"
////////////////////////////////////////////////////////////////

  /**
   * Slot for the <code>zoneId</code> property.
   * @see com.vykon.vykonPro.hvac.BZoneInfo#getZoneId
   * @see com.vykon.vykonPro.hvac.BZoneInfo#setZoneId
   */
  public static final Property zoneId = newProperty(Flags.READONLY, "",null);

  /**
   * Get the <code>zoneId</code> property.
   * @see com.vykon.vykonPro.hvac.BZoneInfo#zoneId
   */
  public String getZoneId() { return getString(zoneId); }

  /**
   * Set the <code>zoneId</code> property.
   * @see com.vykon.vykonPro.hvac.BZoneInfo#zoneId
   */
  public void setZoneId(String v) { setString(zoneId,v,null); }

////////////////////////////////////////////////////////////////
// Property "out"
////////////////////////////////////////////////////////////////

  /**
   * Slot for the <code>out</code> property.
   * @see com.vykon.vykonPro.hvac.BZoneInfo#getOut
   * @see com.vykon.vykonPro.hvac.BZoneInfo#setOut
   */
  public static final Property out = newProperty(Flags.READONLY, new BStatusNumeric(),null);

  /**
   * Get the <code>out</code> property.
   * @see com.vykon.vykonPro.hvac.BZoneInfo#out
   */
  public BStatusNumeric getOut() { return (BStatusNumeric)get(out); }

  /**
   * Set the <code>out</code> property.
   * @see com.vykon.vykonPro.hvac.BZoneInfo#out
   */
  public void setOut(BStatusNumeric v) { set(out,v,null); }

////////////////////////////////////////////////////////////////
// Property "ord"
////////////////////////////////////////////////////////////////

  /**
   * Slot for the <code>ord</code> property.
   * @see com.vykon.vykonPro.hvac.BZoneInfo#getOrd
   * @see com.vykon.vykonPro.hvac.BZoneInfo#setOrd
   */
  public static final Property ord = newProperty(Flags.READONLY, BOrd.NULL,null);

  /**
   * Get the <code>ord</code> property.
   * @see com.vykon.vykonPro.hvac.BZoneInfo#ord
   */
  public BOrd getOrd() { return (BOrd)get(ord); }

  /**
   * Set the <code>ord</code> property.
   * @see com.vykon.vykonPro.hvac.BZoneInfo#ord
   */
  public void setOrd(BOrd v) { set(ord,v,null); }

////////////////////////////////////////////////////////////////
// Property "facets"
////////////////////////////////////////////////////////////////

  /**
   * Slot for the <code>facets</code> property.
   * facets applied to the avg, min and max slots
   * @see com.vykon.vykonPro.hvac.BZoneInfo#getFacets
   * @see com.vykon.vykonPro.hvac.BZoneInfo#setFacets
   */
  public static final Property facets = newProperty(0, BFacets.NULL,null);

  /**
   * Get the <code>facets</code> property.
   * @see com.vykon.vykonPro.hvac.BZoneInfo#facets
   */
  public BFacets getFacets() { return (BFacets)get(facets); }

  /**
   * Set the <code>facets</code> property.
   * @see com.vykon.vykonPro.hvac.BZoneInfo#facets
   */
  public void setFacets(BFacets v) { set(facets,v,null); }

////////////////////////////////////////////////////////////////
// Type
////////////////////////////////////////////////////////////////

  public Type getType() { return TYPE; }
  public static final Type TYPE = Sys.loadType(BZoneInfo.class);

/*+ ------------ END BAJA AUTO GENERATED CODE -------------- +*/

  public BZoneInfo()
  {

  }

  public BZoneInfo(String id,BStatusNumeric out,BOrd ord)
  {
    setZoneId(id);
    setOut(out);
    setOrd(ord);
  }

  public BZoneInfo(String id,BStatusNumeric out,BOrd ord,BFacets f)
  {
    setZoneId(id);
    setOut(out);
    setOrd(ord);
    setFacets(f);
  }

  public boolean isChildLegal(BComponent child)
  {
    return false;
  }

  public boolean isParentLegal(BComponent parent)
  {
    return (parent instanceof BZoneListExt);
  }

  public BFacets getSlotFacets(Slot slot)
  {
      if (slot.equals(out)) return getFacets();
      return super.getSlotFacets(slot);
  }

}
