package com.vykon.vykonPro.hvac;

import javax.baja.naming.BOrd;
import javax.baja.sys.BComponent;
import javax.baja.sys.BFacets;
import javax.baja.sys.BIcon;
import javax.baja.sys.Flags;
import javax.baja.sys.Property;
import javax.baja.sys.Sys;
import javax.baja.sys.Type;

public class BZoneListExt
    extends BComponent
{
  /*-
   class BZoneListExt
   {
     properties
     {
       out: String
         -- String property which displays the number of out of range zones and the total
         -- number of zones being monitored by the parent component.
         default{[ "" ]}
         flags{ readonly, transient }
         
       linkOrd: BOrd
         default{[ BOrd.NULL ]}
         flags{ readonly, transient, hidden }
         
       hyperlink: BOrd
         -- relative ord applied to component base ord when hyperlinking from the table view
         default{[ BOrd.make("slot:") ]}
         flags{ operator, defaultOnClone }
         
     }
     actions
     {
     }
     topics
     {
     }
   }
   -*/
/*+ ------------ BEGIN BAJA AUTO GENERATED CODE ------------ +*/
/*@ $com.vykon.vykonPro.hvac.BZoneListExt(1843530144)1.0$ @*/
/* Generated Mon Mar 28 13:22:53 EDT 2011 by Slot-o-Matic 2000 (c) Tridium, Inc. 2000 */

////////////////////////////////////////////////////////////////
// Property "out"
////////////////////////////////////////////////////////////////
  
  /**
   * Slot for the <code>out</code> property.
   * String property which displays the number of out of
   * range zones and the total number of zones being monitored
   * by the parent component.
   * @see com.vykon.vykonPro.hvac.BZoneListExt#getOut
   * @see com.vykon.vykonPro.hvac.BZoneListExt#setOut
   */
  public static final Property out = newProperty(Flags.READONLY|Flags.TRANSIENT, "",null);
  
  /**
   * Get the <code>out</code> property.
   * @see com.vykon.vykonPro.hvac.BZoneListExt#out
   */
  public String getOut() { return getString(out); }
  
  /**
   * Set the <code>out</code> property.
   * @see com.vykon.vykonPro.hvac.BZoneListExt#out
   */
  public void setOut(String v) { setString(out,v,null); }

////////////////////////////////////////////////////////////////
// Property "linkOrd"
////////////////////////////////////////////////////////////////
  
  /**
   * Slot for the <code>linkOrd</code> property.
   * @see com.vykon.vykonPro.hvac.BZoneListExt#getLinkOrd
   * @see com.vykon.vykonPro.hvac.BZoneListExt#setLinkOrd
   */
  public static final Property linkOrd = newProperty(Flags.READONLY|Flags.TRANSIENT|Flags.HIDDEN, BOrd.NULL,null);
  
  /**
   * Get the <code>linkOrd</code> property.
   * @see com.vykon.vykonPro.hvac.BZoneListExt#linkOrd
   */
  public BOrd getLinkOrd() { return (BOrd)get(linkOrd); }
  
  /**
   * Set the <code>linkOrd</code> property.
   * @see com.vykon.vykonPro.hvac.BZoneListExt#linkOrd
   */
  public void setLinkOrd(BOrd v) { set(linkOrd,v,null); }

////////////////////////////////////////////////////////////////
// Property "hyperlink"
////////////////////////////////////////////////////////////////
  
  /**
   * Slot for the <code>hyperlink</code> property.
   * relative ord applied to component base ord when hyperlinking
   * from the table view
   * @see com.vykon.vykonPro.hvac.BZoneListExt#getHyperlink
   * @see com.vykon.vykonPro.hvac.BZoneListExt#setHyperlink
   */
  public static final Property hyperlink = newProperty(Flags.OPERATOR|Flags.DEFAULT_ON_CLONE, BOrd.make("slot:"),null);
  
  /**
   * Get the <code>hyperlink</code> property.
   * @see com.vykon.vykonPro.hvac.BZoneListExt#hyperlink
   */
  public BOrd getHyperlink() { return (BOrd)get(hyperlink); }
  
  /**
   * Set the <code>hyperlink</code> property.
   * @see com.vykon.vykonPro.hvac.BZoneListExt#hyperlink
   */
  public void setHyperlink(BOrd v) { set(hyperlink,v,null); }

////////////////////////////////////////////////////////////////
// Type
////////////////////////////////////////////////////////////////
  
  public Type getType() { return TYPE; }
  public static final Type TYPE = Sys.loadType(BZoneListExt.class);

/*+ ------------ END BAJA AUTO GENERATED CODE -------------- +*/

  public void started()
  {
    setLinkOrd(this.getSlotPathOrd());
  }

  public boolean isChildLegal(BComponent child) 
  {
    return (child instanceof BZoneInfo); 
  }
  
  public BFacets loadFacets()
  {
    BMinMaxAvgBqlWithLimits parent = (BMinMaxAvgBqlWithLimits) this.getParent().getParentComponent();
    return parent.getFacets();
  }

  /**
   * Get the icon.
   */
  public BIcon getIcon()
  {
    return icon;
  }

  private static final BIcon icon = BIcon.std("site.png");

}
