package com.vykon.vykonPro.timer;

import javax.baja.sys.Action;
import javax.baja.sys.BBoolean;
import javax.baja.sys.BComponent;
import javax.baja.sys.BFacets;
import javax.baja.sys.BIcon;
import javax.baja.sys.BRelTime;
import javax.baja.sys.Flags;
import javax.baja.sys.Property;
import javax.baja.sys.Slot;
import javax.baja.sys.Sys;
import javax.baja.sys.Type;

public class BRelTimeCommand
    extends BComponent
{
  /*-
   class BRelTimeCommand
   {
     properties
     {
       outTime:BRelTime
         flags{ readonly, summary }
         default{[ BRelTime.makeSeconds(10) ]}
       
       Facets: BFacets
        -- These facets are applied against the outTime property.
        default {[ BFacets.make(BFacets.SHOW_MILLISECONDS, BBoolean.make(false)) ]}
      
     }
     actions
     {
       changeTime(time:BRelTime)
         default{[ BRelTime.makeSeconds(10) ]}
     }
     topics
     {
     }
   }
   -*/
/*+ ------------ BEGIN BAJA AUTO GENERATED CODE ------------ +*/
/*@ $com.vykon.vykonPro.timer.BRelTimeCommand(2109438356)1.0$ @*/
/* Generated Tue Mar 16 16:03:16 EDT 2010 by Slot-o-Matic 2000 (c) Tridium, Inc. 2000 */

////////////////////////////////////////////////////////////////
// Property "outTime"
////////////////////////////////////////////////////////////////
  
  /**
   * Slot for the <code>outTime</code> property.
   * @see com.vykon.vykonPro.timer.BRelTimeCommand#getOutTime
   * @see com.vykon.vykonPro.timer.BRelTimeCommand#setOutTime
   */
  public static final Property outTime = newProperty(Flags.READONLY|Flags.SUMMARY, BRelTime.makeSeconds(10),null);
  
  /**
   * Get the <code>outTime</code> property.
   * @see com.vykon.vykonPro.timer.BRelTimeCommand#outTime
   */
  public BRelTime getOutTime() { return (BRelTime)get(outTime); }
  
  /**
   * Set the <code>outTime</code> property.
   * @see com.vykon.vykonPro.timer.BRelTimeCommand#outTime
   */
  public void setOutTime(BRelTime v) { set(outTime,v,null); }

////////////////////////////////////////////////////////////////
// Property "Facets"
////////////////////////////////////////////////////////////////
  
  /**
   * Slot for the <code>Facets</code> property.
   * These facets are applied against the outTime property.
   * @see com.vykon.vykonPro.timer.BRelTimeCommand#getFacets
   * @see com.vykon.vykonPro.timer.BRelTimeCommand#setFacets
   */
  public static final Property Facets = newProperty(0, BFacets.make(BFacets.SHOW_MILLISECONDS, BBoolean.make(false)),null);
  
  /**
   * Get the <code>Facets</code> property.
   * @see com.vykon.vykonPro.timer.BRelTimeCommand#Facets
   */
  public BFacets getFacets() { return (BFacets)get(Facets); }
  
  /**
   * Set the <code>Facets</code> property.
   * @see com.vykon.vykonPro.timer.BRelTimeCommand#Facets
   */
  public void setFacets(BFacets v) { set(Facets,v,null); }

////////////////////////////////////////////////////////////////
// Action "changeTime"
////////////////////////////////////////////////////////////////
  
  /**
   * Slot for the <code>changeTime</code> action.
   * @see com.vykon.vykonPro.timer.BRelTimeCommand#changeTime()
   */
  public static final Action changeTime = newAction(0,BRelTime.makeSeconds(10),null);
  
  /**
   * Invoke the <code>changeTime</code> action.
   * @see com.vykon.vykonPro.timer.BRelTimeCommand#changeTime
   */
  public void changeTime(BRelTime time) { invoke(changeTime,time,null); }

////////////////////////////////////////////////////////////////
// Type
////////////////////////////////////////////////////////////////
  
  public Type getType() { return TYPE; }
  public static final Type TYPE = Sys.loadType(BRelTimeCommand.class);

/*+ ------------ END BAJA AUTO GENERATED CODE -------------- +*/


  public BFacets getSlotFacets(Slot slot)
  {
    if (slot.equals(outTime))
      return getFacets();
    return super.getSlotFacets(slot);
  }

  // //////////////////////////////////////////////////////////////
  // Initialization
  // //////////////////////////////////////////////////////////////

  public void doChangeTime(BRelTime time)
  {
    setOutTime(time);
  }

  
  ////////////////////////////////////////////////////////////////
  // Icon
  // //////////////////////////////////////////////////////////////

  /**
   * Get the icon.
   */
  public BIcon getIcon()
  {
    return icon;
  }

  private static final BIcon icon = BIcon.std("clock.png");

  
  ///////////////////////////////////////////////////////
  // local variables
  ///////////////////////////////////////////////////////
  
  
  
}
