package com.vykon.vykonPro.util;

import javax.baja.sys.BBoolean;
import javax.baja.sys.BComponent;
import javax.baja.sys.BFacets;
import javax.baja.sys.Property;
import javax.baja.sys.Sys;
import javax.baja.sys.Type;

public class BBroadcastMessage
    extends BComponent
{
  /*-
   class BBroadcastMessage
   {
     properties
     {
       message: String
         -- The message which will be broadcast to all workbench connections
         default {[ "" ]}
         slotfacets {[ BFacets.make(BFacets.MULTI_LINE, BBoolean.make("true")) ]}
         
       echoMessage: boolean
         -- If true the message will be echoed to the sending user's workbench connection
         default{[ false ]}
         
     }
     actions
     {
     
     }
     topics
     {
     }
   }
   -*/
/*+ ------------ BEGIN BAJA AUTO GENERATED CODE ------------ +*/
/*@ $com.vykon.vykonPro.util.BBroadcastMessage(486542347)1.0$ @*/
/* Generated Wed Feb 24 23:10:29 EST 2010 by Slot-o-Matic 2000 (c) Tridium, Inc. 2000 */

////////////////////////////////////////////////////////////////
// Property "message"
////////////////////////////////////////////////////////////////
  
  /**
   * Slot for the <code>message</code> property.
   * The message which will be broadcast to all workbench
   * connections
   * @see com.vykon.vykonPro.util.BBroadcastMessage#getMessage
   * @see com.vykon.vykonPro.util.BBroadcastMessage#setMessage
   */
  public static final Property message = newProperty(0, "",BFacets.make(BFacets.MULTI_LINE, BBoolean.make("true")));
  
  /**
   * Get the <code>message</code> property.
   * @see com.vykon.vykonPro.util.BBroadcastMessage#message
   */
  public String getMessage() { return getString(message); }
  
  /**
   * Set the <code>message</code> property.
   * @see com.vykon.vykonPro.util.BBroadcastMessage#message
   */
  public void setMessage(String v) { setString(message,v,null); }

////////////////////////////////////////////////////////////////
// Property "echoMessage"
////////////////////////////////////////////////////////////////
  
  /**
   * Slot for the <code>echoMessage</code> property.
   * If true the message will be echoed to the sending user's workbench connection
   * @see com.vykon.vykonPro.util.BBroadcastMessage#getEchoMessage
   * @see com.vykon.vykonPro.util.BBroadcastMessage#setEchoMessage
   */
  public static final Property echoMessage = newProperty(0, false,null);
  
  /**
   * Get the <code>echoMessage</code> property.
   * @see com.vykon.vykonPro.util.BBroadcastMessage#echoMessage
   */
  public boolean getEchoMessage() { return getBoolean(echoMessage); }
  
  /**
   * Set the <code>echoMessage</code> property.
   * @see com.vykon.vykonPro.util.BBroadcastMessage#echoMessage
   */
  public void setEchoMessage(boolean v) { setBoolean(echoMessage,v,null); }

////////////////////////////////////////////////////////////////
// Type
////////////////////////////////////////////////////////////////
  
  public Type getType() { return TYPE; }
  public static final Type TYPE = Sys.loadType(BBroadcastMessage.class);

/*+ ------------ END BAJA AUTO GENERATED CODE -------------- +*/


    
}
