package com.vykon.vykonPro.util;

import javax.baja.sys.BStruct;
import javax.baja.sys.Property;
import javax.baja.sys.Sys;
import javax.baja.sys.Type;

public class BRuntimeItem
    extends BStruct
{
  /*-
   class BRuntimeItem
   {
     properties
     {
       outSlot:int
       -- The original outX slot identifier.
        default{[ 0 ]}
        
       runtime:long
       -- The accumulated runtime for the load.
        default{[ 0 ]}
     }
     
   }
   -*/
/*+ ------------ BEGIN BAJA AUTO GENERATED CODE ------------ +*/
/*@ $com.vykon.vykonPro.util.BRuntimeItem(586802983)1.0$ @*/
/* Generated Wed Mar 11 14:26:10 ACT 2009 by Slot-o-Matic 2000 (c) Tridium, Inc. 2000 */

////////////////////////////////////////////////////////////////
// Property "outSlot"
////////////////////////////////////////////////////////////////
  
  /**
   * Slot for the <code>outSlot</code> property.
   * The original outX slot identifier.
   * @see com.vykon.vykonPro.util.BRuntimeItem#getOutSlot
   * @see com.vykon.vykonPro.util.BRuntimeItem#setOutSlot
   */
  public static final Property outSlot = newProperty(0, 0,null);
  
  /**
   * Get the <code>outSlot</code> property.
   * @see com.vykon.vykonPro.util.BRuntimeItem#outSlot
   */
  public int getOutSlot() { return getInt(outSlot); }
  
  /**
   * Set the <code>outSlot</code> property.
   * @see com.vykon.vykonPro.util.BRuntimeItem#outSlot
   */
  public void setOutSlot(int v) { setInt(outSlot,v,null); }

////////////////////////////////////////////////////////////////
// Property "runtime"
////////////////////////////////////////////////////////////////
  
  /**
   * Slot for the <code>runtime</code> property.
   * The accumulated runtime for the load.
   * @see com.vykon.vykonPro.util.BRuntimeItem#getRuntime
   * @see com.vykon.vykonPro.util.BRuntimeItem#setRuntime
   */
  public static final Property runtime = newProperty(0, 0,null);
  
  /**
   * Get the <code>runtime</code> property.
   * @see com.vykon.vykonPro.util.BRuntimeItem#runtime
   */
  public long getRuntime() { return getLong(runtime); }
  
  /**
   * Set the <code>runtime</code> property.
   * @see com.vykon.vykonPro.util.BRuntimeItem#runtime
   */
  public void setRuntime(long v) { setLong(runtime,v,null); }

////////////////////////////////////////////////////////////////
// Type
////////////////////////////////////////////////////////////////
  
  public Type getType() { return TYPE; }
  public static final Type TYPE = Sys.loadType(BRuntimeItem.class);

/*+ ------------ END BAJA AUTO GENERATED CODE -------------- +*/

  public BRuntimeItem()
  {
    
  }
  
  public BRuntimeItem(int outSlot, long runtime)
  {
    setOutSlot(outSlot);
    setRuntime(runtime);
  }

}
