package com.vykon.vykonPro.util;

import javax.baja.sys.BBoolean;
import javax.baja.sys.BComponent;
import javax.baja.sys.BDynamicEnum;
import javax.baja.sys.BFacets;
import javax.baja.sys.Property;
import javax.baja.sys.Sys;
import javax.baja.sys.Type;

public class BSingleCastMessage
    extends BComponent
{
  /*-
   class BSingleCastMessage
   {
     properties
     {
       user: BDynamicEnum
         -- The user's name to send the message to
         default{[ BDynamicEnum.make(0) ]}
         
       message: String
         -- The message which will be broadcast to all workbench connections
         default {[ "" ]}
         slotfacets {[ BFacets.make(BFacets.MULTI_LINE, BBoolean.make("true")) ]} 
      
       echoMessage: boolean
         -- If true the message will be echoed to the sending user's workbench connection
         default{[ false ]}
         
     }
   }
   -*/
/*+ ------------ BEGIN BAJA AUTO GENERATED CODE ------------ +*/
/*@ $com.vykon.vykonPro.util.BSingleCastMessage(135734288)1.0$ @*/
/* Generated Wed Feb 24 23:10:29 EST 2010 by Slot-o-Matic 2000 (c) Tridium, Inc. 2000 */

////////////////////////////////////////////////////////////////
// Property "user"
////////////////////////////////////////////////////////////////
  
  /**
   * Slot for the <code>user</code> property.
   * The user's name to send the message to
   * @see com.vykon.vykonPro.util.BSingleCastMessage#getUser
   * @see com.vykon.vykonPro.util.BSingleCastMessage#setUser
   */
  public static final Property user = newProperty(0, BDynamicEnum.make(0),null);
  
  /**
   * Get the <code>user</code> property.
   * @see com.vykon.vykonPro.util.BSingleCastMessage#user
   */
  public BDynamicEnum getUser() { return (BDynamicEnum)get(user); }
  
  /**
   * Set the <code>user</code> property.
   * @see com.vykon.vykonPro.util.BSingleCastMessage#user
   */
  public void setUser(BDynamicEnum v) { set(user,v,null); }

////////////////////////////////////////////////////////////////
// Property "message"
////////////////////////////////////////////////////////////////
  
  /**
   * Slot for the <code>message</code> property.
   * The message which will be broadcast to all workbench
   * connections
   * @see com.vykon.vykonPro.util.BSingleCastMessage#getMessage
   * @see com.vykon.vykonPro.util.BSingleCastMessage#setMessage
   */
  public static final Property message = newProperty(0, "",BFacets.make(BFacets.MULTI_LINE, BBoolean.make("true")));
  
  /**
   * Get the <code>message</code> property.
   * @see com.vykon.vykonPro.util.BSingleCastMessage#message
   */
  public String getMessage() { return getString(message); }
  
  /**
   * Set the <code>message</code> property.
   * @see com.vykon.vykonPro.util.BSingleCastMessage#message
   */
  public void setMessage(String v) { setString(message,v,null); }

////////////////////////////////////////////////////////////////
// Property "echoMessage"
////////////////////////////////////////////////////////////////
  
  /**
   * Slot for the <code>echoMessage</code> property.
   * If true the message will be echoed to the sending user's workbench connection
   * @see com.vykon.vykonPro.util.BSingleCastMessage#getEchoMessage
   * @see com.vykon.vykonPro.util.BSingleCastMessage#setEchoMessage
   */
  public static final Property echoMessage = newProperty(0, false,null);
  
  /**
   * Get the <code>echoMessage</code> property.
   * @see com.vykon.vykonPro.util.BSingleCastMessage#echoMessage
   */
  public boolean getEchoMessage() { return getBoolean(echoMessage); }
  
  /**
   * Set the <code>echoMessage</code> property.
   * @see com.vykon.vykonPro.util.BSingleCastMessage#echoMessage
   */
  public void setEchoMessage(boolean v) { setBoolean(echoMessage,v,null); }

////////////////////////////////////////////////////////////////
// Type
////////////////////////////////////////////////////////////////
  
  public Type getType() { return TYPE; }
  public static final Type TYPE = Sys.loadType(BSingleCastMessage.class);

/*+ ------------ END BAJA AUTO GENERATED CODE -------------- +*/

  public BSingleCastMessage()
  {
    
  }
  
  public BSingleCastMessage(BDynamicEnum users, String message, boolean echo)
  {
    setUser(users);
    setMessage(message);
    setEchoMessage(echo);
  }
  
  
}
