package com.vykon.vykonProTransform.ui;

import java.util.logging.Level;
import java.util.logging.Logger;

import javax.baja.chart.BChart;
import javax.baja.chart.BChartPane;
import javax.baja.gx.BInsets;
import javax.baja.naming.BOrd;
import javax.baja.naming.SlotPath;
import javax.baja.sys.Action;
import javax.baja.sys.BComponent;
import javax.baja.sys.BObject;
import javax.baja.sys.BValue;
import javax.baja.sys.Context;
import javax.baja.sys.Flags;
import javax.baja.sys.Property;
import javax.baja.sys.Slot;
import javax.baja.sys.Sys;
import javax.baja.sys.Type;
import javax.baja.ui.BBinding;
import javax.baja.ui.BNullWidget;
import javax.baja.ui.BWidget;
import javax.baja.ui.pane.BBorderPane;
import javax.baja.ui.pane.BEdgePane;
import javax.baja.ui.pane.BGridPane;
import javax.baja.ui.table.binding.BBoundTable;
import javax.baja.nre.util.Array;
import javax.baja.util.Lexicon;
import javax.baja.workbench.BWbPlugin;
import javax.baja.workbench.BWbShell;
import javax.baja.workbench.fieldeditor.BWbFieldEditor;

import com.tridium.bql.util.BDynamicTimeRange;
import com.tridium.seriestransform.BTransformQuery;
import com.tridium.seriestransform.NQueryParameters;
import com.tridium.seriestransform.binding.ui.BTransformChartBindingCollection;
import com.tridium.seriestransform.binding.ui.BTransformTableBinding;
import com.tridium.seriestransform.graph.BTransformGraph;
import com.tridium.seriestransform.graph.ParameterSlot;


public class BTransformChartPane
    extends BEdgePane
{
  /*-
   class BTransformChartPane
   {
     properties
     {
       defaultTimeRange:BDynamicTimeRange
        default{[ BDynamicTimeRange.TODAY ]}
     }
     actions
     {
       fieldEditorModified()
     }
     topics
     {
     }
   }
   -*/
/*+ ------------ BEGIN BAJA AUTO GENERATED CODE ------------ +*/
/*@ $com.vykon.vykonProTransform.ui.BTransformChartPane(1055450227)1.0$ @*/
/* Generated Sat Jul 25 21:36:16 EDT 2015 by Slot-o-Matic 2000 (c) Tridium, Inc. 2000 */

////////////////////////////////////////////////////////////////
// Property "defaultTimeRange"
////////////////////////////////////////////////////////////////
  
  /**
   * Slot for the <code>defaultTimeRange</code> property.
   * @see com.vykon.vykonProTransform.ui.BTransformChartPane#getDefaultTimeRange
   * @see com.vykon.vykonProTransform.ui.BTransformChartPane#setDefaultTimeRange
   */
  public static final Property defaultTimeRange = newProperty(0, BDynamicTimeRange.TODAY,null);
  
  /**
   * Get the <code>defaultTimeRange</code> property.
   * @see com.vykon.vykonProTransform.ui.BTransformChartPane#defaultTimeRange
   */
  public BDynamicTimeRange getDefaultTimeRange() { return (BDynamicTimeRange)get(defaultTimeRange); }
  
  /**
   * Set the <code>defaultTimeRange</code> property.
   * @see com.vykon.vykonProTransform.ui.BTransformChartPane#defaultTimeRange
   */
  public void setDefaultTimeRange(BDynamicTimeRange v) { set(defaultTimeRange,v,null); }

////////////////////////////////////////////////////////////////
// Action "fieldEditorModified"
////////////////////////////////////////////////////////////////
  
  /**
   * Slot for the <code>fieldEditorModified</code> action.
   * @see com.vykon.vykonProTransform.ui.BTransformChartPane#fieldEditorModified()
   */
  public static final Action fieldEditorModified = newAction(0,null);
  
  /**
   * Invoke the <code>fieldEditorModified</code> action.
   * @see com.vykon.vykonProTransform.ui.BTransformChartPane#fieldEditorModified
   */
  public void fieldEditorModified() { invoke(fieldEditorModified,null,null); }

////////////////////////////////////////////////////////////////
// Type
////////////////////////////////////////////////////////////////
  
  public Type getType() { return TYPE; }
  public static final Type TYPE = Sys.loadType(BTransformChartPane.class);

/*+ ------------ END BAJA AUTO GENERATED CODE -------------- +*/

  public BTransformChartPane()
  {
    this.setFlags(this.getSlot("right"), Flags.HIDDEN);
    this.setFlags(this.getSlot("left"), Flags.HIDDEN);
  }
  
  public String getDisplayName(Slot slot, Context cx)
  {
    if(slot.equals(top)) return "ToolBar";
    else if(slot.equals(center)) return "Charts";
    else if(slot.equals(bottom)) return "Table";
    return super.getDisplayName(slot, cx);
  }
  
  public void started() throws Exception
  {
    BGridPane pane = new BGridPane();
    fe = BWbFieldEditor.makeFor(BDynamicTimeRange.TODAY); 
    range = getDefaultTimeRange();
    fe.loadValue(range); 
    
    // Create a link to signal when the field editor action is performed
    linkTo("link0", fe, BWbFieldEditor.setModified, fieldEditorModified);

    BInsets insets = BInsets.make(4, 2, 4, 2);
    pane.add(null, new BBorderPane(fe, insets));
    setTop(pane);
    
    BWbShell shell = (BWbShell) getShell();
    if (shell != null)
    {
      BObject base = shell.getActiveOrdTarget().get();
      BTransformChartBindingCollection[] bindings = findBindings();

      for (int i = 0; i < bindings.length; i++)
      {
        if (logger.isLoggable(Level.FINE)) logger.fine("Found this binding: " + bindings[0].getOrd());

        BTransformQuery query = bindings[0].getQuery();
        BOrd graphOrd = query.getGraphOrd();
        String queryParams = "";
        if (graphOrd == null || graphOrd == BOrd.NULL) return;

        BTransformGraph graph = (BTransformGraph) graphOrd.resolve(base).get();
        graph.lease(3);
        ParameterSlot[] paramSlots = graph.getParameterSlots();
        for (int k = 0; k < paramSlots.length; k++)
        {
          ParameterSlot param = paramSlots[k];
          SlotPath path = param.getSlotPath();
          SlotPath parent = path.getParent();
          String[] pathNames = path.getNames();
          String property = pathNames[pathNames.length - 1];

          // retrieve our parent component
          BOrd paramOrd = BOrd.make(graph.getAbsoluteOrd(), parent);
          BObject object = paramOrd.get(graph);
          if (null != object && object instanceof BComponent)
          {
            // get our property from the BComplex
            BComponent complex = (BComponent) object;
            complex.lease();
            Property p = complex.getProperty(property);
            BValue defaultValue = complex.get(p);

            if (defaultValue instanceof BDynamicTimeRange)
            {
              queryParams = queryParams + "?" + path.getBody() + "=" + range.encodeToString();
            }
          }
        }
        
        query.setQueryParams(queryParams);
      }
      
      
      BBoundTable table = getBoundTable(this.getBottom());
      if(table!=null)
      {
        BTransformTableBinding[] tableBindings = findTableBindings();
        if(tableBindings.length>0)
        {
          for(int i=0; i<tableBindings.length; i++)
          {
            BTransformQuery query = tableBindings[0].getQuery();
            BOrd graphOrd = query.getGraphOrd();
            String queryParams = "";
            if(graphOrd == null || graphOrd == BOrd.NULL) return;
            
            BTransformGraph graph = (BTransformGraph) graphOrd.resolve(base).get();
            graph.lease(3);
            
            ParameterSlot[] paramSlots = graph.getParameterSlots();
            
            for (int k = 0; k < paramSlots.length; k++)
            {
              ParameterSlot param = paramSlots[k];
              SlotPath path = param.getSlotPath();
              SlotPath parent = path.getParent();
              String[] pathNames = path.getNames();
              String property = pathNames[pathNames.length - 1];

              // retrieve our parent component
              BOrd paramOrd = BOrd.make(graph.getAbsoluteOrd(), parent);
              BObject object = paramOrd.get(graph);
              if (null != object && object instanceof BComponent)
              {
                // get our property from the BComplex
                BComponent complex = (BComponent) object;
                complex.lease();
                Property p = complex.getProperty(property);
                BValue defaultValue = complex.get(p);

                if (defaultValue instanceof BDynamicTimeRange)
                {
                  queryParams = queryParams + "?" + path.getBody() + "=" + range.encodeToString();
                }
              }
            }
            
            query.setQueryParams(queryParams);
          }
        }
        
        BBoundTable newTable = new BBoundTable();
        for(int i=0; i<tableBindings.length; i++)
        {
          newTable.add(null, (BTransformTableBinding)tableBindings[i].newCopy());
        }
        newTable.setLayout(table.getLayout());
        BWidget parentWidget = table.getParentWidget();
        if(parentWidget!=null) 
        {
          parentWidget.set(table.getName(), newTable);
        }
      }
    }
  }

  public void stopped()
  {
    setTop(new BNullWidget());
  }
  
////////////////////////////////////////////////////////////////
//Action handlers
////////////////////////////////////////////////////////////////

  /**
   * Called when the field editor is modified
   */
  public void doFieldEditorModified()
  {
    saveChart(isViewModified());
  }
  
  
/////////////////////////////////////////////////////////////////
// helper methods
/////////////////////////////////////////////////////////////////
  
  /**
   * Find transform chart bindings
   */
  private BTransformChartBindingCollection[] findBindings()
  {
    // Find all the other widgets present and update their bindings        
    Array a = new Array(BTransformChartBindingCollection.class);
    
    // Find an array of table chart bindings
    findTransformChartBindings((BWidget)getParent(), a);
    
    return (BTransformChartBindingCollection[])a.trim();
  }
  
  /**
   * Recursively find a list of all the transform chart bindings
   */
  private void findTransformChartBindings(BWidget w, Array a)
  {
    BWidget[] kids = w.getChildren(BWidget.class);
    
    BBinding[] bindings = null;
    
    for(int i=0; i < kids.length; ++i)
    {
      bindings = kids[i].getBindings();
      
      for(int x=0; x < bindings.length; ++x)
      {
        if (bindings[x] instanceof BTransformChartBindingCollection)
          a.add(bindings[x]);  
      }
      
      findTransformChartBindings(kids[i], a);
    }
  }
  
  
  /**
   * Find transform table bindings
   */
  private BTransformTableBinding[] findTableBindings()
  {
    // Find all the other widgets present and update their bindings        
    Array a = new Array(BTransformTableBinding.class);
    
    // Find an array of table chart bindings
    findTransformTableBindings(this, a);
    
    return (BTransformTableBinding[])a.trim();
  }
  
  /**
   * Recursively find a list of all the transform chart bindings
   */
  private void findTransformTableBindings(BWidget w, Array a)
  {
    BWidget[] kids = w.getChildren(BWidget.class);
    
    BBinding[] bindings = null;
    
    for(int i=0; i < kids.length; ++i)
    {
      bindings = kids[i].getBindings();
      
      for(int x=0; x < bindings.length; ++x)
      {
        if (bindings[x] instanceof BTransformTableBinding)
          a.add(bindings[x]);  
      }
      
      findTransformTableBindings(kids[i], a);
    }
  }
  
  /**
   * find the bound table
   */
  private BBoundTable getBoundTable(BWidget widget) throws Exception
  {
    BBoundTable table = null;
    
    if(widget instanceof BBoundTable) return (BBoundTable)widget;
    
    BWidget[] kids = widget.getChildWidgets();
    for(int i=0; i<kids.length; i++)
    {
      if(kids[i] instanceof BBoundTable)
      {  
        table = (BBoundTable)kids[i];
        return table;
      }
      
      getBoundTable(kids[i]);
    }
    
    return table;
  }
  
  
  /**
   * Return the chart pane
   * @return chart pane
   * @throws Exception
   */
  private BChartPane getChartPane() throws Exception
  {
    BChartPane chartPane = null;
    
    if (getCenter().getType().is(BChartPane.TYPE))
      chartPane = (BChartPane)getCenter();
    else
      throw new Exception("Could not find chart pane!");
    
    return chartPane;
  }
  
  /**
   * Is the view already modified
   * @return modified
   */
  private boolean isViewModified()
  {
    BWbShell shell = BWbShell.getWbShell(this);
    
    if (shell != null)
    {
      BWbPlugin activeView = BWbShell.getWbShell(this).getActiveView();
      return activeView.isModified();
    }
    else
      return false;
  }
  
  private void saveChart(boolean alreadyModified)
  {
    if (fe != null)
    {
      try
      {        
        range = (BDynamicTimeRange) fe.saveValue();
        
        if (logger.isLoggable(Level.FINE)) logger.fine("Got this time range: " + range);
        
        BTransformTableBinding[] tableBindings = findTableBindings();
        BBoundTable table = getBoundTable(this.getBottom());
        
        for(int m=0; m<tableBindings.length; m++)
        {
          BTransformQuery query = tableBindings[m].getQuery();
          BOrd graphOrd = query.getGraphOrd();
          if(graphOrd==null || graphOrd==BOrd.NULL) return;
          
          BWbShell shell = (BWbShell) getShell();
          if (shell != null)
          {
            BObject base = shell.getActiveOrdTarget().get();
            BTransformGraph graph = (BTransformGraph) graphOrd.resolve(base).get();
            graph.lease(3);
            
            NQueryParameters pMap = query.decodeQueryParameters(graph);
            String queryParams = "";
            SlotPath[] paths = pMap.getSlotPaths();
            for(int j=0; j<paths.length; j++)
            {
              queryParams= queryParams + "?" + paths[j].getBody() + "=" + range.encodeToString();
            }
            
            query.setQueryParams(queryParams);
          }
        }
        
        BTransformChartBindingCollection[] bindings = findBindings();
        BChartPane chartPane = getChartPane();
                
        for(int i=0; i < bindings.length; ++i)
        {
          if (logger.isLoggable(Level.FINE)) logger.fine("Found this binding: " + bindings[i].getOrd()); 
          
          BTransformQuery query = bindings[i].getQuery();
          BOrd graphOrd = query.getGraphOrd();
          if(graphOrd==null || graphOrd==BOrd.NULL) return;
          
          BWbShell shell = (BWbShell) getShell();
          if (shell != null)
          {
            BObject base = shell.getActiveOrdTarget().get();
            BTransformGraph graph = (BTransformGraph) graphOrd.resolve(base).get();
            graph.lease(3);
            
            NQueryParameters pMap = query.decodeQueryParameters(graph);
            String queryParams = "";
            SlotPath[] paths = pMap.getSlotPaths();
            for(int j=0; j<paths.length; j++)
            {
              queryParams= queryParams + "?" + paths[j].getBody() + "=" + range.encodeToString();
            }
            
            query.setQueryParams(queryParams);
          }
        } 
        
        if (chartPane != null)
        {
          BChartPane newPane = (BChartPane)chartPane.newCopy();
          setCenter(newPane); 

          // If the view was already modified when we first loaded the widget then don't clear any modifications
          if (alreadyModified)
          {          
            // Clear any modified flags to avoid changed dialog popping up
            BWbPlugin activeView = BWbShell.getWbShell(this).getActiveView();
            activeView.clearModified();  
          }
          
          if (logger.isLoggable(Level.FINE)) logger.fine("Cleared the modified view");
        }
        
        if(table != null)
        {
          BBoundTable newTable = new BBoundTable();
          
          for(int i=0; i<tableBindings.length; i++)
          {
            newTable.add(null, (BTransformTableBinding)tableBindings[i].newCopy());
          }
          
          newTable.setLayout(table.getLayout());
          BWidget parentWidget = table.getParentWidget();
          if(parentWidget!=null)
          {
            parentWidget.set(table.getName(), newTable);
          }
        }
      }
      catch(Exception e)
      {
        if (logger.isLoggable(Level.FINE)) logger.fine("Error attempting to save chart");
		e.printStackTrace();
      }
    } 
  }
  
  
  
  
////////////////////////////////////////////////////////////////
//Fields
////////////////////////////////////////////////////////////////

  private BDynamicTimeRange range = getDefaultTimeRange();
  private BWbFieldEditor fe = null;
  
  public static final Lexicon lex = Lexicon.make(BTransformChartPane.class);
  //private Log log = Log.getLog("transformChartPane"); 
  private static final Logger logger = Logger.getLogger("transformChartPane");
    

}
